// FilerDlg.cpp : implementation file
//


#include "stdafx.h"
#include "Filerx.h"
#include "SciCtrl.h"
#include "inifile.h"
#include "TreeNode.h"
#include "TreeCtrl_proj.h"
#include "ListCtrl.h"
#include "TreeCtrl_file.h"
#include "TreeCtrl_prop.h"
#include "TreeCtrl_mac.h"
#include "TreeCtrl_tlb.h"
#include "FilerDlg.h"
#include "shortcutdlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


#define	hbut 20		//button dim
#define	marg 3		//margins
#define	hcombo 20	//Combo height
#define xstatus (4*hbut+3*marg)
#define hstatus 20

extern char * gMacrobarpath;
extern char * gMyDirectory;
extern CAtom gAtom;
extern bool gLaunchedfirst;
extern HWND gDest;
extern char * gPathtoshow;
extern char * gMyName;

extern CSciCtrl * gScintilla;
extern CImgList * gImgList;
extern bool gPlaying;
extern bool gStepping;
extern bool gTesting;
extern bool gRecording;
extern macro * gCurmac;
extern macro * gMacros;
extern int gKeyhit;


string_to_icon string_to_icon_array[] = {
    { IDS_TOGGLEMODE,		IDI_ICON_TESTMODE},
    { IDS_PLAYMACRO,		IDI_ICON_RUN},
    { IDS_RECORDMACRO,		IDI_ICON_RECORD},
    { IDS_STOPRECORDMACRO,	IDI_ICON_STOP},
    { IDS_HOTKEY,			IDI_ICON_HOTKEY},
	////////////// End of buttons //////////////////////
	{ IDS_CUT ,				IDI_ICON_CUT},
	{ IDS_COPY ,			IDI_ICON_COPY},
	{ IDS_PASTE ,			IDI_ICON_PASTE},
	{ IDS_NEWFOLDER ,		IDI_ICON_NEWFOLDER},
	{ IDS_DELFOLDER ,		IDI_ICON_DELFOLDER},
	{ IDS_NEWPROJ ,			IDI_ICON_NEWPROJECT},
	{ IDS_DELPROJ ,			IDI_ICON_DELPROJECT},
	{ IDS_ADDFILE ,			IDI_ICON_NEWMACROFILE},
	{ IDS_EXPLORER ,		IDI_ICON_EXPLORER},
	{ IDS_REFRESH ,			IDI_ICON_REFRESH},
	{ IDS_DELETE,			IDI_ICON_DELMACRO},
	{ IDS_DELMACRO ,		IDI_ICON_DELMACRO},
	{ IDS_DELMACROFILE ,	IDI_ICON_DELMACROFILE},
	{ IDS_SAVE ,			IDI_ICON_SAVE},
	{ IDS_MSAVE ,			IDI_ICON_SAVE},
	{ IDS_TESTTHISMACRO ,	IDI_ICON_TEST},
	{ IDS_EDIT ,			IDI_ICON_SCITE},
	{ IDS_NEWMACRO ,		IDI_ICON_NEWMACRO},
	{ IDS_MACROBAR ,		IDI_ICON_MACROBAR},
	{ IDS_OPENMACROFILE ,	IDI_ICON_NEWMACROFILE},
	{ IDS_NEWMACROFILE	,	IDI_ICON_NEWMACROFILE},
	{ IDS_WINDOWS_OPEN ,	IDI_ICON_WIN},
	{ IDS_ADDTOINI ,		IDI_ICON_TOINI},
	{ IDS_DUMPCODE ,		IDI_ICON_DUMPCODE},
	{ IDS_TESTMODE ,		IDI_ICON_TESTMODE},
	{ IDS_SORT ,			IDI_ICON_SORT},
	{ IDS_LOADTYPELIB ,		IDI_ICON_TYPELIB},
	{ IDS_DEBUGMACRO ,		IDI_ICON_DEBUGMACRO},
	{ IDS_TEXTBUT ,			IDI_ICON_TEXTBUT},
	{ IDS_ICONBUT ,			IDI_ICON_ICONBUT},
	{ IDS_ONTOP ,			IDI_ICON_ONTOP},
	{ IDS_NOTONTOP ,		IDI_ICON_NOTONTOP},
	{ IDS_EDITMACROBAR ,	IDI_ICON_EDITMACROBAR},
	{ IDS_UNDO ,			IDI_ICON_UNDO},
	{ IDS_REDO ,			IDI_ICON_REDO},
	{ IDS_CLEAR ,			IDI_ICON_DELMACRO},
	{ IDS_SELECTALL ,		IDI_ICON_SELECTALL},
	{ IDS_SAVESCRIPTAS ,	IDI_ICON_SAVE},
	{ IDS_LOADSCRIPT ,		IDI_ICON_RUN},
	{ IDS_SCRIPTSELECTION ,	IDI_ICON_TEST},
};

int string_to_icon_size=sizeof(string_to_icon_array)/2/sizeof(int);

/////////////////////////////////////////////////////////////////////////////
// CSplashDlg dialog
/////////////////////////////////////////////////////////////////////////////


CSplashDlg::CSplashDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSplashDlg::IDD, pParent)
{
	withname=false;
}



void CSplashDlg::SetMessage(const char * message1,const char * message2)
{
	char * info;
	if (withname) {
		info=(char *)message1;
	} else {
		GetDlgItem(IDC_STATIC_LOAD)->ShowWindow(SW_HIDE);
		if (message2!=NULL) info=(char *)message2;
		GetDlgItem(IDC_STATIC_1)->SetWindowText(message1);	
	}
	GetDlgItem(IDC_STATIC_INFO)->SetWindowText(info);
}

/////////////////////////////////////////////////////////////////////////////
// CFilerDlg dialog
/////////////////////////////////////////////////////////////////////////////


void CFilerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFilerDlg)
	DDX_Control(pDX, IDC_BUTTON_RUN, m_run);
	DDX_Control(pDX, IDC_COMBO, m_combo);
	DDX_Control(pDX, IDC_STATIC_HOTKEY, m_hotkey);
	DDX_Control(pDX, IDC_TAB, m_tab);
	DDX_Control(pDX, IDC_TAB2, m_tab2);
	DDX_Control(pDX, IDC_BUTTON_HK, m_hk);
	DDX_Control(pDX, IDC_BUTTON_RECORD, m_record);
	DDX_Control(pDX, IDC_BUTTON_STOP, m_stop);
	DDX_Control(pDX, IDC_BUTTON_EXITTEST, m_exittest);
	DDX_Control(pDX, IDC_PTREE, m_ptree);
	DDX_Control(pDX, IDC_LIST, m_list);
	DDX_Control(pDX, IDC_TREE, m_tree);
	DDX_Control(pDX, IDC_PROPTREE, m_proptree);
	DDX_Control(pDX, IDC_MACTREE, m_mactree);
	DDX_Control(pDX, IDC_TLBTREE, m_tlbtree);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CFilerDlg, CDialog)
	//{{AFX_MSG_MAP(CFilerDlg)
	ON_NOTIFY(TCN_SELCHANGE, IDC_TAB, OnTabSelchange)
	ON_NOTIFY(TCN_SELCHANGE, IDC_TAB2, OnTabSelchange2)
	ON_WM_SIZE()
	ON_CBN_SELCHANGE(IDC_COMBO, OnSelchangeCombo)
	ON_BN_CLICKED(IDC_BUTTON_RUN, OnButtonRun)
	ON_BN_CLICKED(IDC_BUTTON_RECORD, OnButtonRecord)
	ON_BN_CLICKED(IDC_BUTTON_STOP, OnButtonStop)
	ON_BN_CLICKED(IDC_BUTTON_EXITTEST, OnButtonToggleMode)
	ON_WM_CLOSE()
	ON_WM_SYSCOMMAND()
	ON_WM_COPYDATA()
	ON_WM_CONTEXTMENU()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_BN_CLICKED(IDC_BUTTON_HK, OnButtonHk)
	ON_WM_HELPINFO()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFilerDlg Creation




CFilerDlg::CFilerDlg()
	: CDialog(CFilerDlg::IDD, NULL)
{
	gScintilla=&m_scintilla;
	SetTestMode(true);
	viewmode=VIEW_FILES;
	gotinfo=false;
	draggingdivider=0;
	wCorrespondent=0;
	logging=0;
	gPlaying=FALSE;
	gRecording=FALSE;
	gKeyhit=0;
	m_toolbar=NULL;
	mbarvisible=false;
	gImgList = new CImgList();

}

void CFilerDlg::SetStatusIcon(int pane, bool set)
{
	static HICON sIco[]={NULL,NULL,NULL};
	HICON hIcon=NULL;
	if (set) {
		hIcon=PaneIcon[pane];
	}

	if (hIcon!=sIco[pane]) {
		m_status.SetIcon(pane,hIcon);
		sIco[pane]=hIcon;
	}
}

void CFilerDlg::SetStatusTextAndIcon(char * txt , HICON hicon)
{
	m_status.SetIcon(3,hicon);
	m_status.SetText(txt,3,0);
}


void CFilerDlg::SetBmpImgList(CTreeCtrl * tree,int ID)
{
	HIMAGELIST h=NULL;
	h = ImageList_Create(16, 15, ILC_COLOR, 30, 0);
	if (h!=NULL){
		HBITMAP hbm=(HBITMAP) LoadImage(GetModuleHandle(NULL), MAKEINTRESOURCE(ID),IMAGE_BITMAP, 0, 0, LR_DEFAULTCOLOR);
		int ii=ImageList_Add(h,hbm,NULL);
		TreeView_SetImageList(tree->m_hWnd,h,TVSIL_NORMAL);		
	}
}

template <class T> static void SetSysImgList(T * ctl,int type)
{
	ctl->SetImageList(gImgList,type);
}


BOOL CFilerDlg::OnInitDialog()
{
    CDialog::OnInitDialog();
	m_splash=NULL;
	if (GetIniWindowInt("splash",0)!=0){
		m_splash=new CSplashDlg();
		m_splash->withname=true;
		m_splash->Create(IDD_SPLASH);
	}
	viewmode=VIEW_FILES;
	viewmode2=VIEW2_FILES;
	if (!gLaunchedfirst) gAtom.Add((unsigned int)gDest);


	m_scintilla.CreateSWindow();
	int curtab=0;
	int i;
	CRect drect;				//client rect
	xedges=2*GetSystemMetrics(SM_CXEDGE);
	yedges=2*GetSystemMetrics(SM_CYEDGE);

	int wx=GetIniWindowInt("x",400);
	int wy=GetIniWindowInt("y",100);
	int ww=GetIniWindowInt("w",250);
	int wh=GetIniWindowInt("h",500);
	vsplit=GetIniWindowInt("vsplit",0);
	treespace=GetIniWindowInt("tree",70);
	autosplit=GetIniWindowInt("autosplit",0);
	splitfactor=GetIniWindowInt("splitfactor",2);
	hideonminimize=GetIniWindowInt("hideonminimize",0);


	MoveWindow(wx,wy,ww,wh,true);
	SetWindowText(gMyName);
	SetIcon(FlxLoadIcon(IDI_ICON1),true);
	SetIcon(FlxLoadIcon(IDI_ICON1),false);

	tooltip.Create(this);
	//Prepare buttons
	for (i=0;i<5;i++){
		tipbutton[i].SetIcon(FlxLoadIcon(string_to_icon_array[i].icon_id));
		tooltip.AddTool(&tipbutton[i],string_to_icon_array[i].string_id);
	}
	tooltip.Activate(true);


	// tree,ptree and list will use the same image list

	SetSysImgList(&m_tree, TVSIL_NORMAL);
	SetSysImgList(&m_list,LVSIL_SMALL);
	SetSysImgList(&m_ptree,TVSIL_NORMAL);
	SetBmpImgList(&m_mactree,IDB_BITMAP_MACTREE);
	SetBmpImgList(&m_tlbtree,IDB_BITMAP_TLBTREE);
	SetBmpImgList(&m_proptree,IDB_BITMAP_PTREE);

	int dolog=GetIniWorkInt("logging",0);
	if (dolog==1) {
		BuildPath("logpath",logpath,"filerx.log");
		if (!logfile.Open(logpath,CFile::modeCreate | CFile::modeWrite))
			dolog=0;
	}
	logging=dolog;

	//Build and explore root
	if (m_splash!=NULL) m_splash->SetMessage("Tree ...");
	m_tree.DisplayTree();
	if (m_splash!=NULL) m_splash->SetMessage("Project Tree ...");
	m_ptree.InitTree();
	if (m_splash!=NULL) m_splash->SetMessage("Typelib Tree ...");
	m_tlbtree.InitTree();


	BuildPath("ifacepath",ifacename,"scintilla.iface");
	if (m_splash!=NULL) m_splash->SetMessage("Scintilla iface ...");
	ifaceok=LoadIface(ifacename);

	if (!ifaceok)
		MessageBox("scintilla.iface not loaded ...","Check iface",MB_OK);
	else{
		m_scintilla.Init();
		if (m_splash!=NULL) m_splash->SetMessage("Macros ...");
		m_mactree.InitTree();
	}

	if (*gPathtoshow!='\0'){
		char project[MAX_PATH];
		lstrcpy(project,gPathtoshow);
		char * pend=(char *)project+lstrlen(project)-1;
		if (*pend=='\\') *pend='\0';
		if (IsProject(project)){
			m_ptree.AddProject(project);//Load Project file
			curtab=1;
			viewmode=VIEW_PROJS;
		}
	}
	m_ptree.checkdirty=(GetIniWorkInt("checkdirtyproject",1)!=0);
	m_mactree.checkdirty=(GetIniWorkInt("checkdirtymacros",1)!=0);
	m_scintilla.auto_autocomplete=GetIniWorkInt("auto_autocomplete",3);
	m_scintilla.auto_insertclosing=GetIniWorkInt("auto_insertclosing",1);

	char * tabs1[]={"Files","Projs","Props","Macros","Tlibs"};
	char * tabs2[]={"Files","Source","Output","TypeLib","Lua"};
	
	for (i=0;i<=4;i++) {
		m_tab.InsertItem(i,tabs1[i]);
		m_tab2.InsertItem(i,tabs2[i]);
	}

	m_tab.SetCurSel(curtab);

	char hw[10];
	itoa((int)m_hWnd,hw,10);

	ToSendMessage(SCD_IDENTIFY,hw);
	if (ifaceok)
		ToSendMessage(SCD_MACROENABLE,"1");


	///////////// Status Bar

	CRect rect;
   	this->GetClientRect(&rect);
	rect.top = rect.bottom- hstatus-marg;
	rect.left=xstatus;
	rect.right-=marg;
	rect.bottom=rect.top+hstatus;
	m_status.Create(WS_CHILD | WS_VISIBLE
					| CCS_NODIVIDER
					| CCS_NOPARENTALIGN | CCS_NORESIZE
					| SBARS_SIZEGRIP  ,rect,this,IDC_STATUS);

	int m_Widths[4];
	m_Widths[0] = 20;
   	m_Widths[1] = 40;
   	m_Widths[2] = 60;
   	m_Widths[3] = -1;
	m_status.SetParts( 4, m_Widths);

	PaneIcon[0]=FlxLoadIcon(IDI_ICON_SCITE);
	PaneIcon[1]=FlxLoadIcon(IDI_ICON_TEST);
	PaneIcon[2]=FlxLoadIcon(IDI_ICON_RECORD);

	SetTestMode(gLaunchedfirst);
	SetStatusIcon(0,!gLaunchedfirst);
	UpdateViews(viewmode,viewmode2);

	///////////// Macro  Bar

	GetIniWorkString("macrobarpath",gMacrobarpath);
	if (*gMacrobarpath!='\0'){
		if (m_splash!=NULL) m_splash->SetMessage("Macro Bar ...");
		m_toolbar=new CToolDlg(this);
		m_toolbar->Create(IDD_TOOLBAR,this);
		m_toolbar->AddButtons(true);
		mbarvisible=true;
	}
	EnableShortcuts(true);
	lastsk=0;
	lastskname=NULL;
	DoSplash("");
	PlayMacro("_auto_run_");
//	while (gPlaying) {};
//	if (macrotorun!=NULL)
//		PlayMacro(macrotorun+10);
	return TRUE;  // return TRUE unless you set the focus to a control
}


/////////////////////////////////////////////////////////////////////////////
// CFilerDlg Destruction

void CFilerDlg::WriteIniFile()
{
	CRect wrect;
	if (GetIniWindowInt("savewindow",0)==1){
		GetWindowRect(&wrect);
		SetIniWindowInt("x",wrect.left);
		SetIniWindowInt("y",wrect.top);
		SetIniWindowInt("w",wrect.Width());
		SetIniWindowInt("h",wrect.Height());
		SetIniWindowInt("vsplit",vsplit);
		SetIniWindowInt("tree",treespace);
	}
	if (GetIniWorkInt("saveworkdir",1)==1){
		char selpath[MAX_PATH];
		m_list.GetFirstSelectedPath((char *) selpath);
		if (selpath=='\0')
			m_tree.GetSelectedNodePath((char *) selpath);
		if (selpath!='\0')
			SetIniString(SECTION_WORK,"workdir",selpath);
	}
}


void CFilerDlg::OnClose()
{
	//Tell user I'm closed
	ToSendMessage(SCD_MACROENABLE,"0");
	if (gDest!=0)
		BringSciTEToForeground();
	ToSendMessage(SCD_CLOSING);
	WriteIniFile();

	CleanBeforeClosing();
	if (logging)
		logfile.Close();
	gAtom.Delete();
	CDialog::OnClose();
}


void CFilerDlg::DeleteBmpImglist(CTreeCtrl * ctl)
{
	CImageList * pImgList= ctl->GetImageList(LVSIL_NORMAL);
	if (pImgList) {
		HIMAGELIST h=pImgList->Detach();
		ImageList_Destroy(h);
	}
}

void CFilerDlg::CleanBeforeClosing()
{

	DoSplash("");
	
	//free trees and list
	m_list.DeleteAllItems();
	m_tree.DeleteAllItems();
	m_ptree.DeleteAllItems();
	m_proptree.DeleteAllItems();
	m_mactree.DeleteAllItems();
	m_tlbtree.DeleteAllItems();
	m_mactree.CleanupMacros();
	if (m_toolbar!=NULL) {
		m_toolbar->DeleteButtons();
		m_toolbar->DestroyWindow();
		delete m_toolbar;
	}

	//Detach imagelists
	gImgList->RemoveImages();
	gImgList->Detach();
	delete gImgList;

	DeleteBmpImglist(&m_mactree);
	DeleteBmpImglist(&m_proptree);
	DeleteBmpImglist(&m_tlbtree);
}


/////////////////////////////////////////////////////////////////////////////
// CFilerDlg Resizing / Redrawing

void CFilerDlg::UpdateOneWindow(CWnd * w,int flag)
{
	hdwp= ::DeferWindowPos(hdwp,w->m_hWnd,NULL,0,0,0,0,flag);
}

void CFilerDlg::UpdateViews(int vmode, int vmode2)
{
	//viewmode=0 : folder tree
	//viewmode=1 : project tree
	//viewmode=2 : property tree view
	//viewmode=3 : macro tree view
	
	UINT flag=SWP_NOMOVE | SWP_NOSIZE | SWP_NOZORDER;

	if (vmode!=-1){
		if (vmode!=viewmode) {
			viewmode=vmode;
			hdwp=::BeginDeferWindowPos(5);
			if (hdwp) UpdateOneWindow((CWnd *)&m_tree,flag |(viewmode==VIEW_FILES?SWP_SHOWWINDOW:SWP_HIDEWINDOW));
			if (hdwp) UpdateOneWindow((CWnd *)&m_ptree,flag |(viewmode==VIEW_PROJS?SWP_SHOWWINDOW:SWP_HIDEWINDOW));
			if (hdwp) UpdateOneWindow((CWnd *)&m_proptree,flag |(viewmode==VIEW_PROPS?SWP_SHOWWINDOW:SWP_HIDEWINDOW));
			if (hdwp) UpdateOneWindow((CWnd *)&m_mactree,flag |(viewmode==VIEW_MACROS?SWP_SHOWWINDOW:SWP_HIDEWINDOW));
			if (hdwp) UpdateOneWindow((CWnd *)&m_tlbtree,flag |(viewmode==VIEW_TLIBS?SWP_SHOWWINDOW:SWP_HIDEWINDOW));

			if (hdwp) ::EndDeferWindowPos(hdwp);
			m_tab.SetCurSel(viewmode);
		}
		if (viewmode==VIEW_PROPS)
			m_proptree.InitTree();

	}

	//viewmode2=0 : file list
	//viewmode2=1 : source editor
	//viewmode2=2 : output editor
	//viewmode2=3 : typelib output editor

	if (vmode2!=-1){
		if (viewmode2!=vmode2) {
			m_mactree.CompileEditedMacro();
			viewmode2=vmode2;
			m_tab2.SetCurSel(viewmode2);
			bool vwfiles=(viewmode2==VIEW2_FILES);
			hdwp=::BeginDeferWindowPos(2);
			if (hdwp) UpdateOneWindow((CWnd *)&m_list,flag | (vwfiles?SWP_SHOWWINDOW:SWP_HIDEWINDOW));
			if (hdwp) UpdateOneWindow((CWnd *)&m_scintilla,flag | (!vwfiles?SWP_SHOWWINDOW:SWP_HIDEWINDOW));
			if (hdwp) ::EndDeferWindowPos(hdwp);
			m_scintilla.SendToDoc(viewmode2);
			if (viewmode2==VIEW2_SOURCE){
				m_scintilla.SetLexer(SCLEX_CPP);
			}else if (viewmode2==VIEW2_LUA){
				m_scintilla.SetLexer(SCLEX_LUA);
			}

			m_mactree.SynchronizeSource(m_mactree.GetSelectedItem());
		}
	}


	Cstr stt;
	int ic;
	if (viewmode==VIEW_MACROS){
		if (gRecording) {
			stt="Recording ...";
			ic=IDI_ICON_RECORD;
		} else if (viewmode2==VIEW2_OUTPUT){
			stt="Macro ";
			ic=IDI_ICON_TEST;
			m_scintilla.SetFocus();
		} else {
			stt="Editing Macro ";
			ic=IDI_ICON_NEWMACROFILE;
		}
		if (gCurmac!=NULL) {
			stt+=gCurmac->name;
		}
	} else if (viewmode==VIEW_FILES) {
		stt="Files Viewing";
		ic=IDI_ICON_NEWFOLDER;
	} else if (viewmode==VIEW_PROJS) {
		stt="Project mode";
		ic=IDI_ICON_NEWPROJECT;
	} else if (viewmode==VIEW_TLIBS) {
		stt="TypeLib mode";
		ic=IDI_ICON_NEWPROJECT;
	} else if (viewmode==VIEW_PROPS) {
		stt="Properties mode";
		if (gDest==0)
			stt+=" **** SCITE NOT CONNECTED";
		ic=IDI_ICON_SCITE;
	}
	SetStatusTextAndIcon(stt.buf , FlxLoadIcon(ic));

	m_run.SetIcon(FlxLoadIcon(gTesting?IDI_ICON_TEST:IDI_ICON_RUN));
	m_run.EnableWindow(!gRecording);
	m_record.EnableWindow(!gRecording);
	m_stop.EnableWindow(gRecording);
	m_exittest.EnableWindow(!gRecording);
}


void CFilerDlg::DeferTreePos(CTreeCtrl * c)
{
	hdwp=::DeferWindowPos(hdwp,c->m_hWnd,NULL,marg,ytree,wtree,htree,SWP_NOZORDER | SWP_NOACTIVATE);
}
void CFilerDlg::DeferWPos(CWnd * w,int wx,int wy,int ww,int wh)
{
	hdwp=::DeferWindowPos(hdwp,w->m_hWnd,NULL,wx,wy,ww,wh,SWP_NOZORDER | SWP_NOACTIVATE);
}

void CFilerDlg::MoveWindows(bool moveall)
{
	int marg2=2*marg;
	int marg3=3*marg;
	int marg4p=4*marg+hbut;
	int marg5p=5*marg+3*hbut;
	int marg1p=marg+hbut;
	int ytab2,hkx,hkw;
	wcombo=(clientw-marg4p)*4/5;
	hkx=marg2+hbut;
	hkw=clientw-marg4p-wcombo;

	ytab=marg2+hbut;
	ytree=ytab+marg1p;					//Tree y position
	if (vsplit==0){					// Horizontal splitter bar
		wtree=clientw-marg2;				//Tree/List width
		htree=maxhtree*treespace/100;	//Tree height
		if (htree<yedges) htree=yedges;
		if (htree>maxhtree) htree=maxhtree;
		ylist=htree+marg5p;			//List y position
		hlist=clienth-ylist-marg2-hbut;		//List height
		wlist=wtree;
		xlist=marg;
		ytab2=ylist-marg1p;
	}else{								//side-by-side
		htree=clienth-marg5p;	//Tree height
		wtree=maxwtree*treespace/100;			//Tree/List width
		if (wtree<xedges) wtree=xedges;
		if (wtree>maxwtree) wtree=maxwtree;
		wlist=clientw-wtree-marg3;
		ylist=ytree;	//List y position
		hlist=htree;	//List height
		xlist=wtree+marg2;
		ytab2=ytab;
	}

	ybut=ylist+hlist+marg;

	UINT flag=SWP_NOZORDER | SWP_NOACTIVATE;
	hdwp=::BeginDeferWindowPos(moveall?10:15);
	if (hdwp) DeferWPos((CWnd *)&m_scintilla,xlist,ylist,wlist,hlist);
	if (hdwp) DeferWPos((CWnd *)&m_list,xlist,ylist,wlist,hlist);
	if (hdwp) DeferTreePos(&m_tree);
	if (hdwp) DeferTreePos(&m_ptree);
	if (hdwp) DeferTreePos(&m_proptree);
	if (hdwp) DeferTreePos(&m_mactree);
	if (hdwp) DeferTreePos(&m_tlbtree);
	if (hdwp) DeferWPos((CWnd *)&m_tab2,xlist,ytab2,wlist,hbut);
	if (hdwp) DeferWPos((CWnd *)&m_tab,marg,ytab,wtree,hbut);

	if (moveall) {
		if (hdwp) DeferWPos((CWnd *)&m_combo,marg+hkx+hkw,marg,wcombo,hcombo);
		if (hdwp) DeferWPos((CWnd *)&m_hotkey,hkx,marg,hkw,hcombo);

		xbut=marg;
		for (int i=0;i<4;i++){
			if (i==0) xbut=xbut+marg;
			if (hdwp) DeferWPos((CWnd *)&tipbutton[i],xbut,ybut,hbut,hbut);
			xbut=xbut+hbut;
		}

		if (hdwp) DeferWPos((CWnd *)&tipbutton[4],marg,marg,hbut,hbut);

	}
	if (hdwp) ::EndDeferWindowPos(hdwp);
}

void CFilerDlg::OnSize(UINT nType, int cx, int cy)
{
	CDialog::OnSize(nType, cx, cy);
	//if  sub-windows exist :
	OnSizeDo(cx,cy);
}

void CFilerDlg::OnSizeDo(int cx, int cy)
{
	if(m_status.m_hWnd!=0)
	{
		m_status.MoveWindow(xstatus,cy-hstatus-marg,cx-xstatus-marg,hstatus,TRUE);
	}

	if (::IsWindow(m_run.m_hWnd)) {
		clientw=cx;
		clienth=cy;	//Status bar
		maxhtree=clienth-6*marg-3*hbut-yedges;
		maxwtree=clientw-3*marg-xedges;
		if (autosplit==1)
			if (((vsplit==1) && (cy>splitfactor*cx)) || ((vsplit==0) && (cy*splitfactor<cx)))
				{vsplit=1-vsplit;}
		MoveWindows(true);
	}
}

void CFilerDlg::TryToShowPath()
{
	AddToCombo(gPathtoshow);
	char * slash;
	int tries=0;

	do{
		tries++;
		slash=strrchr(gPathtoshow,'\\');	// find last slash
		if (slash) *slash='\0';else break;
	}while (!ShowPath());					//Find path
	if (tries==1){				//only if path was found the first time
		m_list.SelectFile(slash+1);
	}
}

void CFilerDlg::AddToCombo(const char *s)
{
	int indx;
	int cnt;
	bool mustadd=true;
	if (*s=='\0') return;
	//Is the String already in ?
	cnt=m_combo.GetCount();
	if (cnt>0){
		for (indx=0;indx<cnt;indx++){
			int lslen=m_combo.GetLBTextLen(indx);
			Cstr ls(lslen);
			m_combo.GetLBText(indx,ls.buf);
			if (!strcmp(s,ls.buf)){
				mustadd=false;
				break;
			}
		}
	}
	if (mustadd) indx=m_combo.AddString(s);
	m_combo.SetCurSel(indx);
}

bool CFilerDlg::ShowPath()
{
	HTREEITEM hSelected=NULL;
	m_tree.SetRedraw(false);
	m_list.SetRedraw(false);

	//Find the tree Item
	hSelected = m_tree.FindItem(gPathtoshow);

	if (hSelected){
		m_tree.Select(hSelected, TVGN_CARET);
		m_tree.SelectSetFirstVisible(hSelected);
	}
	m_tree.SetRedraw(true);
	m_list.SetRedraw(true);
	return (hSelected!=NULL);
}



/////////////////////////////////////////////////////////////////////////////
// CFilerDlg Button/Combo Events


void CFilerDlg::OnSelchangeCombo() //When selection changes in Combo
{
	m_combo.GetLBText(m_combo.GetCurSel(),gPathtoshow);
	TryToShowPath();
}


void CFilerDlg::OnButtonToggleMode()	{ if (gStepping) gKeyhit='S'; else ToggleTestMode();}
void CFilerDlg::OnButtonRun()			{ if (gStepping) gKeyhit='G'; else PlayMacro();}
void CFilerDlg::OnButtonRecord()		{ if (gStepping) gKeyhit='O'; else StartRecordMacro(true);}
void CFilerDlg::OnButtonStop()			{ if (gStepping) gKeyhit='H'; else StopRecordMacro();}
void CFilerDlg::OnButtonHk()
{
	if (GetAsyncKeyState(VK_CONTROL) & 0x8000) {
		ShowMacroBar(!mbarvisible);
	} else {
		if (viewmode==VIEW_MACROS) EditShortcut();
	}
}



BOOL CFilerDlg::PreTranslateMessage(MSG* pMsg)
{

	// If edit control is visible in tree view control, sending a
      // WM_KEYDOWN message to the edit control will dismiss the edit
      // control.  When ENTER key was sent to the edit control, the parent
      // window of the tree view control is responsible for updating the
      // item's label in TVN_ENDLABELEDIT notification code.
    if (gPlaying && gStepping) {
		if (pMsg->message == WM_KEYDOWN) {
			gKeyhit=(int)pMsg->wParam ;
			return true;
		}
	}

	if (pMsg->message==WM_HOTKEY) {
		int scut=pMsg->wParam;
		if (globalshortcut!=0) {
			ExecuteMacroShortcut();
		} else {
			macro * m=m_mactree.FindMacroByShortcut(scut);
			if (m!=NULL) {
				while (1) {
					if ((GetAsyncKeyState(VK_SHIFT) & 0x8000)==0) break;
					if ((GetAsyncKeyState(VK_CONTROL) & 0x8000)==0) break;
				}
				PlayMacro(m->name);
			}
		}
		return true;
	}

	if (pMsg->hwnd!=m_scintilla.m_hWnd){
		if (pMsg->message == WM_KEYDOWN &&
           pMsg->wParam == VK_RETURN || pMsg->wParam == VK_ESCAPE) {
			 CEdit* edit = m_ptree.GetEditControl();
			 if (!edit) edit=m_proptree.GetEditControl();
			 if (!edit) edit=m_mactree.GetEditControl();
			 if (edit) {
				edit->SendMessage(WM_KEYDOWN, pMsg->wParam, pMsg->lParam);
			 }
				return TRUE;
		}
	}else{
		int vmode2=m_tab2.GetCurSel();
		if (pMsg->message == WM_KEYDOWN){
			if (pMsg->wParam == VK_F9)  {
				if (vmode2==VIEW2_SOURCE)
					PlayMacro();
				else if (vmode2==VIEW2_LUA)
					m_scintilla.doLoadScript();
			} else if (pMsg->wParam == VK_F10) {
				m_mactree.CompileEditedMacro();
				EnterTestMode();
				PlayMacro();
			} else if (pMsg->wParam == VK_F11){
				m_scintilla.AutoCShow(-1);
			} else if (pMsg->wParam == VK_F5){
				if (vmode2==VIEW2_LUA)
					m_scintilla.doScriptSelection();
			}
		}
	}

	tooltip.RelayEvent(pMsg);
	return CDialog::PreTranslateMessage(pMsg);
}


void CFilerDlg::OnTabSelchange(NMHDR* pNMHDR, LRESULT* pResult)
{
    int vmode = m_tab.GetCurSel();
	int vmode2;
	if (vmode==VIEW_MACROS)
		vmode2=VIEW2_SOURCE;
	else if (vmode==VIEW_TLIBS)
		vmode2=VIEW2_TLIBS;
	else
		vmode2=VIEW2_FILES;

  	UpdateViews(vmode,vmode2);
	*pResult = 0;
}
void CFilerDlg::OnTabSelchange2(NMHDR* pNMHDR, LRESULT* pResult)
{
	int vmode2=m_tab2.GetCurSel();
  	UpdateViews(-1,vmode2);
	*pResult = 0;
}


BOOL CFilerDlg::OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult)
{
	if (wParam==(WPARAM)IDC_SCINTILLA)
		if (lParam!=NULL)
			if (m_scintilla.HandleNotification(lParam)){};
				//return 1;
	
	return CDialog::OnNotify(wParam, lParam, pResult);
}

#define HZONE 1
#define VZONE 2
#define DRAGGING_H_DIVIDER 1
#define DRAGGING_V_DIVIDER 2


void set_divider_cursor(int zone)
{
	if (zone==HZONE)
		SetCursor(LoadCursor(NULL,IDC_SIZENS));
	else if (zone==VZONE)
		SetCursor(LoadCursor(NULL,IDC_SIZEWE));
}

int CFilerDlg::PointInDragZone(CPoint point)
{
	if (vsplit==0) {
		if (point.y>=ytree+htree && point.y<=ylist)
			if (point.x>marg && point.x<clientw-marg) return HZONE;
	} else {
		if (point.x>=marg+wtree && point.x<=xlist)
			if (point.y>2*hbut+3*marg && point.y<clienth-2*marg-hbut) return VZONE;
	}
	return 0;
}


void CFilerDlg::OnLButtonDown(UINT nFlags, CPoint point)
{
	draggingdivider=PointInDragZone(point);
	if (draggingdivider!=0){
		set_divider_cursor(draggingdivider);
		SetCapture();
		return;
	}
	CDialog::OnLButtonDown(nFlags, point);
}

void CFilerDlg::OnLButtonUp(UINT nFlags, CPoint point)
{
	if (draggingdivider!=0){
		draggingdivider=0;
		ReleaseCapture();
	}
	CDialog::OnLButtonUp(nFlags, point);
}

void CFilerDlg::OnMouseMove(UINT nFlags, CPoint point)
{
	int zone;

	if (draggingdivider!=0){
		zone=draggingdivider;
		if (draggingdivider==DRAGGING_H_DIVIDER){
			vsplit=0;
			treespace=(int)(100.00*(point.y-ytab-hbut-marg)/maxhtree);
		}else{
			vsplit=1;
			treespace=(int)(100.00*(point.x-marg)/maxwtree);
		}

		if (treespace<0) treespace=0;
		if (treespace>200) treespace=200;
		if (treespace>100) {
			vsplit=1-vsplit;
			treespace=200-treespace;
		}
		MoveWindows();
	} else
		zone =PointInDragZone(point);

	set_divider_cursor(zone);


	CDialog::OnMouseMove(nFlags, point);
}


void CFilerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID) == SC_MINIMIZE && hideonminimize==1){
		ShowWindow(SW_HIDE);
	} else {
		CDialog::OnSysCommand(nID, lParam);
	}
}

void CFilerDlg::RefreshMacroBar(HTREEITEM h)
{
	m_toolbar->DeleteButtons();
	((CFilerTree*)&m_proptree)->TreeToIni(NULL,h,SECTION_MACROBAR);
	m_toolbar->AddButtons();	
}

void CFilerDlg::ShowMacroBar(bool show)
{
	if (m_toolbar!=NULL) {
		m_toolbar->ShowWindow(show ? SW_SHOW : SW_HIDE );
		mbarvisible=show;
	}
}

void CFilerDlg::ExecuteMacroShortcut()
{
	CShortcutDlg skdlg;
	skdlg.m_execute=true;
	skdlg.m_shortcut=lastsk;
	skdlg.m_name=lastskname;
	EnableShortcuts(false);
	if (skdlg.DoModal()==IDOK){
		lastsk=skdlg.macroshortcut;
		macro * m=m_mactree.FindMacroByShortcut(lastsk);
		if (m!=NULL) {
			PlayMacro(m->name);
			lastskname=m->name;
		}
	}
	EnableShortcuts(true);
}


void CFilerDlg::EnableShortcuts(bool enable){

	macro * m=gMacros;
	int gscut=GetIniShortcutInt("_global_shortcut_");
	globalshortcut=gscut;
	if (gscut!=0) {
		if (enable) {
			RegisterHK(m_hWnd,gscut);
			while (m!=NULL){
				if ((m->flags & erased_macro)==0){
					int scut=GetIniShortcutInt(m->name);
					m->shortcut=scut;
				}
				m=m->next;
			}
		} else {
			UnregisterHotKey(m_hWnd,gscut);
		}
		return;
	}

	while (m!=NULL){
		if ((m->flags & erased_macro)==0){
			if (enable) {
				int scut=GetIniShortcutInt(m->name);
				m->shortcut=scut;
				RegisterHK(m_hWnd,scut);
			} else {
				UnregisterHotKey(m_hWnd,m->shortcut);
			}
		}
		m=m->next;
	}
}

void CFilerDlg::ShowHKName(int scut)
{
	Cstr ss("< ");
	ss+=GetKeyName(LOWORD(scut),HIWORD(scut));
	ss+=" >";
	m_hotkey.SetWindowText(ss.buf);
}

void CFilerDlg::EditShortcut()
{
	EnableShortcuts(false);
	HTREEITEM hsel=m_mactree.GetSelected();
	if (hsel!=NULL) {
		if (m_mactree.isMacroItem(hsel)) {
			char * selmacname=m_mactree.hSelectedText;
			macro * selmac=m_mactree.FindMacroByName(selmacname);
			if (selmac!=NULL) {
				CShortcutDlg skdlg;
				skdlg.m_name=selmacname;
				skdlg.m_shortcut=selmac->shortcut;
				skdlg.m_execute=false;

				if (skdlg.DoModal()==IDOK){
					char * s=GetKeyName(skdlg.m_cod,skdlg.m_mod);
					if (skdlg.m_cod!=0) {
						SetIniShortcutInt(selmacname,skdlg.m_cod,skdlg.m_mod,s);
						ShowHKName(skdlg.macroshortcut);
						m_mactree.SetBold(hsel);
					}
				}
			}
		}
	}
	
	EnableShortcuts(true);
}



BOOL CFilerDlg::OnHelpInfo(HELPINFO* pHelpInfo)
{
	ShellExecute(NULL,"open","filerx.chm",NULL,gMyDirectory,SW_SHOWDEFAULT);
	return true;
}
