// FilerDlg.h: interface for the CFilerDlg class.

#if !defined(AFX_FILERDLG_H__INCLUDED_)
#define AFX_FILERDLG_H__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CSplashDlg dialog


class CFileTreeCtrl;
class CFileListCtrl;
class CProjTreeCtrl;
class CPropTreeCtrl;
class CMacTreeCtrl;
class CTlbTreeCtrl;
class CSciCtrl;


class CSplashDlg : public CDialog
{
// Construction
public:
	CSplashDlg(CWnd* pParent = NULL);   // standard constructor
	void SetMessage(const char * message1,const char * message2="");
	bool withname;
// Dialog Data
	//{{AFX_DATA(CSplashDlg)
	enum { IDD = IDD_SPLASH };
	//}}AFX_DATA

};



/////////////////////////////////////////////////////////////////////////////
// CToolDlg dialog

class CFilerDlg;
class Cstr;
class CToolButton : public CButton
{
public:
	CToolButton * next;
	CToolButton * prev;
	int buttonid;
	Cstr name;
	Cstr subname;
	Cstr completename;
	Cstr iconpath;
	Cstr args;
	void BuildCompleteName();
};

static char*  barprops[] = {"_x_","_y_","_ontop_","_have_icons_","_buttoncolumns_","_buttonw_","_buttonh_",
						"_textbuttoncolumns_","_textbuttonw_","_textbuttonh_"};
static int bardefaults[] = {100,100,0,0,16,23,23,6,110,30};


#define propmax 9
#define prop_x_ barprops[0]
#define prop_y_ barprops[1]
#define prop_ontop_ barprops[2]
#define prop_have_icons_ barprops[3]
#define prop_buttoncolumns_ barprops[4]
#define prop_buttonw_ barprops[5]
#define prop_buttonh_ barprops[6]
#define prop_textbuttoncolumns_ barprops[7]
#define prop_textbuttonw_ barprops[8]
#define prop_textbuttonh_ barprops[9]

#define default_x_ bardefaults[0]
#define default_y_ bardefaults[1]
#define default_ontop_ bardefaults[2]
#define default_have_icons_ bardefaults[3]
#define default_buttoncolumns_ bardefaults[4]
#define default_buttonw_ bardefaults[5]
#define default_buttonh_ bardefaults[6]
#define default_textbuttoncolumns_ bardefaults[7]
#define default_textbuttonw_ bardefaults[8]
#define default_textbuttonh_ bardefaults[9]


#define BAR_CHANGE_NOTHING 0
#define BAR_CHANGE_ONTOP 1
#define BAR_CHANGE_HAVICONS 2
#define BAR_CHANGE_EDITOR 3
#define BAR_CHANGE_PATH 4


class CToolDlg : public CDialog
{
// Construction
public:
	CToolDlg(CWnd* pParent = NULL);   // standard constructor
	CToolButton * GetButtonOf(int index);
	void GetTextOf(int index,Cstr * s);
	void GetIni(bool editing);
	void SetIni(bool editing);
	void AddOneButton(char * name,char * subname,bool fromedit=false);
	void AddButtons(bool firstin=false);
	void DeleteButtons();
	void AddToMacroBar(const char * mname0);
	void DropItemFromList (CWnd * w);
	void SetDropMark(CPoint pt);
	void ReBuildBar(int change,char * path=NULL);
	// Edition
	void EditBar();
	void ShowEditControls(bool show);
	void SetDimButton(int dmode);
	void MoveListItem(int index , int move);
	void Synchronize(LVFINDINFO * lvf);
	void DisplayIconList(TreeNode * flist);

	CToolTipCtrl tooltip;
	CToolButton * buttons;
	int bcount;
	int lines;
	int cols;

	int xpossave;
	int ypossave;

	int props[propmax+1];
	int eprops[propmax+1];
	int * buttonh;
	int * buttonw;
	int * bcols;

	bool noresize;
	
	int dimmode;

	bool editing;
	int origwidth;
	int origheight;
// Dialog Data
	//{{AFX_DATA(CToolDlg)
	enum { IDD = IDD_TOOLBAR };
	CButton	m_dim;
	CButton	m_buttontext;
	CSliderCtrl	m_slider;
	CButton	m_buttonicon;
	CButton	m_save;
	CButton	m_exit;
	CStatic	m_staticargs;
	CStatic	m_staticbar;
	CStatic	m_staticmacros;
	CListBox	m_listmacros;
	CEdit	m_editargs;
	CButton	m_up;
	CButton	m_remove;
	CButton	m_down;
	CButton	m_add;
	CStatic	m_staticsubname;
	CStatic	m_staticname;
	CStatic	m_staticicon;
	CEdit	m_editicon;
	CListCtrl	m_listicons;
	CListBox	m_listbuttons;
	CEdit	m_editsubname;
	CComboBox	m_combo;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CToolDlg)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CToolDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnNcRButtonDown( UINT nHitTest, CPoint point );
	afx_msg void OnNcLButtonDblClk( UINT nHitTest, CPoint point );
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSelchangeListButtons();
	afx_msg void OnButtonAdd();
	afx_msg void OnButtonRemove();
	afx_msg void OnButtonUp();
	afx_msg void OnButtonDown();
	afx_msg void OnButtonExit();
	afx_msg void OnButtonSave();
	afx_msg void OnChangeEditSubname();
	afx_msg void OnChangeEditArgs();
	afx_msg void OnDblclkListIcons(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnButtonDim();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


/////////////////////////////////////////////////////////////////////////////
// CFilerDlg dialog

#define MAX_TITLE 200

#define m_exittest tipbutton[0]
#define m_run tipbutton[1]
#define m_record tipbutton[2]
#define m_stop tipbutton[3]
#define m_hk tipbutton[4]


#define VIEW_FILES 0
#define VIEW_PROJS 1
#define VIEW_PROPS 2
#define VIEW_MACROS 3
#define VIEW_TLIBS 4

#define VIEW2_FILES 0
#define VIEW2_SOURCE 1
#define VIEW2_OUTPUT 2
#define VIEW2_TLIBS 3
#define VIEW2_LUA 4



struct string_to_icon {
	int string_id;
	int icon_id;
};

class MItemData
{
public:
	int		iItemID;
	HICON   hItemIcon;
    Cstr  strItemText;
	Cstr  macroname;
};

class IconMenu :public CMenu
{
public:
	IconMenu();	
	~IconMenu();
    void DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct);
	void MeasureItem(LPMEASUREITEMSTRUCT lpMeasureItemStruct);  
};					

class CFilerDlg : public CDialog, public CMacroCommunicator
{
public:
	CFilerDlg();					//Construction
	bool ShowPath();				//display m_PathToShow or subpath
	void TryToShowPath();			//Try to display m_PathToShow
	void AddToCombo(const char * s);		//Add string to Combo Box
	void ToSendMessage(int typ,const char * arg=NULL,const char * arg2=NULL);	//Send Message to caller
	void FilerxMessage(int typ,const char * arg=NULL,const char * arg2=NULL);	//Send Message to caller
	void ToSendMacroCommand(int cmd,int p1,char * t,char * params);
	void SendText(const char * txt);
	void SendWithToolTip(const char * txt);
	int GetInfo(int code,char * params,int arg,int arg2);
	int GetFilerxInfo(int code,char * params,int arg,int arg2);
	void CleanBeforeClosing();
	void WindowsOpen(const char * fname);	//Default Windows Open
	void ExplorerOpen(const char * path);	//Open directory in Explorer
	void SciTEOpen(const char * path,bool activate=false);		//Open file in SciTE
	void BringSciTEToForeground();

	//Menu handling
	MItemData *  mdatas[20];	// 20 items allowed in menu
	int mdatacnt;				//menu items count
	Cstr chosenmacro;		// if custom macro menu is hit
	void AddToMenu(UINT id) ;
	void AddOneFilterMenu(char * txt,char * filter,int id);
	void AddCustomMenus(int section,int type, bool withseparator=true);
	void InitMenu();
	UINT TrackMenu();
	void DoListMenu(); 
	void DoTreeMenu(); 
	void DoTlbTreeMenu(); 
	void DoPTreeMenu(); 
	void DoMTreeMenu() ;
	void DoScintillaMenu() ;
	void DoToolBarMenu(CPoint point,int ontop,int havicons) ;

	void WriteIniFile();

	// Test Mode
	void SetTestMode(bool test);
	void EnterTestMode();
	void ExitTestMode();
	void ToggleTestMode(bool forceupdate=true);
	//Macro Playing/Recording
	void RecordCommand(char * c);
	void DebugOrPlay(bool todebug,char * m);
	void PlayMacro(char * m =NULL);
	void DebugMacro(char * m =NULL);
	bool FilerxDebug(macro * m,int line) { return false;};
	void StartRecordMacro(bool forcetesting=false);
	void StopRecordMacro();
	//Menu customizing macros
	void RunMenuMacro(const char * arg);
	bool RunMacroWithArgs(const char * macname,const char * macargs);
	//Macro List
	void BuildMacroList();
	//Shortcuts
	void ExecuteMacroShortcut();
	void EnableShortcuts(bool enable);
	void EditShortcut();
	void ShowHKName(int codmod);

	//Windows drawing
	int PointInDragZone(CPoint point);
	void UpdateViews(int vmode,int vmode2);		//Shows/Enables buttons
	void OnSizeDo(int cx, int cy); 
	void UpdateOneWindow(CWnd * w,int flag);
	void DeferWPos(CWnd * w,int wx,int wy,int ww,int wh);
	void DeferTreePos(CTreeCtrl * c);
	void MoveWindows(bool moveall=false);						//Resize trees/list
	//Macro Bar
	void ShowMacroBar(bool show);
	void RefreshMacroBar(HTREEITEM h);
	void DoSplash(char *arg,char * arg2=NULL);
	//Image Lists
	void SetBmpImgList(CTreeCtrl * tree,int ID);
	void DeleteBmpImglist(CTreeCtrl * tree);
	// logfile
	void DoLog(const char * log1,const char * log2);
	//status bar
	void SetStatusIcon(int pane, bool set);
	void SetStatusTextAndIcon(char * txt , HICON hicon);

	int logging;					//!=0 when logging
	char logpath[MAX_PATH];			//log file path
	CStdioFile logfile;				//

	char m_PathToShow[MAX_PATH];	//used by ShowPath
	char ifacename[MAX_PATH];		//Scintilla.iface

	HWND wCorrespondent;			//Caller ID specified in message
	bool gotinfo;					//true when answer to info arrives
	Cstr sci_text_info;				//received text info
	int sci_int_info;				//received int info

	int xbut,ybut;					//Button placement	
	int treespace;					//% of space occupied by the tree
	int vsplit;						//!=0 if vertical split
	int splitfactor;				//when to change split
	int autosplit;					//!=0 if auto split enabled
	int ytab;						//tab placement
	int wcombo;						//combo width
	int ytree,htree,wtree;			//tree placement
	int xlist,ylist,wlist,hlist;	//list placement
	int clientw,clienth;			//Dialog client area size
	int xedges;						//2* 3D edge width
	int yedges;						//2* 3D edge height
	int maxhtree;					//tree max height
	int maxwtree;					//tree max width

	HDWP hdwp;						//used for various window resizing/moving
	int draggingdivider;			//1/2 while dragging horz/vert divider

	bool mbarvisible;				//true if macro bar is visible
	
	CToolDlg *		m_toolbar;		
	CSplashDlg *	m_splash;
	HICON PaneIcon[3];				// status bar icons
	bool ifaceok;					//true when iface is loaded

	CButton  tipbutton[5];			//array of buttons
	CToolTipCtrl tooltip;			// tooltip ...
	CMenu * filtermenu;				//filter popup menu
	CMenu * popupmenu;				//main popup menu
	CPoint menupoint;				//menu hit point
	int viewmode;					//0:normal 1:project 2:project editing
	int viewmode2;

	int hideonminimize;

	int globalshortcut;				//!=0 if global shortcut exists
	int lastsk;						//last used shortcut code
	char * lastskname;				//last used shortcut name

	// Dialog Data
	//{{AFX_DATA(CFilerDlg)
	enum { IDD = IDD_FILER };
	CComboBox	m_combo;
	CStatic	m_hotkey;
	CTabCtrl	m_tab;
	CTabCtrl	m_tab2;
	CFileTreeCtrl	m_tree;			//Desktop Tree
	CFileListCtrl	m_list;			//File List
	CProjTreeCtrl	m_ptree;		//Project Tree
	CPropTreeCtrl	m_proptree;		//Properties Tree
	CMacTreeCtrl	m_mactree;		//Macros Tree
	CTlbTreeCtrl	m_tlbtree;		//TypeLib Tree
	CSciCtrl		m_scintilla;	//Scintilla Control
	CStatusBarCtrl	m_status;
	//}}AFX_DATA

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CFilerDlg)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	//virtual BOOL OnChildNotify(UINT message, WPARAM wParam, LPARAM lParam, LRESULT* pLResult);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual BOOL OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult);
	//}}AFX_VIRTUAL
// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CFilerDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnTabSelchange(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnTabSelchange2(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnSelchangeCombo();
	afx_msg void OnButtonRun();
	afx_msg void OnButtonRecord();
	afx_msg void OnButtonStop();
	afx_msg void OnButtonToggleMode();
	afx_msg void OnClose();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg BOOL OnCopyData(CWnd* pWnd, COPYDATASTRUCT* pCopyDataStruct);
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnButtonHk();
	afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};




//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_FILERDLG_H__INCLUDED_)
