// macreact.cpp : implementation file
//

#include "stdafx.h"
#include "inifile.h"
#include "SciCtrl.h"
#include "TreeCtrl_proj.h"
#include "ListCtrl.h"
#include "TreeCtrl_file.h"
#include "TreeCtrl_prop.h"
#include "TreeCtrl_mac.h"
#include "TreeCtrl_tlb.h"
#include "FilerDlg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


IScriptControlPtr pscript;

extern CFilerDlg * gMaindialog;
extern bool gTesting;
extern char * gMyDirectory;
extern bool gLaunchedfirst;
extern HWND gDest;
//////////////////////////////////////////////////////////////////////////////
// Calling another program

static CFilerTree * GetControl(int num)
{
	switch (num) {
		case VIEW_FILES :return (CFilerTree *)(&gMaindialog->m_tree);
		case VIEW_PROJS :return (CFilerTree *)(&gMaindialog->m_ptree);
		case VIEW_PROPS :return (CFilerTree *)(&gMaindialog->m_proptree);
		case VIEW_MACROS :return (CFilerTree *)(&gMaindialog->m_mactree);
		case VIEW_TLIBS :return (CFilerTree *)(&gMaindialog->m_tlbtree);
		default :return NULL;
	}
}

struct HRESULT_EXCEPTION
{
    HRESULT_EXCEPTION(HRESULT hr)
    { if (FAILED(hr)) throw hr; }

    HRESULT operator = (HRESULT hr)
    { if (FAILED(hr)) throw hr; return hr; }
};


void dump_com_error(_com_error &e)
{
    char err[200];
	int errl=0;
    errl=sprintf(err,"\tErreur : %s\n", e.ErrorMessage());
    _bstr_t bstrSource(e.Source());
    _bstr_t bstrDescription(e.Description());
    if (bstrSource.length() > 0)
        errl+=sprintf(err+errl,"\tSource = %s\n", (LPCTSTR) bstrSource);
    if (bstrDescription.length() > 0)
        errl+=sprintf(err+errl,"\tDescription = %s\n", (LPCTSTR) bstrDescription);
	AfxMessageBox(err,MB_OK);
}



void CFilerDlg::FilerxMessage(int typ,const char * arg /*=NULL*/,const char * arg2/*=NULL*/)
{
	int iarg=(int) arg;
	int iarg2=(int) arg2;
	try {

		if (typ>=FLX_EXPANDITEM && typ<=FLX_SORTCHILDREN) {
			CTreeCtrl * tree=GetControl(iarg);
			if (typ==FLX_EXPANDITEM) 
				tree->Expand((HTREEITEM) arg2,TVE_EXPAND);
			else if (typ==FLX_COLLAPSEITEM)
				tree->Expand((HTREEITEM) arg2,TVE_COLLAPSE);
			else if (typ==FLX_SELECTITEM)
				tree->Select((HTREEITEM) arg2, TVGN_CARET);
			else if (typ==FLX_SORTCHILDREN)
				tree->SortChildren((HTREEITEM) arg2);
		} else if (typ==FLX_WINDOWSIZE || typ==FLX_WINDOWPOS ) {
			if (iarg>0 && iarg2>0) {
				int flag=( typ==FLX_WINDOWSIZE ? SWP_NOMOVE : SWP_NOSIZE);
				SetWindowPos(NULL,iarg,iarg2,iarg,iarg2,flag | SWP_SHOWWINDOW | SWP_NOZORDER);
			}
		} else if (typ==FLX_WINDOWARRANGE) {
			vsplit=iarg;
			if (vsplit!=0) vsplit=1;
			treespace=iarg2;
			if (treespace<0) treespace=0;
			if (treespace>100) treespace=100;
			MoveWindows();
		} else if (typ==FLX_SHOWTREE) {
			if (iarg>=0 && iarg<=VIEW_TLIBS) {
	  			UpdateViews(iarg,-1);
			}
		} else if (typ==FLX_SHOWTAB2) {
			if (iarg>=0 && iarg<=VIEW2_LUA) {
	  			UpdateViews(-1,iarg);
			}
		} else if (typ==FLX_STATUS) {
			m_status.SetIcon(3,FlxLoadIcon(IDI_ICON_NEWMACRO));
			m_status.SetText(arg,3,0);
		} else if (typ==FLX_SPLASH) {
			DoSplash((char *)arg,(char *) arg2);
		} else if (typ==FLX_SCRIPTINIT) {
			CoInitialize(NULL);
			pscript.CreateInstance(__uuidof (ScriptControl));
			pscript->Language = arg;
		} else if (typ==FLX_SCRIPTEXIT) {
			pscript->Reset();
			CoUninitialize();
			pscript=NULL;
		} else if (typ==FLX_SCRIPTADDCODE) {
				HRESULT_EXCEPTION hr=pscript->AddCode(arg);
		} else if (typ==FLX_SCRIPTEXECUTE) {
				HRESULT_EXCEPTION hr=pscript->ExecuteStatement(arg);
		} else if (typ==FLX_VIEWMACROBAR) {
			ShowMacroBar(arg!=0);
		}
	}
	catch (_com_error &e)
	{
		dump_com_error(e);
	}
	catch (HRESULT hr)
	{
		_com_error e(hr);
		dump_com_error(e);
	}
}



//Called by expression evaluator to retrieve Filerx state

int CFilerDlg::GetFilerxInfo(int code,char *params,int arg,int arg2)
{
	static bool sFindrecurse;
	static int sFinditem;
	char ipath[MAX_PATH];
	int retval=0;
	bool retval_is_text=false;

	if (code>=FLX_GETROOTITEM && code<=FLX_FINDITEM) {
		CFilerTree * tree=GetControl((int) arg);
		switch (code) {
			case FLX_GETROOTITEM :
				retval=(int)tree->GetRootItem();break;
			case FLX_GETCHILDITEM :
				retval=(int)tree->GetChildItem((HTREEITEM) arg2);break;
			case FLX_GETNEXTSIBLINGITEM :
				retval=(int)tree->GetNextSiblingItem((HTREEITEM) arg2);break;
			case FLX_GETPARENTITEM :
				retval=(int)tree->GetParentItem((HTREEITEM) arg2);break;
			case FLX_FINDITEM :
				retval=((CFilerTree *)tree)->FindTreeItem((HTREEITEM)sFinditem,(char *)arg2,sFindrecurse);break;
			case FLX_GETSELECTEDITEM : 
				retval= (int)tree->GetSelectedItem();break;
			case FLX_GETITEMTYPE : 
				retval= (int)tree->GetItemType((HTREEITEM) arg2);break;
			case FLX_GETITEMTEXT :	
				sci_text_info=tree->GetItText((HTREEITEM)arg2);retval_is_text=true;break;
			case FLX_GETITEMPATH : 	
				if (arg==VIEW_FILES) {
					TreeNode * node = (TreeNode*)tree->GetItemData((HTREEITEM)arg2);
					sci_text_info=node->m_strPath;
				} else if (arg==VIEW_PROJS) {
					sci_text_info=((CProjTreeCtrl*)tree)->GetItemPath((HTREEITEM)arg2,ipath);
				}
				retval_is_text=true;
				break;
		}
	} else if (code==FLX_FINDITEMPREPARE) {
		sFindrecurse=(bool) (arg!=0);
		sFinditem=(int)arg2;
	} else if (code==FLX_GETLISTCOUNT) {
		retval=m_list.GetItemCount();
	} else if (code==FLX_GETLISTITEMTEXT) {
		*ipath='\0';
		m_list.GetItemText(arg,0,ipath,MAX_PATH-1);
		sci_text_info=ipath;
		retval_is_text=true;
	} else if (code==FLX_GETIMISCINFO) {
		WINDOWPLACEMENT wp;
		switch (arg) {
			case 1 : retval=(int)gDest;break;
			case 2 : retval=(int)gLaunchedfirst;break;
			case 3 : retval=(int)vsplit;break;
			case 4 : retval=(int)treespace;break;
			case 5 : retval=(int)splitfactor;break;
			case 6 : retval=(int)autosplit;break;
			case 7 :
			case 8 :
			case 9 :
			case 10 :
				GetWindowPlacement(&wp);
				if (arg==7)
					retval=wp.rcNormalPosition.left;
				else if (arg==8)
					retval=wp.rcNormalPosition.top;
				else if (arg==9)
					retval=wp.rcNormalPosition.right-wp.rcNormalPosition.left;
				else
					retval=wp.rcNormalPosition.bottom-wp.rcNormalPosition.top;
				break;
			case 11 : retval=(int)hideonminimize;break;
			case 12 : retval=(int)GetIniWorkInt("askbeforedelete",0);break;
			case 13 : retval=(int)GetIniWorkInt("askifsavemacros",0);break;
			case 14 : retval=(int)GetIniWorkInt("askifsaveproject",0);break;
			case 15 : retval=(int)viewmode;break;
			case 16 : retval=(int)gTesting;break;
			case 17 : retval=(int)mbarvisible;break;
			case 18 : retval=(int)viewmode2;break;
			case 19 : retval=0; break;
		}
	} else if (code==FLX_GETSMISCINFO) {
		char * sinfo="";
		switch (arg) {
			case 1 : sinfo=gMyDirectory;break;
			case 2 : sinfo=logpath;break;
		}
		retval=(int) sinfo;
	} else if (code==FLX_SCRIPTEVAL) {
		sci_text_info="";
		try {
			_variant_t result=pscript->Eval((char *)arg);
			sci_text_info=(LPCTSTR)(_bstr_t)result;
		}
		catch (_com_error &e)
		{
			dump_com_error(e);
		}
		catch (HRESULT hr)
		{
			_com_error e(hr);
			dump_com_error(e);
		}
		retval_is_text=true;
	}
	if (retval_is_text)
		retval=(int)sci_text_info.buf;

	return retval;
}

void CFilerDlg::DoSplash(char * arg1,char * arg2)
{
	if (*arg1=='\0') {
		if (m_splash!=NULL) {
			m_splash->DestroyWindow();
			delete m_splash;
			m_splash=NULL;
		}
	} else {
		if (m_splash==NULL) {
			m_splash=new CSplashDlg();
			m_splash->Create(IDD_SPLASH);
		}
		m_splash->SetMessage(arg1,arg2);
	}

}