// menu.cpp : implementation file
//

#include "stdafx.h"
#include "inifile.h"
#include "SciCtrl.h"
#include "TreeCtrl_proj.h"
#include "ListCtrl.h"
#include "TreeCtrl_file.h"
#include "TreeCtrl_prop.h"
#include "TreeCtrl_mac.h"
#include "TreeCtrl_tlb.h"
#include "FilerDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern bool gTesting;
extern string_to_icon string_to_icon_array[];
extern int string_to_icon_size;
extern char * gMacrobarpath;
extern HWND gDest;

#define FILTER_MENU 1000
#define CUSTOM_MENU 10000

/////////////////////////////////////////////////////////////////////////////////
// Popup Menu Handling

void CFilerDlg::InitMenu() 
{
	popupmenu=new IconMenu();
	popupmenu->CreatePopupMenu();
	filtermenu=NULL;
	mdatacnt=0;
}

UINT CFilerDlg::TrackMenu() 
{
	UINT choice=popupmenu->TrackPopupMenu(TPM_RETURNCMD , menupoint.x - 4, menupoint.y,this,NULL);
	if (filtermenu!=NULL) delete filtermenu;
	delete popupmenu;
	if (mdatacnt>0) {
		if (choice>=FILTER_MENU) {
			int index=choice-CUSTOM_MENU;
			if (choice<CUSTOM_MENU) {
				index=choice-FILTER_MENU;;
				choice=mdatas[index]->iItemID+FILTER_MENU;
			}
			chosenmacro=mdatas[index]->macroname;
		}

		for (int i=0;i<mdatacnt;i++) {
			MItemData * mptr=mdatas[i];
			if (mptr->hItemIcon!=NULL)
				DestroyIcon(mptr->hItemIcon);
			delete mptr;
		}
	}
	return choice;
}

void CFilerDlg::OnContextMenu(CWnd* pWnd, CPoint point) 
{
	menupoint.x=point.x;
	menupoint.y=point.y;
	if(pWnd==(CWnd *) &m_ptree) 
		DoPTreeMenu();
	else if(pWnd==(CWnd *) &m_mactree) 
		DoMTreeMenu();
	else if(pWnd==(CWnd *) &m_tlbtree) 
		DoTlbTreeMenu();
	else if(pWnd==(CWnd *) &m_tree) 
		DoTreeMenu();
	else if(pWnd==(CWnd *) &m_list) 
		DoListMenu();
	else if(pWnd==(CWnd *) &m_scintilla) 
		DoScintillaMenu();
}

void CFilerDlg::AddToMenu(UINT id) 
{
	if (id!=0){
		MItemData * mdata=new MItemData;
		mdatas[mdatacnt]=mdata;
		mdatacnt++;
		mdata->iItemID=id;
		mdata->strItemText.resize(200);
		LoadString(AfxGetResourceHandle(),id,mdata->strItemText.buf,200);
		mdata->hItemIcon=NULL;
		for (int i=0;i<string_to_icon_size;i++) {
			if (id==(UINT)string_to_icon_array[i].string_id) {
				mdata->hItemIcon=FlxLoadIcon(string_to_icon_array[i].icon_id);
				break;
			}
		}
		popupmenu->AppendMenu(MF_ENABLED | MF_OWNERDRAW, id,(LPCTSTR)mdata);
	}else
		popupmenu->AppendMenu(MF_SEPARATOR, 0);
}

///////////////////////////////////////////////////////////////////////////////////////
// List Menu Handling

void CFilerDlg::AddOneFilterMenu(char * txt,char * filter,int id)
{
	MItemData * mdata=new MItemData;
	mdatas[mdatacnt]=mdata;
	mdata->macroname=filter;
	mdata->hItemIcon=NULL;
	mdata->iItemID=id;
	int flags=(id==m_list.curfilternum ? MF_STRING|MF_CHECKED : MF_STRING);
	filtermenu->AppendMenu(flags,mdatacnt+FILTER_MENU,txt);
	mdatacnt++;
}

#define ALL_TYPES -1

void CFilerDlg::AddCustomMenus(int section,int type,bool withseparator/*=true*/)
{
	bool first=true;
	int filtercnt=1;
	int idicon=IDI_ICON_NEWMACRO;
	if (section==SECTION_MACROBARMENU) idicon=IDI_ICON_MACROBAR;

	CIniSection * inisec=new CIniSection(section);
	while (inisec->GetNextKey()) {
		char * comma=strchr(inisec->value,',');
		int allowedtype=ALL_TYPES;
		if (type!=ALL_TYPES) {
			if (comma!=NULL) {
				*comma='\0';
				allowedtype=atoi(comma+1);
			} else
				allowedtype=type;
		}
		if (lstrlen(inisec->value)>0 && type==allowedtype){
			if (first && withseparator)
				AddToMenu(0);
			if (section==SECTION_FILTERS) {
				AddOneFilterMenu(inisec->key,inisec->value,filtercnt);
				filtercnt++;
			} else {
				MItemData * mdata=new MItemData;
				mdatas[mdatacnt]=mdata;
				mdata->macroname=inisec->value;
				mdata->iItemID=mdatacnt+CUSTOM_MENU;
				mdata->strItemText=inisec->key;
				mdata->hItemIcon=FlxLoadIcon(idicon);
				popupmenu->AppendMenu(MF_ENABLED | MF_OWNERDRAW, mdata->iItemID,(LPCTSTR)mdata);
				mdatacnt++;
			}
			first=false;
		}
	}
	delete inisec;
}

void CFilerDlg::DoListMenu() 
{
	char selpath[MAX_PATH];
	m_list.GetFirstSelectedPath((char *)selpath);
	InitMenu();
	int inisection;

	if (selpath!='\0'){
		AddToMenu(IDS_EDIT);
		if (IsDSP(selpath)) AddToMenu(IDS_OPENDSP);
		if (IsProject(selpath)) {
			AddToMenu(IDS_OPENPROJ);
			AddToMenu(IDS_ADDTOINI);
			inisection=SECTION_PROJECTS;
		}
		if (IsMacros(selpath)) {
			AddToMenu(IDS_OPENMACROFILE);
			AddToMenu(IDS_ADDTOINI);
			inisection=SECTION_MACROS;
		}
		if (IsLua(selpath)) {
			AddToMenu(IDS_LOADSCRIPT);
		}
		if (IsTypeLib(selpath)) AddToMenu(IDS_LOADTYPELIB);
		AddToMenu(IDS_WINDOWS_OPEN);
		if (viewmode==VIEW_PROJS) AddToMenu(IDS_ADDFILE);
		AddCustomMenus(SECTION_FILELISTMENU,ALL_TYPES);
		AddToMenu(0);
	}

	filtermenu=new(CMenu);
	filtermenu->CreatePopupMenu();
	
	AddOneFilterMenu("All Files","",0);
	AddCustomMenus(SECTION_FILTERS,ALL_TYPES,false);
	popupmenu->AppendMenu(MF_POPUP, (UINT)(filtermenu->m_hMenu),"File Filter" );


	UINT rep=TrackMenu();
	int toUpdate=-1;
	
	if (rep>CUSTOM_MENU) {
		RunMenuMacro(selpath);
	} else if (rep>=FILTER_MENU) {
		m_list.curfilternum=rep-FILTER_MENU;
		m_list.curfilterlist=chosenmacro+" ";
		m_tree.GetSelectedNodePath(selpath);
		m_tree.Refresh(selpath);
	} else {
		switch (rep){
			case 0: break;
			case IDS_EDIT: 
				while (*selpath!='\0') {
					SciTEOpen(selpath,true);
					if (gDest==0) break;
					m_list.GetNextSelectedPath((char *) selpath);
				}
				break;
			case IDS_OPENDSP :
				m_ptree.ImportDSP(selpath);//Load Project file
				toUpdate=VIEW_PROJS;
				break;
			case IDS_OPENPROJ :
				m_ptree.AddProject(selpath);//Load Project file
				toUpdate=VIEW_PROJS;
				break;
			case IDS_OPENMACROFILE :
				m_mactree.LoadMacroFile(selpath);//Load Macro file
				toUpdate=VIEW_MACROS;
				break;
			case IDS_WINDOWS_OPEN :
				WindowsOpen(selpath);//Default Windows Open
				break;
			case IDS_ADDFILE:
				m_ptree.AddNewFile(selpath);
				break;
			case IDS_LOADTYPELIB:
				m_tlbtree.AddTypeLibFile(selpath);
				toUpdate=VIEW_TLIBS;
				break;
			case IDS_ADDTOINI:
				SetIniNewString(inisection,selpath);
				m_proptree.ReloadIni();
				break;
			case IDS_LOADSCRIPT :
				ToSendMessage(SCD_LOADSCRIPT,selpath);
				break;
		}
	}
	if (toUpdate!=-1)
		UpdateViews(toUpdate,-1);
}


/////////////////////////////////////////////////////////////////////////////////////////
// Tree Menu Handling


	
void CFilerDlg::DoTreeMenu() 
{
	char selpath[MAX_PATH];
	m_tree.OnContextMenu(menupoint);
	m_tree.GetSelectedNodePath((char *) selpath);

	InitMenu();
	AddToMenu(IDS_EXPLORER);
	AddToMenu(IDS_REFRESH);
	AddCustomMenus(SECTION_FILETREEMENU,ALL_TYPES);

	UINT rep=TrackMenu();	
	if (rep>=CUSTOM_MENU)
		RunMenuMacro(selpath);
	else if (rep==IDS_EXPLORER)
		ExplorerOpen(selpath);
	else if (rep==IDS_REFRESH)
		m_tree.Refresh((char *)selpath);
}

/////////////////////////////////////////////////////////////////////////////////////////
// TypeLib Tree Menu Handling
	
void CFilerDlg::DoTlbTreeMenu() 
{
	int kind=m_tlbtree.OnContextMenu(menupoint);
	if (kind==-1) return;
	
	HTREEITEM item=m_tlbtree.GetSelectedItem();
	char * seltext=m_tlbtree.GetItText(item);

	InitMenu();
	AddCustomMenus(SECTION_TLBMENU,kind,false);

	UINT rep=TrackMenu();	
	if (rep>=CUSTOM_MENU) {
		RunMenuMacro(seltext);
	}
}

///////////////////////////////////////////////////////////////////////////////////////
// Project Tree Menu Handling

void CFilerDlg::DoPTreeMenu() 
{
	int kind=m_ptree.OnContextMenu(menupoint);	
	HTREEITEM item=m_ptree.GetSelectedItem();
	char * seltext=m_ptree.GetItText(item);


	InitMenu();
	int nosep=false;
	
	switch (kind){
		case TYPE_ROOT :
			nosep=true;
			break;
		case TYPE_PROJECT :
			AddToMenu(IDS_EDIT);
			AddToMenu(0);
			AddToMenu(IDS_NEWFOLDER);
			AddToMenu(0);
			AddToMenu(IDS_SAVE);
			AddToMenu(IDS_ADDTOINI);
			AddToMenu(IDS_DELPROJ);
			AddCustomMenus(SECTION_PROJECTMENU,TYPE_PROJECT);
			break;
		case TYPE_FOLDER :
			AddToMenu(IDS_NEWFOLDER);
			AddToMenu(IDS_DELFOLDER);
			AddCustomMenus(SECTION_PROJECTMENU,TYPE_FOLDER);
			break;
		case TYPE_FILE :
			AddToMenu(IDS_EDIT);
			AddToMenu(IDS_WINDOWS_OPEN);
			if (IsLua(seltext)) AddToMenu(IDS_LOADSCRIPT);
			AddCustomMenus(SECTION_PROJECTMENU,TYPE_FILE);
			AddToMenu(0);
			AddToMenu(IDS_DELETE);
			break;
		default:
			nosep=true;
	}
			if (kind==TYPE_FOLDER || kind==TYPE_PROJECT)
				AddToMenu(IDS_SORT);
			if (!nosep) AddToMenu(0);
			AddToMenu(IDS_NEWPROJ);

	UINT rep=TrackMenu();
	
	if (rep!=0) 
		m_ptree.ExecMenuCommand(rep);
}

///////////////////////////////////////////////////////////////////////////////////////
// Macro Tree Menu Handling


void CFilerDlg::DoMTreeMenu() 
{
	int kind=m_mactree.OnContextMenu(menupoint);
	
	InitMenu();

	switch (kind){
		case TYPE_ROOT :
			break;
		case TYPE_MACROFILE :
			AddToMenu(IDS_NEWMACRO);
			AddToMenu(IDS_EDIT);
			AddToMenu(0);
			AddToMenu(IDS_MSAVE);
			AddToMenu(IDS_ADDTOINI);
			AddToMenu(IDS_DELMACROFILE);
			AddToMenu(0);
			break;
		case TYPE_MACRO :
			if (gDest!=NULL)
				AddToMenu(IDS_PLAYMACRO);
			AddToMenu(IDS_TESTTHISMACRO);
			AddToMenu(IDS_DEBUGMACRO);
			AddToMenu(IDS_HOTKEY);
			if (mbarvisible)
				AddToMenu(IDS_MACROBAR);
			AddToMenu(0);
			AddToMenu(IDS_DELMACRO);
			AddToMenu(IDS_DUMPCODE);
			AddToMenu(0);
			break;
		case TYPE_FILE :
			AddToMenu(IDS_EDIT);
			break;
	}

	if (gTesting)
		AddToMenu(IDS_EXITTEST);
	else
		AddToMenu(IDS_TESTMODE);
	AddToMenu(IDS_NEWMACROFILE);

	UINT rep=TrackMenu();

	if (rep!=0) {
		HTREEITEM hsel=m_mactree.GetSelected();
		char *  path=m_mactree.hSelectedText;
		
		switch (rep){
			case IDS_PLAYMACRO: 
				if (gTesting) ToggleTestMode();
				PlayMacro(path);break;
			case IDS_RECORDMACRO: StartRecordMacro(true);break;
			case IDS_HOTKEY:EditShortcut();break;
			case IDS_MACROBAR: m_toolbar->AddToMacroBar(path);break;
			case IDS_TESTMODE	: EnterTestMode();break;
			case IDS_TESTTHISMACRO: 
				if (!gTesting) ToggleTestMode();
				PlayMacro(path);break;
			case IDS_EXITTEST	: ExitTestMode();break;
			case IDS_STOPRECORDMACRO: StopRecordMacro();break;
			case IDS_EDIT		: SciTEOpen(path,true);break;
			case IDS_MSAVE		: m_mactree.doSave(hsel);break;
			case IDS_DELMACROFILE : m_mactree.pdel();break;
			case IDS_DELMACRO	: m_mactree.fdel();break;
			case IDS_NEWMACRO	: m_mactree.fnew();break;
			case IDS_NEWMACROFILE: m_mactree.pnew();break;
			case IDS_ADDTOINI :	SetIniNewString(SECTION_MACROS,path);
								m_proptree.ReloadIni();
								break;
			case IDS_DUMPCODE	: m_mactree.DumpMacroCode();break;
			case IDS_DEBUGMACRO : 
				if (!gTesting) ToggleTestMode();
				DebugMacro(path);break;
		}
	}
}

/////////////////////////////////////////////////////////////////////////////////
// ToolBar Menu

void CFilerDlg::DoToolBarMenu(CPoint point,int ontop,int havicons) 
{
	menupoint.x=point.x;
	menupoint.y=point.y;

	InitMenu();
	AddToMenu((ontop ? IDS_NOTONTOP : IDS_ONTOP));
	AddToMenu((havicons ? IDS_TEXTBUT : IDS_ICONBUT));
	if (!m_toolbar->editing)
		AddToMenu(IDS_EDITMACROBAR);

	AddCustomMenus(SECTION_MACROBARMENU,ALL_TYPES);
	UINT rep=TrackMenu();
	if (rep>0) {
		char * mpath=NULL;
		int change=BAR_CHANGE_PATH;
		if (rep>=CUSTOM_MENU) {
			mpath=chosenmacro.buf;
			change=BAR_CHANGE_PATH;
		} else {
			if (rep==IDS_ONTOP || rep==IDS_NOTONTOP){
				change=BAR_CHANGE_ONTOP;
			} else if (rep==IDS_ICONBUT || rep==IDS_TEXTBUT){
				change=BAR_CHANGE_HAVICONS;
			}else if (rep==IDS_EDITMACROBAR)
				change=BAR_CHANGE_EDITOR;
		}
		m_toolbar->ReBuildBar(change,mpath);
	}
}

/////////////////////////////////////////////////////////////////////////////////
// Scintilla Menu

void CFilerDlg::DoScintillaMenu() 
{
	InitMenu();
	m_scintilla.GetState();
	if (m_scintilla.state.canundo) AddToMenu(IDS_UNDO);
	if (m_scintilla.state.canredo) AddToMenu(IDS_REDO);
	if (m_scintilla.state.havesel) {
		AddToMenu(IDS_CUT);
		AddToMenu(IDS_COPY);
		AddToMenu(IDS_CLEAR);
	}
	if (m_scintilla.state.canpaste) AddToMenu(IDS_PASTE);
	AddToMenu(IDS_SELECTALL);
	if (viewmode2==VIEW2_LUA) {
		AddToMenu(0);
		AddToMenu(IDS_SAVESCRIPTAS);
		AddToMenu(IDS_LOADSCRIPT);
		if (m_scintilla.state.havesel)
			AddToMenu(IDS_SCRIPTSELECTION);
	}
	AddCustomMenus(SECTION_SCINTILLAMENU,ALL_TYPES,true);

	UINT rep=TrackMenu();
	m_scintilla.HandleMenu(rep);
}

/////////////////////////////////////////////////////////////////////////////////////////
// IconMenu Class

IconMenu::IconMenu()
{
}

IconMenu::~IconMenu()
{
	DestroyMenu();
}

#define ICON_WIDTH 16
#define ICON_HEIGHT 16

void IconMenu::DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct)
{
	MItemData * mdata=(MItemData *)lpDrawItemStruct->itemData;
	CDC* pdc=CDC::FromHandle(lpDrawItemStruct->hDC);

	CRect rect(lpDrawItemStruct->rcItem);
	CRect rcIcon(rect);
	//CRect rcText(rect);
	//rcIcon.left=rect.left+2;
	rcIcon.left+=2;
	rcIcon.right=rcIcon.left+ICON_WIDTH;
	//rcText.left=rcIcon.right+4;
	
	if (lpDrawItemStruct->itemAction & (ODA_SELECT | ODA_DRAWENTIRE)) {
		COLORREF backcolor;
		COLORREF textcolor;
		if (lpDrawItemStruct->itemState & ODS_SELECTED){
			backcolor=::GetSysColor(COLOR_HIGHLIGHT);
			textcolor=RGB(255,255,255);
		} else {
			backcolor=::GetSysColor(COLOR_BTNFACE);
			textcolor=::GetSysColor(COLOR_BTNTEXT);
		}
 		CBrush *pBrush=new CBrush(backcolor);
		pdc->FillRect(rect,pBrush);
		delete pBrush;

		if(mdata->hItemIcon){
			pdc->DrawState(rcIcon.TopLeft(),CSize(ICON_WIDTH,ICON_HEIGHT),mdata->hItemIcon,DST_ICON|DSS_NORMAL,(CBrush*)NULL);	
		}
		pdc->SetTextColor(textcolor);
		pdc->SetBkColor(backcolor);	
		rect.left=rcIcon.right+4;
		pdc->DrawText(mdata->strItemText.buf,&rect,DT_LEFT|DT_NOCLIP|DT_SINGLELINE|DT_VCENTER);
	}   
}


void IconMenu::MeasureItem(LPMEASUREITEMSTRUCT lpMeasureItemStruct)
{
	MItemData  * mdata=(MItemData *)lpMeasureItemStruct->itemData;
	CDC* pdc=new CDC;
	pdc->Attach(::GetDC(AfxGetMainWnd()->m_hWnd));

    CFont m_fontMenu;
    LOGFONT m_lf;
    ZeroMemory ((PVOID) &m_lf,sizeof (LOGFONT));
    NONCLIENTMETRICS nm;
    nm.cbSize = sizeof (NONCLIENTMETRICS);
    SystemParametersInfo(SPI_GETNONCLIENTMETRICS,nm.cbSize,&nm,0); 
    m_lf =  nm.lfMenuFont;
    m_fontMenu.CreateFontIndirect (&m_lf);
    CFont* oldFont= pdc->SelectObject (&m_fontMenu);
    CSize szText=pdc->GetOutputTextExtent(mdata->strItemText.buf);  
	pdc->SelectObject (oldFont); 
	m_fontMenu.DeleteObject();
	::ReleaseDC(AfxGetMainWnd()->m_hWnd,pdc->m_hDC);
	delete pdc;
	lpMeasureItemStruct->itemWidth=szText.cx+ICON_WIDTH+4;
	lpMeasureItemStruct->itemHeight=__max(ICON_HEIGHT,szText.cy)+3;
 }
			


