// filerx.cpp : Defines the class behaviors for the filerx application.

#include "stdafx.h"

#include "inifile.h"
#include "SciCtrl.h"
#include "TreeCtrl_proj.h"
#include "ListCtrl.h"
#include "TreeCtrl_file.h"
#include "TreeCtrl_prop.h"
#include "TreeCtrl_mac.h"
#include "TreeCtrl_tlb.h"
#include "filerdlg.h"

//Globals ...

CFilerxApp NEAR theApp;
char * gMyName="Filerx";

LPMALLOC gpMalloc;				//Used in TreeNode.cpp only , but initialized/released once here
CFilerDlg * gMaindialog=NULL;	//Main dialog
char * gInipath=NULL;			//Filerx.ini path
char * gMacrobarpath=NULL;		//Current macro bar path
char * gMyDirectory=NULL;		//Filerx.exe directory
char * gPathtoshow=NULL;		//Used in command line
CAtom gAtom(gMyName);			//Atom class
bool gLaunchedfirst;			//true if Filerx is launched first
HWND gDest=NULL;				//Caller ID

CSciCtrl * gScintilla=NULL;	//Scintilla control
CImgList * gImgList;		//A class to handle image lists
bool gPlaying;				//true when playing a macro
bool gStepping;				//true when debugging stepping
bool gTesting;				//true when macro output is sent to internal Scintilla
bool gRecording;			//true when recording a macro
macro * gCurmac=NULL;		//current macro
macro * gMacros=NULL;		//list of loaded macros
int gKeyhit;				//Used when debugging a macro

int folderIcon;				//closed folder icon
int ofolderIcon;			//open folder icon

///////////////////////////////////////////////////////////////////////////////
// Command line parsing

void CMyCmdLineInfo::ParseParam(const char* pszParam, BOOL bFlag, BOOL bLast)
{
	if (!strncmp(pszParam,"macro:run:",10)) {
		theApp.macrotorun=pszParam;
	} else if (!strncmp(pszParam,"id:",3)) {
		int dest;
		char * desth=(char *)pszParam+3;
		while(*desth==' ') desth++;
		if (*desth=='0' && (*(desth+1)=='x' || *(desth+1)=='X'))
			sscanf(desth+2,"%x",&dest);
		else
			sscanf(desth,"%u",&dest);
		gDest=(HWND)dest;
	}else {
		lstrcpy(gPathtoshow,pszParam);
	}
}


/////////////////////////////////////////////////////////////////////////////
// CFilerxApp

BOOL CFilerxApp::InitInstance()
{
	AfxOleInit();
	AfxEnableControlContainer();
	Enable3dControls();
	mustrun=true;
	gLaunchedfirst=true;
	gDest=0;

	gInipath=new char[MAX_PATH];
	gMacrobarpath=new char[MAX_PATH];
	gMyDirectory=new char[MAX_PATH];
	gPathtoshow=new char[MAX_PATH];
	*gPathtoshow='\0';

	CMyCmdLineInfo cmdline;
	ParseCommandLine(cmdline);

	if (gDest!=0){	// I was launched by SciTE
		if (gAtom.Find((int)gDest)){ // another instance exists : use it
			HWND wfilerx=(HWND)::FindWindow((const char *)32770L,gMyName);
			mustrun=false;
			if (macrotorun!="") {
				COPYDATASTRUCT cds;
				cds.dwData = 0;
				cds.lpData = macrotorun.buf;
				cds.cbData = macrotorun.len;
				::SendMessage(wfilerx ,WM_COPYDATA,(UINT)gDest,(long)&cds);
			} else {
				ShowWindow(wfilerx,SW_SHOWNORMAL);
				SetForegroundWindow(wfilerx);
			}
		}
		gLaunchedfirst=false;
	}

	if (mustrun){
		SHGetMalloc(&gpMalloc);
		
		// Save my directory :
		lstrcpy(gMyDirectory,m_pszHelpFilePath);
		char * c=gMyDirectory+lstrlen(gMyDirectory);
		while (*c!='\\' ) c--;
		*(c+1)='\0';

		//GetIniFileName
		lstrcpy(gInipath,gMyDirectory);
		lstrcat(gInipath,m_pszProfileName);

		// Create dialog
		gMaindialog= new CFilerDlg ();

		// Directory to show ...
		if (*gPathtoshow=='\0')
			BuildPath("workdir",gPathtoshow,"*");		

	}
	return TRUE;
}


int CFilerxApp::Run() {
	if (mustrun) {
		gMaindialog->DoModal();
		delete [] gInipath;
		delete [] gMacrobarpath;
		delete [] gMyDirectory;
		delete [] gPathtoshow;
		delete gMaindialog;
		gpMalloc->Release();
	} else
		::PostQuitMessage(0);
	return 0;

}

/////////////////////////////////////////////////////////////////////////
///

