// SciCtrl.cpp : implementation file
//

#include "stdafx.h"
#include "SciCtrl.h"
#include "TreeCtrl_proj.h"
#include "ListCtrl.h"
#include "TreeCtrl_file.h"
#include "TreeCtrl_prop.h"
#include "TreeCtrl_mac.h"
#include "TreeCtrl_tlb.h"
#include "FilerDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CFilerDlg * gMaindialog;
extern bool gPlaying;
extern bool gStepping;
extern int gKeyhit;
extern macro * gCurmac;
extern macro * gMacros;

/////////////////////////////////////////////////////////////////////////////
// CSciCtrl

BEGIN_MESSAGE_MAP(CSciCtrl, CWnd)
	//{{AFX_MSG_MAP(CSciCtrl)
	ON_WM_LBUTTONDBLCLK()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()



CSciCtrl::CSciCtrl()
{
	HINSTANCE hmod = LoadLibrary("SciLexer.DLL");
	if (hmod==NULL)
	{
		MessageBox( 
		"The Scintilla DLL could not be loaded.", 
		"Error loading Scintilla", 
		MB_OK | MB_ICONERROR);
	} 
	m_keywords=NULL;
	m_ScintillaCommands=new int[snumnames+1];
}

void CSciCtrl::CreateSWindow()
{
	CRect r(1,1,100,100);
	CreateEx(WS_EX_CLIENTEDGE,"Scintilla","",
			WS_CHILD | WS_VSCROLL | WS_HSCROLL | WS_CLIPCHILDREN,
			r,gMaindialog,(UINT)IDC_SCINTILLA);
}

CSciCtrl::~CSciCtrl()
{
	if (m_keywords!=NULL) delete [] m_keywords;
	if (m_ScintillaCommands!=NULL) delete [] m_ScintillaCommands;
}


#define BP_MARKER 2
#define IP_MARKER 3

void CSciCtrl::Init()
{
	char sname[40];
	char * snamelistptr=snamelist;
	char * snameptr;
	for (int i=0;i<=snumnames;i++){
		snameptr=sname;
		while (*snamelistptr!=',' && *snamelistptr!='\0')
			*snameptr++=*snamelistptr++;
		*snameptr='\0';
		m_ScintillaCommands[i]=GetCommandCode((char *)sname);
/*		char b [10];
		itoa(i,b,10);
		if (m_ScintillaCommands[i]==0)
			MessageBox(b,sname);*/
		snamelistptr++;
	}
	
	docsource=(void *)SendMessage(SCI_CREATEDOCUMENT, 0, 0);
	docoutput=(void *)SendMessage(SCI_CREATEDOCUMENT, 0, 0);
	doctlb=(void *)SendMessage(SCI_CREATEDOCUMENT, 0, 0);
	doclua=(void *)SendMessage(SCI_CREATEDOCUMENT, 0, 0);
	SendMessage(SCI_SETDOCPOINTER,0,(long)doclua);
	SendMessage(SCI_SETLEXER,0,0);
	SendMessage(SCI_SETDOCPOINTER,0,(long)doctlb);
	SendMessage(SCI_SETLEXER,0,0);
	SendMessage(SCI_SETTEXT,(long)"");
	SendMessage(SCI_SETDOCPOINTER,0,(long)docoutput);
	SendMessage(SCI_SETLEXER,0,0);
	SendMessage(SCI_SETTEXT,(long)"");
	SendMessage(SCI_SETDOCPOINTER,0,(long)docsource);
	doc[1].selstart=0;doc[1].selend=0;
	doc[2].selstart=0;doc[2].selend=0;
	doc[3].selstart=0;doc[3].selend=0;
	doc[4].selstart=0;doc[4].selend=0;
	curdocnum=VIEW2_SOURCE;
	SendMessage(SCI_SETLEXER,SCLEX_CPP,0);
	SendMessage(SCI_SETTEXT,(long)"");
	SendMessage(SCI_STYLESETFORE,6,0x7F007F);//""
	SendMessage(SCI_STYLESETFORE,7,0x7F007F);//''
	SendMessage(SCI_STYLESETFORE,5,0x007F7F);//keywords0
	SendMessage(SCI_STYLESETFORE,16,0x808000);//keywords1
	SendMessage(SCI_STYLESETFORE,2,0x7F0000);//comments
	SendMessage(SCI_STYLESETFORE,9,0x0000C0);//preprocessor=error
	//SendMessage(SCI_STYLESETBOLD,16,true);//bold keywords1

	SendMessage(SCI_SETINDENTATIONGUIDES,true,0);
	SendMessage(SCI_SETTABWIDTH,4,0);
	SendMessage(SCI_SETINDENT,4,0);
	SendMessage(SCI_SETCARETPERIOD,400,0);
	char * words=GetMacroKeyWords(1);
	SendMessage(SCI_SETKEYWORDS,0,(long)words);
	delete[]words;
	words=GetMacroKeyWords(2);
	SendMessage(SCI_SETKEYWORDS,1,(long)words);
	delete[]words;

	SendMessage(SCI_MARKERDEFINE,BP_MARKER,1);
	SendMessage(SCI_MARKERDEFINE,IP_MARKER,4);
	SendMessage(SCI_MARKERSETBACK,BP_MARKER,0x0000ff);
	SendMessage(SCI_MARKERSETBACK,IP_MARKER,0x00ffff);
	SendMessage(SCI_SETCARETLINEBACK,0xff80ff);
	SendMessage(SCI_CALLTIPSETBACK,0xffffa0);
	//SendMessage(GetCommandCode("AutoCSetAutoHide"),0);
	SendMessage(SCI_AUTOCSETCANCELATSTART,0);

	SendMessage(SCI_USEPOPUP,0);
	luacurrentscript[0]='\0';
}

//////////////////////////////////////////////////////////////////
// Set/Get Text
void CSciCtrl::SetLexer(int lexer)
{
	SendMessage(SCI_SETLEXER,lexer,0);
	if (lexer==SCLEX_LUA) {
	char *luawords = "and break do else elseif end false for function if \
						in local nil not or repeat return then true until while \
						_VERSION assert collectgarbage dofile error gcinfo loadfile loadstring \
						print tonumber tostring type unpack \
						_G getfenv getmetatable ipairs loadlib next pairs pcall \
						rawegal rawget rawset require setfenv setmetatable xpcall";/* \
						string.byte string.char string.dump string.find string.len \
string.lower string.rep string.sub string.upper string.format string.gfind string.gsub \
table.concat table.foreach table.foreachi table.getn table.sort table.insert table.remove table.setn \
math.abs math.acos math.asin math.atan math.atan2 math.ceil math.cos math.deg math.exp \
math.floor math.frexp math.ldexp math.log math.log10 math.max math.min math.mod \
math.pi math.rad math.random math.randomseed math.sin math.sqrt math.tan \
coroutine.create coroutine.resume coroutine.status \
coroutine.wrap coroutine.yield \
io.close io.flush io.input io.lines io.open io.output io.read io.tmpfile io.type io.write \
io.stdin io.stdout io.stderr \
os.clock os.date os.difftime os.execute os.exit os.getenv os.remove os.rename \
os.setlocale os.time os.tmpname";*/
SendMessage(SCI_SETKEYWORDS,0,(long)luawords);
	} else {
	char * words=GetMacroKeyWords(1);
	SendMessage(SCI_SETKEYWORDS,0,(long)words);
	delete[]words;

	}
}

void CSciCtrl::GetBuffer(Cstr * s)
{
	int textlen=SendMessage(SCI_GETLENGTH);
	s->resize(textlen);
	s->len=textlen;
	SendMessage(SCI_GETTEXT,textlen+1,(long)s->buf);
}

void CSciCtrl::ClearAll()
{
	SendMessage(SCI_CLEARALL);
}

void CSciCtrl::OpenText(const char * name)
{
	Cstr text;
	if (*name!='\0')
		ReadTextFile(name,&text);
	gMaindialog->UpdateViews(-1,VIEW2_OUTPUT);
	SetText(text.buf);
}

void CSciCtrl::LoadLuaFile(char * name)
{
	Cstr text;
	if (*name!='\0'){
		ReadTextFile(name,&text);
		lstrcpy(luacurrentscript,name);
	}
	gMaindialog->UpdateViews(-1,VIEW2_LUA);

	SetText(text.buf);
}



void CSciCtrl::SetText(char * text)
{
	if (text!=NULL) {
		SendMessage(SCI_SETTEXT,0,(long)text);
		if (*text!='\0')
			SendMessage(SCI_EMPTYUNDOBUFFER,0,0);
	}
}

void CSciCtrl::SendToDoc(int docnum)
{
	if (docnum>0) {
		if (docnum!=curdocnum) {
			doc[curdocnum].selstart=SendMessage(SCI_GETSELECTIONSTART,0,0);			
			doc[curdocnum].selend=SendMessage(SCI_GETSELECTIONEND,0,0);			
			curdocnum=docnum;
			SendMessage(SCI_SETDOCPOINTER,0,(long)doc[docnum].docptr);
			SendMessage(SCI_SETSELECTIONSTART,doc[docnum].selstart,0);
			SendMessage(SCI_SETSELECTIONEND,doc[docnum].selend,0);
		}
	}
}

void CSciCtrl::AddLine(const char * line)
{
	gMaindialog->UpdateViews(-1,VIEW2_TLIBS);
	if (line!=NULL) {
		SendMessage(SCI_ADDTEXT,lstrlen(line),(long)line);
		SendMessage(SCI_ADDTEXT,1,(long)"\n");
	}
}

void CSciCtrl::ClearAllTlb()
{
	gMaindialog->UpdateViews(-1,VIEW2_TLIBS);
	SendMessage(SCI_CLEARALL);
}


void CSciCtrl::SendText(const char * txt)
{
	if (txt!=NULL)
		SendMessage(SCI_ADDTEXT,lstrlen(txt),(long)txt);
}

void CSciCtrl::SendWithToolTip(const char * txt)
{
	char buff[100];
	char * psrc=(char *)txt;
	char * pdst=buff;
	while ( *psrc && *psrc!='(') 
		*pdst++=*psrc++;
	*pdst++='(';*pdst++='\0';
	SendText((const char *) buff);
	int cpos=GetCurPos();
	SendMessage(SCI_CALLTIPSHOW,cpos,(long)txt);
}


///////////////////////////////////////////////////////////////////////
// Internal Macro Communicator routines

int CSciCtrl::GetInfo(int code,char *params,int arg,int arg2)
{

	if (code>=FLX_MESSAGES) {
		return gMaindialog->GetFilerxInfo(code,params,arg,arg2);
	}
	
	int neededsize=0;
	int wParam=arg;

	if (code==SCI_GETSELTEXT){
		int send=SendMessage(SCI_GETSELECTIONEND);
		int sbeg=SendMessage(SCI_GETSELECTIONSTART);
		neededsize=send-sbeg;
		wParam=0;
	}else if(code==SCI_GETCURLINE){
		int cpos=GetCurPos();
		int line=SendMessage(SCI_LINEFROMPOSITION,cpos);
		neededsize=SendMessage(SCI_LINELENGTH,line);
		wParam=neededsize;
	}else if(code==SCI_GETTEXT){
		neededsize = SendMessage(SCI_GETLENGTH);
		wParam=neededsize;
	}else if(code==SCI_GETLINE){
		neededsize=SendMessage(SCI_LINELENGTH,arg);
	}else if(code==SCD_ASKFILENAME){
		return (int)scd_opened.buf;
	}else if(code==SCD_ASKPROPERTY){
		gMaindialog->sci_text_info="";
		return (int)gMaindialog->sci_text_info.buf;
	}else
		return SendMessage(code,arg,arg2);
	
	gMaindialog->sci_text_info="";
	if (neededsize>0) {
		gMaindialog->sci_text_info.resize(neededsize);
		SendMessage(code,wParam,(long)gMaindialog->sci_text_info.buf);
		*(gMaindialog->sci_text_info.buf+neededsize)='\0';
	}
	return (int) gMaindialog->sci_text_info.buf;
}

void CSciCtrl::ToSendMacroCommand(int cmd,int p1,char * t,char * params)
{
	SendMessage(cmd,p1,(unsigned long)t);
}

void CSciCtrl::ToSendMessage(int cmd,const char * arg /*=NULL*/,const char * arg2/*=NULL*/)
{

	if (cmd>=FLX_MESSAGES) {
		gMaindialog->FilerxMessage(cmd,arg,arg2);
		return;
	}

	if (cmd==SCD_MENUCOMMANDW) {
		gMaindialog->ToSendMessage(cmd,arg,arg2);
		return;
	}

	if (cmd==SCD_OPEN) {
		if (*arg=='\0') {
			ClearAll();
			scd_opened="Untitled";
		} else {
			OpenText(arg);
			scd_opened=arg;
		}
	} else if (cmd==SCD_SAVEAS){
		CStdioFile p;
		p.Open(arg,CFile::modeCreate | CFile::modeWrite);
		Cstr textbuffer;
		GetBuffer(&textbuffer);
		p.WriteString(textbuffer.buf);
		//p.WriteString("\r\n");
		p.Close();
	}else if (cmd==SCD_CLOSE) {
		scd_opened="";
		//ClearAll();
	}else if (cmd==SCD_FIND) {
		SendMessage(SCI_SEARCHANCHOR);
		int p=SendMessage(SCI_SEARCHNEXT,0,(unsigned int)arg);
		//ClearAll();
	} else if (cmd==SCD_OUTPUTSIZE) {
		gMaindialog->treespace=(int)arg;
		if (gMaindialog->treespace<0) gMaindialog->treespace=0;
		if (gMaindialog->treespace>100) gMaindialog->treespace=100;
		gMaindialog->MoveWindows();
	}
	return;
}

/////////////////////////////////////////////////////////////////////
// Play/Record Start/Stop

void CSciCtrl::BeforePlay()
{
	if (curdocnum==VIEW2_SOURCE) {
		gMaindialog->UpdateViews(-1,VIEW2_OUTPUT);
	}
	SetFocus();
}

void CSciCtrl::AfterPlay()
{
	SetFocus();
}

void CSciCtrl::StartStopRecord(int start)
{
	int msg= (start ? SCI_STARTRECORD : SCI_STOPRECORD);
	SendMessage(msg);
}

//////////////////////////////////////////////////////////////////////
// Notifications


bool CSciCtrl::HandleNotification(LPARAM lParam)
{
	SCNotification * notif=(SCNotification *) lParam;
	
	if (!gPlaying) {
		if (notif->nmhdr.code==(unsigned int)SCN_MACRORECORD){
			Record(gCurmac,notif->message,notif->wParam,notif->lParam);
			return 1;
		}else if(notif->nmhdr.code==(unsigned int)SCN_CHARADDED){

			char * openings="([{\"'";
			char * closings=")]}\"'";
			char * ochr=strchr(openings,notif->ch);
			if (ochr!=NULL && gMaindialog->viewmode2==VIEW2_SOURCE) {
				if (auto_insertclosing!=0) {
					int cpos=GetCurPos();
					int c=SendMessage(SCI_GETCHARAT,cpos+1);
					if (!isprint(c) || isspace(c)) {
						char cchr[2];
						*cchr=closings[(char *)ochr-(char *)openings];
						*(cchr+1)='\0';
						SendMessage(SCI_REPLACESEL,  0,  (long)cchr);
						SendMessage(SCI_CHARLEFT);
					}
				}			
				if (notif->ch==(int)'(')
					ShowCallTip();
				return 1;
			} else if  (notif->ch  ==  '\n')  {
				char  linebuf[1000];
				int cpos=GetCurPos();
				int curLine=SendMessage(SCI_LINEFROMPOSITION,cpos);
				int  lineLength  =  SendMessage(SCI_LINELENGTH,  curLine);
				if  (curLine  >  0  &&  lineLength  <=  2)  {
					int  prevLineLength  =  SendMessage(SCI_LINELENGTH,  curLine  -  1);
					if  (prevLineLength  <  sizeof(linebuf))  {
						//WORD  buflen  =  sizeof(linebuf);
						//memcpy(linebuf,  &buflen,  sizeof(buflen));
						SendMessage(SCI_GETLINE,  curLine  -  1,(long)linebuf);
						linebuf[prevLineLength]  =  '\0';
						for  (int  pos  =  0;  linebuf[pos];  pos++)  {
							if  (linebuf[pos]  !=  ' '  &&  linebuf[pos]  !=  '\t')
							linebuf[pos]  =  '\0';
						}
						SendMessage(SCI_REPLACESEL,  0,  (long)linebuf);
					}
				}
			} else if (auto_autocomplete>0) {
				if (iscsym(notif->ch)) {
					if (!SendMessage(SCI_AUTOCACTIVE))
						AutoCShow(auto_autocomplete);
				}
			}
		} else if(notif->nmhdr.code==(unsigned int)SCN_MODIFIED && gMaindialog->viewmode2==VIEW2_SOURCE){
			if ((notif->modificationType & 3)!=0) {
				// Add or delete text
				gMaindialog->m_mactree.NotifDirty();

			}
		}
	}
	return 0;
}

char * CSciCtrl::GetWordBeg(int back,int * len)
{
	int cpos=GetCurPos()-back;
	int cpos0=cpos;
	*len=0;
	while (cpos>=0){
		int c=SendMessage(SCI_GETCHARAT,cpos);
		if (iscsym(c)){
			(*len)++;
			cpos--;
		}else
			break;
	}
	cpos++;
	char * tbuff=new char[*len+1];
	char * bptr=tbuff;
	while (cpos<=cpos0) {
		*bptr++=(char)SendMessage(SCI_GETCHARAT,cpos++);
	}
	*bptr='\0';
	return tbuff;
}


void CSciCtrl::ShowCallTip()
{
	int lenentered=0;
	char * kword=GetWordBeg(2,&lenentered);
	if (lenentered>0){ 
		char * ttip=GetToolTip(kword,gMacros);
		delete [] kword;
		if (*ttip!='\0')
			SendMessage(SCI_CALLTIPSHOW,GetCurPos(),(int)ttip);
		delete []ttip;
	}
}

int compare( const void *arg1, const void *arg2 )
{
   /* Compare all of both strings: */
   return lstrcmp( * ( char** ) arg1, * ( char** ) arg2 );
}



void CSciCtrl::AutoCShow(int wantchars)
{
	if (m_keywords==NULL) {
		char * words=GetMacroKeyWords(3);
		char ** ct=new char *[2000];
		int cnum=0;
		char * w=words;
		int maxl=0;
		char tbuf[100];
		char * tb;
		while (*w!='\0') {
			tb=tbuf;
			while (*w!=' ' && *w!='\0'){
				*tb++=*w++;
			}
			*tb='\0';
			ct[cnum]=new char[lstrlen(tbuf)+1];
			lstrcpy(ct[cnum],tbuf);
			cnum++;
			if (*w=='\0') break;
			w++;
		}
		qsort( (void *)ct, cnum, sizeof( char * ), compare );
		int cnnum=0;
		w=words;
		while (cnnum<cnum){
			lstrcpy(w,ct[cnnum]);
			w=w+lstrlen(ct[cnnum]);
			delete [] ct[cnnum];
			*w++=' ';
			cnnum++;
		}
		delete [] ct;
		*w++='\0';
		m_keywords=words;
	}
	int lenentered=0;
	char * wordbeg=GetWordBeg(1,&lenentered);
	if (lenentered>=wantchars){
		char * kw=m_keywords;
		while (kw!=NULL) {
			kw=strstr(kw,wordbeg);
			if (kw==NULL || kw==m_keywords) break;
			if (*(kw-1)==' ') break;
			while (*kw!=' ' && *kw!='\0') kw++;
		}
		if (kw!=NULL) {
			SendMessage(SCI_AUTOCSETIGNORECASE,true);
			SendMessage(SCI_AUTOCSHOW,lenentered,(int)m_keywords);
		}
	}
	delete [] wordbeg;
}

////////////////////////////////////////////////////////////////////////////
// Debugging




bool CSciCtrl::ShowExpr(macro * m, int * curpos)
{
	int cpos=*curpos;
	char * Xpression;
	char * xval=NULL;

	int send=SendMessage(SCI_GETSELECTIONEND);
	int sbeg=SendMessage(SCI_GETSELECTIONSTART);
	int l=send-sbeg;
	if (l>0) {
		// Evaluate selected expression
		Xpression=new char[l+1];
		SendMessage(SCI_GETSELTEXT,l+1,(long)Xpression);
		xval=GetValueOfExpr(m,Xpression);
	} else { 
		// Try to evaluate variable containing the caret
		Xpression=new char[100];
		char * kptr=Xpression;
		// find start of word
		while (cpos>0 && iscsym((char)SendMessage(SCI_GETCHARAT,cpos))) cpos--;
		cpos++;
		// copy word
		while(kptr-Xpression<99) {
			char c=(char)SendMessage(SCI_GETCHARAT,cpos);
			if (!iscsym(c)) break;
			*kptr++=c;
			cpos++;
		}
		*kptr='\0';
		*curpos=cpos;
		// evaluate
		xval=GetValueOf(m,Xpression);
	}

	// Show result in a tooltip
	SendMessage(SCI_CALLTIPCANCEL,0,0);
	bool tipshow=false;
	if (xval!=NULL) {
		Cstr tip(Xpression);
		tip+="=";
		int hltbeg=tip.len;
		tip+=xval;
		int hltend=tip.len;
		SendMessage(SCI_CALLTIPSHOW,cpos,(int)tip.buf);
		SendMessage(SCI_CALLTIPSETHLT,hltbeg,hltend);
		
		delete [] xval;
		tipshow=true;
	}
	delete [] Xpression;
	return tipshow;
}




bool CSciCtrl::FilerxDebug(macro * m,int debugline)
{
	// called by macro.dll in a debug thread
	// gKeyhit is set by CFilerDlg::PreTranslateMessage() or CFilerDlg::OnButtonxxxx()

	static macro * sLastmac;		// last debugged macro
	static int sLastline;			// last debugged line
	static int sLasttippos;			// last tooltip position
	static bool sAlreadyin=false;	// to avoid reentrant calls ...

	bool tostop=false;				// true when H(alt) key is hit
	bool dowait=true;				// true until H(alt), G(o), or S(tep) key is hit
	int isBreakPoint;				// return value of SendMessage(SCI_MARKERGET)

	int curpos;
	int cpos;						// temp curpos

	if (debugline==sLastline) return false;
	sLastline=debugline;
	
	if (sAlreadyin) return false;
	sAlreadyin=true;
	
	if (!gStepping) {
		for (int i=0;i<10;i++) {
			int bpline=m->breakpoints[i];
			if (m->breakpoints[i]==debugline) {
				gStepping=true;
				break;
			}
		}
		if (!gStepping) {
			sAlreadyin=false;
			return false;
		}
	}

	int olddoc=curdocnum;
	int newdoc=VIEW2_SOURCE;
	LockWindowUpdate();
	SendToDoc(VIEW2_SOURCE);

	// show breakpoint markers
	if (m!=sLastmac) {
		gMaindialog->m_mactree.DoDecompile(m);
		sLastmac=m;
		sLasttippos=-1;
		for (int i=0;i<10;i++) {
			int bpline=m->breakpoints[i];
			if (bpline!=-1)
				SendMessage(SCI_MARKERADD,bpline,BP_MARKER);
		}
	} 


	SetFocus();

	// show last tooltip
	if (m==sLastmac && sLasttippos!=-1){
		cpos=sLasttippos;
		ShowExpr(m,&cpos);
	}

	SendMessage(SCI_GOTOLINE,debugline);
	curpos=GetCurPos();
	SendMessage(SCI_SETCARETLINEVISIBLE,1);
	SendMessage(SCI_MARKERADD,debugline,IP_MARKER);
	UnlockWindowUpdate();

	// Main loop

	while (dowait) {
		// wait key ...
		while (gKeyhit==0) { 
			if (GetCurPos()!=curpos) {
				gKeyhit=-1;
			}
		}

		if (gKeyhit=='S') {
			dowait=false;
			gKeyhit=0;
		} else if (gKeyhit=='H') {
			tostop=true;
			dowait=false;
		} else if (gKeyhit=='G') {
			gStepping=false;
			sLastline=-1;
			dowait=false;
		} else if (gKeyhit=='O') {
			newdoc = (newdoc==VIEW2_SOURCE?olddoc:VIEW2_SOURCE);
			SendToDoc(newdoc);
		} else if (gKeyhit=='B') {
			int line=SendMessage(SCI_LINEFROMPOSITION,curpos);
			isBreakPoint=(SendMessage(SCI_MARKERGET,line,0) & (1<<BP_MARKER));
			if (isBreakPoint) {
				SendMessage(SCI_MARKERDELETE,line,BP_MARKER);
				for (int i=0;i<10;i++) {
					if (m->breakpoints[i]==line) {
						m->breakpoints[i]=-1;
						break;
					}
				}
			} else {
				for (int i=0;i<10;i++) {
					if (m->breakpoints[i]==-1) {
						SendMessage(SCI_MARKERADD,line,BP_MARKER);
						m->breakpoints[i]=line;
						break;
					}
				}
			}
		} else if (gKeyhit==VK_RIGHT) {
			SendMessage(SCI_CHARRIGHT,0,0);
		} else if (gKeyhit==VK_LEFT) {
			SendMessage(SCI_CHARLEFT,0,0);
		} else if (gKeyhit==VK_DOWN) {
			SendMessage(SCI_LINEDOWN);
		} else if (gKeyhit==VK_UP) {
			SendMessage(SCI_LINEUP);
		} else if (gKeyhit==VK_TAB) {
			curpos=GetCurPos();
			cpos=curpos;
			int textlen=SendMessage(SCI_GETLENGTH);
			bool wrapped=false;
			while (true) {
				if (ShowExpr(m,&cpos)!=NULL) {
					SendMessage(SCI_GOTOPOS,cpos-1);
					break;
				}
				if (cpos>=textlen) {
					wrapped=true;
					cpos=0;
				} else if (wrapped && cpos>=curpos)
					break;
				cpos++;
			}
		} else if (gKeyhit==-1) {
		} else
			gKeyhit=0;

		if (gKeyhit!=0) {
			curpos=GetCurPos();
			cpos=curpos;
			sLasttippos=curpos;
			ShowExpr(m,&cpos);
		}
		gKeyhit=0;
	}

	if (gStepping && !tostop)
		LockWindowUpdate();

	SendToDoc(VIEW2_SOURCE);
	SendMessage(SCI_CALLTIPCANCEL,0,0);
	SendMessage(SCI_MARKERDELETE,debugline,IP_MARKER);
	SendMessage(SCI_SETCARETLINEVISIBLE,0);
		
	SendToDoc(olddoc);
	
	sAlreadyin=false;
	return tostop;
}


void CSciCtrl::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	if (gStepping)	
		gKeyhit='B';
	else
		CWnd::OnLButtonDblClk(nFlags, point);
}

void CSciCtrl::GetState()
{
	state.curpos=GetCurPos();
	state.curline=SendMessage(SCI_LINEFROMPOSITION,state.curpos);
	state.selstart=SendMessage(SCI_GETSELECTIONSTART);
	state.selend=SendMessage(SCI_GETSELECTIONEND);
	state.canundo=SendMessage(SCI_CANUNDO);
	state.canredo=SendMessage(SCI_CANREDO);
	state.anchor=SendMessage(SCI_GETANCHOR);
	state.canpaste=SendMessage(SCI_CANPASTE);
	state.havesel=(state.curpos!=state.anchor);
}


void CSciCtrl::doSaveScript()
{
	CFileDialog fd(false,0,(LPCTSTR)luacurrentscript);
	if (fd.DoModal()==IDOK){
		CStdioFile p;
		p.Open((const char *)fd.GetPathName(),CFile::modeCreate | CFile::modeWrite | CFile::typeBinary );
		Cstr textbuffer;
		GetBuffer(&textbuffer);
		p.WriteString(textbuffer.buf);
		p.Close();
		lstrcpy(luacurrentscript,(const char *)fd.GetPathName());
	}
}
void CSciCtrl::doLoadScript()
{
	gMaindialog->ToSendMessage(SCD_LOADSCRIPT,luacurrentscript);
}

void CSciCtrl::doScriptSelection()
{
	int send=SendMessage(SCI_GETSELECTIONEND);
	int sbeg=SendMessage(SCI_GETSELECTIONSTART);
	int l=send-sbeg;
	if (l>0) {
		char * Xpression=new char[l+20];
		lstrcpy(Xpression,"dostring ");
		SendMessage(SCI_GETSELTEXT,l+1,(long)Xpression+lstrlen(Xpression));
		gMaindialog->ToSendMessage(SCD_EXTENDER,Xpression);
		delete [] Xpression;
	}
}

#define CUSTOM_MENU 10000

void CSciCtrl::HandleMenu(int rep)
{
	int code=0;
	if (rep>=CUSTOM_MENU) {
		int send=SendMessage(SCI_GETSELECTIONEND);
		int sbeg=SendMessage(SCI_GETSELECTIONSTART);
		int l=send-sbeg;
		if (l>=0) {
			char * Xpression=new char[l+1];
			*Xpression='\0';
			SendMessage(SCI_GETSELTEXT,l+1,(long)Xpression);
			gMaindialog->RunMenuMacro(Xpression);
			delete [] Xpression;
		}
		return;
	}

	switch (rep){
		case IDS_SAVESCRIPTAS:
			doSaveScript();
			break;
		case IDS_LOADSCRIPT:
			doLoadScript();
			break;
		case IDS_SCRIPTSELECTION:
			doScriptSelection();
			break;
		case IDS_UNDO:
			code=SCI_UNDO;
			break;
		case IDS_REDO :
			code=SCI_REDO;
			break;
		case IDS_CUT :
			code=SCI_CUT;
			break;
		case IDS_COPY :
			code=SCI_COPY;
			break;
		case IDS_PASTE :
			code=SCI_PASTE;
			break;
		case IDS_CLEAR:
			code=SCI_CLEAR;
			break;
		case IDS_SELECTALL:
			code=SCI_SELECTALL;
			break;
	}
	if (code!=0)
		SendMessage(code);
}