// ShortcutDlg.cpp : implementation file
//

#include "stdafx.h"
#ifdef _MINI
#include "MiniFilx/MiniFilxx.h"
#endif
#include "common/macro.h"
#include "ShortcutDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern macro * gMacros;
/////////////////////////////////////////////////////////////////////////////
// CShortcutDlg dialog


CShortcutDlg::CShortcutDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CShortcutDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CShortcutDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_cod=0;
	m_mod=0;
	macroshortcut=0;
}


void CShortcutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CShortcutDlg)
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CShortcutDlg, CDialog)
	//{{AFX_MSG_MAP(CShortcutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CShortcutDlg message handlers

void CShortcutDlg::OnOK() 
{
	CDialog::OnOK();
	m_hk->GetHotKey(m_cod,m_mod);
	macroshortcut=m_cod + (m_mod <<16);
}

void CShortcutDlg::OnCancel() 
{
	CDialog::OnCancel();
}

BOOL CShortcutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	m_hk=(CHotKeyCtrl *)GetDlgItem(IDC_HOTKEY_DLG);
	wok=(CWnd *)GetDlgItem(IDOK);
	wok->EnableWindow(!m_execute);
	m_hk->SetHotKey(LOWORD(m_shortcut),HIWORD(m_shortcut));
	m_hk->SetFocus();
	SetForegroundWindow();
	CenterWindow(GetDesktopWindow());
	SetWText(m_name);
	g_hwndTT=0;
	ttip.Create(this);
	g_hwndTT=ttip.m_hWnd;
	m_scod=-1;
	m_smod=-1;
	ShowMacList(true);
	return FALSE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CShortcutDlg::SetWText(const char * s)
{
	char * tex1="Execute";
	char * tex2=" : ";
	char *ss=(char *)s;
	if (s==NULL) ss="";
	
	char * cbuf = new char[30+lstrlen(ss)];
	if (*ss=='\0')
			tex2="...";
	if (!m_execute)
		tex1="Shortcut for";
	sprintf(cbuf,"%s Macro%s%s",tex1,tex2,ss);
	SetWindowText(cbuf);
	delete [] cbuf;
}

void CShortcutDlg::ShowMacList(bool init)
{
#define ID_TT 1
	WORD cod;
	WORD mod;
	m_hk->GetHotKey(cod,mod);
	if ((cod!=m_scod) || (mod!=m_smod)) {
		m_scod=cod;
		m_smod=mod;
		char * lpfx="\n     ";
		Cstr slist(2000);
		slist="     ";
		slist+=GetMName(mod & 7);
		slist+=lpfx;
		slist+="--------\n";
		macro * m=gMacros;
		bool skexists=false;
		while (m!=NULL){
			if ((m->flags & erased_macro)==0) {
				WORD hh=HIWORD(m->shortcut);
				WORD ll=LOWORD(m->shortcut);
				if ((hh & 7)==(mod & 7) && m->shortcut!=0) {
					Cstr thiskey(GetKName(ll,hh & 8));
					thiskey+=" = ";
					thiskey+=m->name;
					if (ll==cod) { 
						skexists=true;
						slist+="\n>> ";
						if (m_execute)
							SetWText(m->name);
					} else {
						slist+=lpfx;
					}
					slist+=thiskey;
				}
			}
			m=m->next;
		}
		if (m_execute && !skexists)
			SetWText("");

		bool enableok= ((skexists && m_execute) || (!skexists && !m_execute));
		wok->EnableWindow(enableok);

		CRect r;
		this->GetWindowRect(&r);

		TOOLINFO ti; 
		ti.rect.right =r.right;
		ti.rect.top = r.top;
		ti.rect.bottom =r.bottom;
		ti.rect.left =r.left;
		ti.cbSize = sizeof(TOOLINFO); 
		ti.uFlags = TTF_TRACK | TTF_ABSOLUTE; 
		ti.hwnd = this->m_hWnd;
		ti.uId = ID_TT; 
		ti.hinst = 0; 
		ti.lpszText = " "; 
		if (init) {
			::SendMessage(g_hwndTT, TTM_ADDTOOL, 0, (LPARAM) &ti); 
			::SendMessage(g_hwndTT, TTM_SETMAXTIPWIDTH, 0, (LPARAM) SHRT_MAX); 
			RECT margrect={3,3,3,3};
			ttip.SetMargin(&margrect);
			::SendMessage(g_hwndTT, TTM_TRACKPOSITION, 0, (LPARAM) MAKELONG(-1000, -1000)); 
			ttip.Activate(true);
		}
		ttip.UpdateTipText(slist.buf,this,ID_TT);
		::SendMessage(g_hwndTT,TTM_TRACKACTIVATE,(WPARAM)TRUE,(LPARAM)&ti);
		RECT ttr;
		::GetWindowRect(g_hwndTT,&ttr);
		int tty=(r.top+r.bottom)/2-(ttr.bottom-ttr.top)/2;
		::SendMessage(g_hwndTT, TTM_TRACKPOSITION, 0, (LPARAM)MAKELONG(r.right+10, tty)); 
	}
}

BOOL CShortcutDlg::OnCommand(WPARAM wParam, LPARAM lParam) 
{
	if (LOWORD(wParam)==IDC_HOTKEY_DLG)
		ShowMacList(false);
		
	return CDialog::OnCommand(wParam, lParam);
}

