// ToolDlg.cpp : implementation file
//

#include "stdafx.h"
#include "inifile.h"
#include "common/macro.h"
#include "SciCtrl.h"
#include "TreeCtrl_proj.h"
#include "ListCtrl.h"
#include "TreeCtrl_file.h"
#include "TreeCtrl_prop.h"
#include "TreeCtrl_mac.h"
#include "TreeCtrl_tlb.h"
#include "FilerDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


extern CFilerDlg * gMaindialog;
extern char * gMacrobarpath;
extern char * gPathtoshow;
extern CImgList * gImgList;
extern macro * gMacros;

static char * sBartitle="Macro Bar";
static char * sEditorbartitle="Macro Bar Editor";


#define xpos props[0]
#define ypos props[1]
#define ontop props[2]
#define havicons props[3]
#define ibcols props[4]
#define ibuttonw props[5]
#define ibuttonh props[6]
#define tbcols props[7]
#define tbuttonw props[8]
#define tbuttonh props[9]

#define ibw eprops[5]
#define ibh eprops[6]
#define tbw eprops[8]
#define tbh eprops[9]


bool isprop(const char *text)
{
	int i=0;
	while (i<=propmax) {
		if (!strcmp(text,barprops[i])) return true;
		i++;
	}
	return false;
}

/////////////////////////////////////////////////////////////////////////////
// CToolButton

void CToolButton::BuildCompleteName()
{
	completename=name;
	if (subname.len!=0) {
		completename+="!";
		completename+=subname;
	}
}


/////////////////////////////////////////////////////////////////////////////
// CToolDlg dialog


CWnd * tbutt;

CToolDlg::CToolDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CToolDlg::IDD, pParent)
{

	buttons=NULL;
	bcount=0;
	lines=0;
	cols=0;
	noresize=true;
	editing=false;

	//{{AFX_DATA_INIT(CToolDlg)
	//}}AFX_DATA_INIT
}


void CToolDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CToolDlg)
	DDX_Control(pDX, IDC_BUTTON_DIM, m_dim);
	DDX_Control(pDX, IDC_BUTTON_TEXT, m_buttontext);
	DDX_Control(pDX, IDC_SLIDER_WT, m_slider);
	DDX_Control(pDX, IDC_BUTTON_ICON, m_buttonicon);
	DDX_Control(pDX, IDC_BUTTON_SAVE, m_save);
	DDX_Control(pDX, IDC_BUTTON_EXIT, m_exit);
	DDX_Control(pDX, IDC_STATIC_ARGS, m_staticargs);
	DDX_Control(pDX, IDC_STATIC_BAR, m_staticbar);
	DDX_Control(pDX, IDC_STATIC_MACROS, m_staticmacros);
	DDX_Control(pDX, IDC_LIST_MACROS, m_listmacros);
	DDX_Control(pDX, IDC_EDIT_ARGS, m_editargs);
	DDX_Control(pDX, IDC_BUTTON_UP, m_up);
	DDX_Control(pDX, IDC_BUTTON_REMOVE, m_remove);
	DDX_Control(pDX, IDC_BUTTON_DOWN, m_down);
	DDX_Control(pDX, IDC_BUTTON_ADD, m_add);
	DDX_Control(pDX, IDC_STATIC_SUBNAME, m_staticsubname);
	DDX_Control(pDX, IDC_STATIC_ICON, m_staticicon);
	DDX_Control(pDX, IDC_LIST_ICONS, m_listicons);
	DDX_Control(pDX, IDC_LIST_BUTTONS, m_listbuttons);
	DDX_Control(pDX, IDC_EDIT_SUBNAME, m_editsubname);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CToolDlg, CDialog)
	//{{AFX_MSG_MAP(CToolDlg)
	ON_WM_SIZE()
	ON_WM_NCRBUTTONDOWN( )
	ON_WM_NCLBUTTONDBLCLK( )
	ON_WM_CREATE()
	ON_LBN_SELCHANGE(IDC_LIST_BUTTONS, OnSelchangeListButtons)
	ON_BN_CLICKED(IDC_BUTTON_ADD, OnButtonAdd)
	ON_BN_CLICKED(IDC_BUTTON_REMOVE, OnButtonRemove)
	ON_BN_CLICKED(IDC_BUTTON_UP, OnButtonUp)
	ON_BN_CLICKED(IDC_BUTTON_DOWN, OnButtonDown)
	ON_BN_CLICKED(IDC_BUTTON_EXIT, OnButtonExit)
	ON_BN_CLICKED(IDC_BUTTON_SAVE, OnButtonSave)
	ON_EN_CHANGE(IDC_EDIT_SUBNAME, OnChangeEditSubname)
	ON_EN_CHANGE(IDC_EDIT_ARGS, OnChangeEditArgs)
	ON_NOTIFY(NM_DBLCLK, IDC_LIST_ICONS, OnDblclkListIcons)
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_BUTTON_DIM, OnButtonDim)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CToolDlg message handlers


int CToolDlg::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CDialog::OnCreate(lpCreateStruct) == -1)
		return -1;
	origwidth=lpCreateStruct->cx;
	origheight=lpCreateStruct->cy;
	return 0;
}


BOOL CToolDlg::OnInitDialog()
{
	tooltip.Create(this);
	tooltip.SetMaxTipWidth(SHRT_MAX); // to allow multiline tooltips
	tooltip.SetDelayTime(200);
	CDialog::OnInitDialog();
	tbutt=GetDlgItem(IDC_BUTTON1);
	ShowEditControls(false);

	return TRUE;  // return TRUE unless you set the focus to a control
}

CToolButton * CToolDlg::GetButtonOf(int index)
{
	return (CToolButton *)(m_listbuttons.GetItemData(index));
}

void CToolDlg::GetTextOf(int index,Cstr * s)
{
	s->resize(m_listbuttons.GetTextLen(index));
	m_listbuttons.GetText(index,s->buf);
}

void CToolDlg::GetIni(bool editing)
{
	int *t=(editing ? eprops: props);
	for (int i=0;i<=propmax;i++) {
		t[i]=GetIniMacrobarInt(barprops[i],bardefaults[i]);
	}
}

void CToolDlg::SetIni(bool editing)
{
	int *t=(editing ? eprops: props);
	for (int i=0;i<=propmax;i++) {
		SetIniMacrobarInt(barprops[i],t[i]);
	}
	xpossave=xpos;
	ypossave=ypos;
}


void CToolDlg::ReBuildBar(int change,char * path/*=NULL*/)
{
	DeleteButtons();
	switch(change) {
		case BAR_CHANGE_NOTHING : break;
		case BAR_CHANGE_ONTOP :	SetIniMacrobarInt(prop_ontop_,!ontop);break;
		case BAR_CHANGE_HAVICONS : SetIniMacrobarInt(prop_have_icons_,!havicons);break;
		case BAR_CHANGE_EDITOR : EditBar(); break;
		case BAR_CHANGE_PATH :lstrcpy(gMacrobarpath,path); break;
	}
	AddButtons();
}


void CToolDlg::AddButtons(bool firstin/*=false*/)
{
	GetIni(editing);
	m_listbuttons.ResetContent();
	if (editing) {
		dimmode=0;
		SetDimButton(0);
	} else {
		buttonh= (havicons!=0 ? &ibuttonh : &tbuttonh);
		buttonw= (havicons!=0 ? &ibuttonw : &tbuttonw);
		bcols= (havicons!=0 ? &ibcols : &tbcols);
	}

	CIniSection * inisec=new CIniSection(SECTION_MACROBAR);
	while (inisec->GetNextKey()) {
		char * completekey=inisec->key;
		char * subend=completekey;
		char * subname;
		while((*subend)!='!' && (*subend)!='\0') subend++;
		if (*subend=='!') *subend++='\0';
		subname=subend;
		macro * m=gMaindialog->m_mactree.FindMacroByName(inisec->key);
		if (m!=NULL) {
			AddOneButton(inisec->key,subname);
			if (editing) {
				int index=m_listbuttons.AddString(buttons->completename.buf);			
				m_listbuttons.SetItemData(index,(unsigned long)buttons);
			}
		}
	}
	delete inisec;

	if (!editing) {
		int borderx=2*GetSystemMetrics(SM_CXSIZEFRAME);
		int bordery=GetSystemMetrics(SM_CYSMCAPTION)+2*GetSystemMetrics(SM_CYSIZEFRAME);
		
		noresize=true;
		if ((*bcols)*lines==bcount) lines--;
		const CWnd * wp = (ontop ? &wndTopMost : &wndNoTopMost);
		if (!firstin) {
			xpos=xpossave;
			ypos=ypossave;
		}
		SetWindowPos(wp,xpos,ypos,(*bcols)*(*buttonw)+borderx,(lines+1)*(*buttonh)+bordery,SWP_SHOWWINDOW);
		tooltip.Activate(havicons);
		gMaindialog->m_proptree.ReloadIni();
	} else {
		if (gMaindialog->m_tree.selNode!=NULL)
			gMaindialog->m_list.DisplayList(gMaindialog->m_tree.selNode);

		if (m_listbuttons.GetCount()>0)
			m_listbuttons.SetCurSel(0);
		OnSelchangeListButtons(); 
	}
}

void CToolDlg::AddOneButton(char * name,char * subname, bool fromedit/*=false*/)
{
	Cstr tmp;
	CToolButton * b=new CToolButton;
	b->name=name;
	b->subname=subname;
	b->BuildCompleteName();
	Cstr * cininame=&b->completename;
	char * ininame=cininame->buf;
	if (!fromedit) {
		GetIniMacrobarString(cininame,&tmp);
		b->iconpath=tmp;
		GetIniMacrobarString(cininame,&tmp,1);
		b->args=tmp;
	} else {
		b->iconpath="";
		b->args="";
	}

	b->buttonid=0;
	b->next=buttons;
	b->prev=NULL;
	if (buttons!=NULL) buttons->prev=b;
	buttons=b;
	
	if (!editing) {
		RECT r;

		r.left=cols*(*buttonw);
		r.top=lines*(*buttonh);
		r.right=r.left+(*buttonw);
		r.bottom=r.top+(*buttonh);
		b->buttonid=bcount+10000;


		if (havicons) {
			b->Create("",BS_PUSHBUTTON | BS_ICON | WS_VISIBLE | WS_CHILD,r,this,b->buttonid);
			HICON h=(HICON)LoadImage(0,b->iconpath.buf,IMAGE_ICON,16,16,LR_LOADFROMFILE);
			if (h==NULL) h=FlxLoadIcon(IDI_ICON_NEWMACRO);
			b->SetIcon(h);
		} else {
			b->Create(ininame,WS_VISIBLE | WS_CHILD | WS_TABSTOP,r,this,b->buttonid);
			b->SetFont(tbutt->GetFont());
		}
		if (*subname!='\0')
			*(ininame+b->name.len)='\n';
		tooltip.AddTool((CWnd *)b,ininame);
		if (*subname!='\0')
			*(ininame+b->name.len)='!';
	}
	bcount++;
	cols++;
	if (cols==(*bcols)) {
		cols=0;
		lines++;
	}
}


void CToolDlg::DeleteButtons()
{
	CToolButton * b=buttons;
	while (b!=NULL) {
		CToolButton * bnext=b->next;
		if (!editing)
			tooltip.DelTool((CWnd *) b,b->buttonid);
		delete [] b;
		b=bnext;
	}
	bcount=0;
	buttons=NULL;
	lines=0;
	cols=0;

	if (!editing) {
		CRect wrect;
		GetWindowRect(&wrect);
		xpos=wrect.left;
		ypos=wrect.top;
		SetIni(false);
	}
}



void CToolDlg::AddToMacroBar(const char * mname0)
{
	Cstr gotname("");
	Cstr mnam0(mname0);
	Cstr mname(mname0);
	int subnum=1;
	GetIniMacrobarString(&mname,&gotname);
	while (gotname!="_?_") {
		subnum++;
		mname=mnam0;
		mname+="!";
		mname+=subnum;
		GetIniMacrobarString(&mname,&gotname);
	}
	SetIniMacrobarString(&mname,"");
	ReBuildBar(BAR_CHANGE_NOTHING); //Redraw with one more button
}


BOOL CToolDlg::OnCommand(WPARAM wParam, LPARAM lParam)
{
	if (!editing) {
		int bnum=LOWORD(wParam);
		CToolButton * b=buttons;
		while (b!=NULL) {
			if (b->buttonid==bnum) break;
			b=b->next;
		}
		if (b!=NULL) {
			char * mname=b->name.buf;
			macro * m=gMaindialog->m_mactree.FindMacroByName(mname);
			if (m!=NULL){
				if (m->flags==3 || m->flags==5) {
					gMaindialog->RunMacroWithArgs(mname,b->args.buf);					
				} else {
					gMaindialog->PlayMacro(mname);
				}
			}
		}
	}
	return CDialog::OnCommand(wParam, lParam);
}

BOOL CToolDlg::PreTranslateMessage(MSG* pMsg)
{
	if (havicons)
		tooltip.RelayEvent(pMsg);
	if (pMsg->message == WM_KEYDOWN &&
       pMsg->wParam == VK_ESCAPE) {
			return TRUE; //<Escape> won't close ...
	}

	return CDialog::PreTranslateMessage(pMsg);
}

void CToolDlg::OnNcRButtonDown( UINT nHitTest, CPoint point )
{
	if (!editing) 
		gMaindialog->DoToolBarMenu(point,ontop,havicons);
}

void CToolDlg::OnNcLButtonDblClk( UINT nHitTest, CPoint point )
{
	// Take next bar path in Filerx.ini

	bool takenext=false;
	char * newbarpath=NULL;
	char * firstbar=NULL;

	CIniSection * inisec=new CIniSection(SECTION_MACROBARMENU);
	while (inisec->GetNextKey()) {
		if (firstbar==NULL)
			firstbar=inisec->value;
		if (takenext) {
			newbarpath=inisec->value;
			break;
		}
		if (!stricmp(gMacrobarpath , inisec->value))
			takenext=true;
	}
	if (takenext && (newbarpath==NULL))
		newbarpath=firstbar;
	if (newbarpath!=NULL)
		ReBuildBar(BAR_CHANGE_PATH,newbarpath);
	delete inisec;
}



void CToolDlg::OnSize(UINT nType, int cx, int cy)
{
	if (!noresize && !editing) {
		CToolButton * b=buttons;
		if (bcount!=0 && ::IsWindow(b->m_hWnd) && cx>(*buttonw)) {
			cols=(int)(cx/(*buttonw));
			lines=(int)(bcount/cols);
			if (lines*cols!=bcount) lines++;
			while (b!=NULL) {
				if (b->next==NULL) break;
				b=b->next;
			}
			CRect r;
			int c=0;
			int l=0;
			int lmarg=(cx-cols*(*buttonw))/2;
			while (b!=NULL) {
				r.left=c*(*buttonw);
				r.top=l*(*buttonh);
				r.right=r.left+(*buttonw);
				r.bottom=r.top+(*buttonh);
				b->MoveWindow(&r);
				c++;
				if (c==cols) {
					c=0;
					l++;
				}
				b=b->prev;
			}
			*bcols=cols;
		}
	} else
		noresize=false;
	CDialog::OnSize(nType, cx, cy);
}

void CToolDlg::DropItemFromList (CWnd * w)
{
	if (havicons) {
		CToolButton * b=(CToolButton *) w;
		char icopath[MAX_PATH];
		gMaindialog->m_list.GetFirstSelectedPath(icopath);
		b->BuildCompleteName();
		SetIniMacrobarString(&b->completename,icopath);
		HICON h=(HICON)LoadImage(0,icopath,IMAGE_ICON,16,16,LR_LOADFROMFILE);
		if (h==NULL) h=FlxLoadIcon(IDI_ICON_NEWMACRO);
		b->SetIcon(h);
		SetWindowText(sBartitle);
		gMaindialog->m_proptree.ReloadIni();
	}
}

void CToolDlg::SetDropMark(CPoint pt)
{
	CWnd * w=WindowFromPoint (pt);
	if (w->GetParent() != (CWnd *) this) {
		SetWindowText(sBartitle);
		return;
	}
	if (havicons) {
		w->SetFocus();
		SetWindowText(((CToolButton *)w)->name.buf);
		SetCursor(gMaindialog->m_ptree.m_hcurDrag);
	}
}

///////////////////////////////////////////////////////////////////////
//

BOOL CALLBACK EnumChildProc(HWND h,LPARAM show)
{
	if (h!=tbutt->m_hWnd)
		ShowWindow(h,show);
	return true;
}

void CToolDlg::ShowEditControls(bool show)
{
	EnumChildWindows(this->m_hWnd,EnumChildProc,(show ? SW_SHOW : SW_HIDE));
}

void CToolDlg::EditBar()
{
	char * btitle;
	editing=!editing;
	ShowEditControls(editing);
	if (!editing) {
		m_listicons.DeleteAllItems();
		btitle=sBartitle;
	} else {
		gMaindialog->UpdateViews(VIEW_FILES,VIEW2_FILES);
		m_listicons.SetImageList(gImgList, LVSIL_SMALL);
		const CWnd * wp = (ontop ? &wndTopMost : &wndNoTopMost);
		SetWindowPos(wp,0,0,origwidth,origheight,SWP_SHOWWINDOW | SWP_NOMOVE);
		m_listmacros.ResetContent();
		macro * m=gMacros;
		while (m!=NULL) {
			m_listmacros.AddString(m->name);
			m=m->next;
		}
		SetDimButton(0);
		btitle=sEditorbartitle;
	}
	SetWindowText(btitle);
}


void CToolDlg::OnSelchangeListButtons() 
{
	int selindex = m_listbuttons.GetCurSel();
	if (selindex!=LB_ERR) {
		Cstr selname;
		GetTextOf(selindex,&selname);
		CToolButton * tb=GetButtonOf(selindex);
		if (*selname.buf!='\0') {
			lstrcpy(gPathtoshow,tb->iconpath.buf);
			if (*gPathtoshow!='\0')
				gMaindialog->TryToShowPath();
			m_staticicon.SetWindowText(tb->iconpath.buf);
			m_editsubname.SetWindowText(tb->subname.buf);
			m_editargs.SetWindowText(tb->args.buf);
			HANDLE h=LoadImage(0,tb->iconpath.buf,IMAGE_ICON,16,16,LR_LOADFROMFILE);
			if (h!=NULL)
				m_buttonicon.SetIcon((HICON)h);
			else
				m_buttonicon.SetIcon(NULL);
			m_buttontext.SetWindowText(tb->name.buf);
		}
	}
}

void CToolDlg::OnButtonAdd() 
{
	int selindex = m_listmacros.GetCurSel();
	if (selindex!=LB_ERR) {
		int slen=m_listmacros.GetTextLen(selindex);
		char * selname=new char [slen+1];
		m_listmacros.GetText(selindex,selname);
		int subn=1;
		Cstr bname=selname;
		Cstr subname="";
		while(m_listbuttons.FindString(-1,bname.buf)!=LB_ERR) {
			subn++;
			subname=subn;
			bname=selname;
			bname+="!";
			bname+=subname;
		}
		int index=m_listbuttons.AddString(bname.buf);
		AddOneButton(selname,subname.buf,true);
		m_listbuttons.SetItemData(index,(unsigned long)buttons);
		m_listbuttons.SetCurSel(index);
		OnSelchangeListButtons();
	}
}

void CToolDlg::OnButtonRemove() 
{
	int selindex = m_listbuttons.GetCurSel();
	if (selindex!=LB_ERR) {
		CToolButton * tb=GetButtonOf(selindex);
		if (tb==buttons) buttons=tb->next;
		CToolButton * tbnext=tb->next;
		CToolButton * tbprev=tb->prev;
		delete [] tb;
		m_listbuttons.DeleteString(selindex);
		if (tbprev!=NULL) tbprev->next=tbnext;
		if (tbnext!=NULL) tbnext->prev=tbprev;
		if (selindex>=m_listbuttons.GetCount()) selindex--;
		m_listbuttons.SetCurSel(selindex);
	}
}

void CToolDlg::MoveListItem(int selindex,int move)
{
	Cstr ctmpname;
	GetTextOf(selindex,&ctmpname);
	int tmpdata=(int)GetButtonOf(selindex);
	m_listbuttons.DeleteString(selindex);
	m_listbuttons.InsertString(selindex+move,ctmpname.buf);
	m_listbuttons.SetItemData(selindex+move,tmpdata);
	m_listbuttons.SetCurSel(selindex+move);
}

void CToolDlg::OnButtonUp() 
{
	int selindex = m_listbuttons.GetCurSel();
	if (selindex!=LB_ERR) {
		if (selindex>0) 
			MoveListItem(selindex,-1);
	}	
}

void CToolDlg::OnButtonDown() 
{
	int selindex = m_listbuttons.GetCurSel();
	if (selindex!=LB_ERR) {
		if (selindex<m_listbuttons.GetCount()-1) 
			MoveListItem(selindex,+1);
	}	
}

void CToolDlg::OnButtonExit() 
{
	ReBuildBar(BAR_CHANGE_EDITOR);
}


void CToolDlg::OnButtonSave() 
{

	WriteIniSection(SECTION_MACROBAR,"\0\0");
	SetIni(true);

	int count=m_listbuttons.GetCount();
	int index=0;
	Cstr ciname;
	while (index<count) {
		CToolButton * tb=GetButtonOf(index);
		GetTextOf(index,&ciname);
		SetIniMacrobarString(&ciname,tb->iconpath.buf);
		if (tb->args.len!=0)
			SetIniMacrobarString(&ciname,tb->args.buf,1);
		index++;
	}
	ReBuildBar(BAR_CHANGE_EDITOR);
}

void CToolDlg::OnChangeEditSubname() 
{
	int selindex = m_listbuttons.GetCurSel();
	if (selindex!=LB_ERR){
		CToolButton * tb=GetButtonOf(selindex);
		char newsubname[200];
		m_editsubname.GetWindowText(newsubname,199);
		tb->subname=newsubname;
		tb->BuildCompleteName();
		m_listbuttons.DeleteString(selindex);
		m_listbuttons.InsertString(selindex,tb->completename.buf);
		m_listbuttons.SetItemData(selindex,(int)tb);
		m_listbuttons.SetCurSel(selindex);
	}	
}

void CToolDlg::OnChangeEditArgs() 
{
	int selindex = m_listbuttons.GetCurSel();
	if (selindex!=LB_ERR){
		CToolButton * tb=GetButtonOf(selindex);
		int ltext= m_editargs.GetWindowTextLength();
		tb->args.resize(ltext);
		tb->args.len=ltext;
		m_editargs.GetWindowText((char *)tb->args.buf,ltext);
	}
}


void CToolDlg::OnDblclkListIcons(NMHDR* pNMHDR, LRESULT* pResult) 
{
	int selindex = m_listbuttons.GetCurSel();
	if (selindex!=LB_ERR){
		NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
		int index = ((NM_LISTVIEW *)pNMHDR)->iItem;
		char file [MAX_PATH+1];
		m_listicons.GetItemText(index,0,(char *)file,MAX_PATH);
		char * dir=gMaindialog->m_tree.selNode->m_strPath;
		CToolButton * tb=GetButtonOf(selindex);
		tb->iconpath=Cstr(dir);
		tb->iconpath+="\\";
		tb->iconpath+=file;
		m_staticicon.SetWindowText(tb->iconpath.buf);
		HANDLE h=LoadImage(0,tb->iconpath.buf,IMAGE_ICON,16,16,LR_LOADFROMFILE);
		if (h!=NULL)
			m_buttonicon.SetIcon((HICON)h);
		else
			m_buttonicon.SetIcon(NULL);
	}
	*pResult = 0;
}

static void SetBSize(CButton* wnd,int w,int h)
{
	wnd->SetWindowPos(0,0,0,w,h,SWP_NOMOVE | SWP_SHOWWINDOW );
}

void CToolDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	if (pScrollBar==(CScrollBar *) &m_slider) {
		if (nSBCode==TB_THUMBPOSITION || nSBCode==TB_THUMBTRACK) {
			switch(dimmode) {
				case 0 :tbw=nPos;break;
				case 1 :tbh=nPos;break;
				case 2 :ibw=nPos;break;
				case 3 :ibh=nPos;break;
				case 4 :ibw=nPos;ibh=ibw;break;
			}
			if (dimmode>1)			
				SetBSize(&m_buttonicon,ibw,ibh);
			else
				SetBSize(&m_buttontext,tbw,tbh);
		}
	}
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CToolDlg::SetDimButton(int dmode)
{
	int wmin=16;
	int wmax=50;
	int spos;
	char * label;
	switch (dmode) {
		case 0 :label="Text Width";spos=tbw;wmin=50;wmax=250;break;
		case 1 :label="Text Height";spos=tbh;break;
		case 2 :label="Icon Width";spos=ibw;break;
		case 3 :label="Icon Height";spos=ibh;break;
		case 4 :label="Icon Size";spos=ibw;break;
	}
	dimmode=dmode;

	m_slider.SetRange(wmin,wmax);
	m_slider.SetPos(spos);
	m_dim.SetWindowText(label);
	SetBSize(&m_buttonicon,ibw,ibh);
	SetBSize(&m_buttontext,tbw,tbh);
}

void CToolDlg::OnButtonDim() 
{
	SetDimButton(dimmode==4 ? 0 :dimmode+1);
}

void CToolDlg::Synchronize(LVFINDINFO * lvf)
{
	if (editing) {
		int efound=m_listicons.FindItem(lvf);
		if (efound>=0){
			m_listicons.SetItemState(efound,LVIS_SELECTED ,LVIS_SELECTED );
			m_listicons.EnsureVisible(efound,0);
		}
	}
}

void CToolDlg::DisplayIconList(TreeNode * flist)
{
	if (editing) {
		m_listicons.DeleteAllItems();

		TreeNode* p=flist;
		while (p!=NULL) {
			char * name=p->m_strName;
			if (IsIcon(name))
				m_listicons.InsertItem(0,name,p->m_icon);
			p=p->m_next;
		}		
	}
}

