#if !defined(AFX_FILERTREE_H__A7295F22_BABD_11D6_946A_A5F949ED9801__INCLUDED_)
#define AFX_FILERTREE_H__A7295F22_BABD_11D6_946A_A5F949ED9801__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// TreeCtrl.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CFilerTree window

struct pitemstruct{
	int type;
	bool dirty;
};


class CFilerTree : public CTreeCtrl
{
// Construction
public:
	CFilerTree();
	~CFilerTree();

// Attributes
public:
	int tree_type;
	HTREEITEM hRoot;
	bool checkdirty;

	//Drag and Drop
	bool m_bDragging;
	HTREEITEM m_hDropItem;
	HTREEITEM m_hDragItem;
	HCURSOR m_hcurOld;
	HCURSOR m_hcurNodrop;
	HCURSOR m_hcurDragCopy;
	HCURSOR m_hcurDrag;
	CImageList* m_pDragImage;
	CWnd*		m_pDropWnd;
	UINT    m_nTimerID;
	CPoint m_TimerPoint;

	//Selected Item
	HTREEITEM hSelected;
	char hSelectedText[MAX_PATH];
	char hSelectedPath[MAX_PATH];
	int hSelectedType;
	// item text buffer
	Cstr itextbuff;
	
// Implementation
public:
	char * GetItText(HTREEITEM h,char * txt=NULL);
	/////////////////////////
	//Overloadable
	virtual bool mayDrag(HTREEITEM h) {return false;};
	virtual bool mayDropAfter(HTREEITEM h) {return false;};
	virtual bool mayDropInto(HTREEITEM h) {return false;};

	virtual void doOnExpand(HTREEITEM hItem) {};
	virtual void doOnSelchanged(HTREEITEM itemOld, HTREEITEM itemNew) {};
	virtual void doOnEndlabeledit(HTREEITEM selitem,char * newtext) {};
	virtual void doOnDblclk(HTREEITEM selitem) {};
	
	virtual void doDropItem() {};
	virtual void CleanItemData(HTREEITEM h,bool del=true);
	virtual void cleanOneItemData(UINT pData) {};
	virtual void IniToTree() {};
	virtual int GetItemType(HTREEITEM h) {return 0;};
	virtual char * GetItemPath(HTREEITEM h,char * path) {*path='\0';return path;};
	virtual void doSave(HTREEITEM h) {};
	/////////////////////////
	int OnContextMenu(CPoint point) ;
	void SetDropMark(CPoint pt);
	void DropItem();
	void TimerOn(CPoint pt);
	void TimerOff();
	void DeleteAllItems();
	HTREEITEM GetSelected();
	int FindTreeItem(HTREEITEM item,char * tofind,bool recurse);

	void TreeToIni( HTREEITEM h,HTREEITEM hsection,int treenum);
	void SaveIfDirty();
	bool isDirty(HTREEITEM h) {return ((pitemstruct *)GetItemData(h))->dirty==true;} 


	// Generated message map functions
protected:
	//{{AFX_MSG(CFilerTree)
	afx_msg void OnSelchanged(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnItemexpanding(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnBegindrag(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnEndlabeledit(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDblclk(NMHDR* pNMHDR, LRESULT* pResult);
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()


};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_FILERTREE_H__A7295F22_BABD_11D6_946A_A5F949ED9801__INCLUDED_)
