#if !defined(AFX_MACTREECTRL_H__INCLUDED_)
#define AFX_MACTREECTRL_H__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// MacTreeCtrl.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CMacTreeCtrl window

// other ...
#define macro_root 7
#define macro_test 8
#define macro_file 9
#define macro_dirty 10
#define macro_file_dirty 11

#define mpitemtype(h) ((pitemstruct *)GetItemData(h))->type
#define mpitemdirty(h) ((pitemstruct *)GetItemData(h))->dirty


class CMacTreeCtrl : public CFilerTree
{
// Construction
public:
	CMacTreeCtrl();
	~CMacTreeCtrl();

// Attributes
public:
	CStdioFile p;				//to Read/Write MacroFiles

	bool nodirtynotif;
	bool selchanged;

	HTREEITEM newmacros;

// Operations
public:
	void InitTree();
	void InitScintilla();
	void SetDirty(HTREEITEM h);
	void NotifDirty();
	//Load Save
	void LoadMacros();
	void LoadMacroFile(const char * name);
	void doSave(HTREEITEM h);			//Save selected MacroFile to disk
	//Compile Decompile
	void TextToMacros(HTREEITEM macfile,HTREEITEM mac,char * buf);
	void CompileEditedMacro(HTREEITEM item=NULL);
	void ShowMacroText(HTREEITEM h);
	void DoDecompile(macro * m);
	void DumpMacroCode();
	//Add Remove Find Macros
	void DeleteMacroFile(HTREEITEM h);
	void CheckMacroName(char * nam);
	macro * AppendMacroToList(macro * m,char * name=NULL);
	void AddRecordedMacro();
	void DeleteMacroByName(const char * name);
	void CleanupMacros();
	macro * FindMacroByHandle(HTREEITEM h);
	macro * FindMacroByName(const char * mname);
	macro * FindMacroByShortcut(int shortcut);


	void SynchronizeSource(HTREEITEM selitm);
	HTREEITEM InsertMacItem(const char * name,int image, HTREEITEM hParent,HTREEITEM after,int type,bool dirty);
	HTREEITEM InsertFile(const char * name,HTREEITEM parent);
	HTREEITEM InsertMacro(const char * name,HTREEITEM parent);
	HTREEITEM InsertMacroFile(const char * name);
	void fnew();								//New Macro
	void fdel();								//Delete Macro
	void pnew();								//New MacroFile
	void pdel();								//Close MacroFile

	int GetItemType(HTREEITEM h){return mpitemtype(h);}
	bool isMacroFileItem(HTREEITEM h) {return (mpitemtype(h)==TYPE_MACROFILE);}
	bool isMacroItem(HTREEITEM h) {return (mpitemtype(h)==TYPE_MACRO);}
	bool isFileItem(HTREEITEM h) {return (mpitemtype(h)==TYPE_FILE);}
	bool isRootItem(HTREEITEM h) {return (mpitemtype(h)==TYPE_ROOT);}
	
	void SetMacroIcon(HTREEITEM item, bool dirtymacro=false);
	void SetBold(HTREEITEM h);
	

	bool mayDrag(HTREEITEM h) {return isMacroItem(h);};
	bool mayDropAfter(HTREEITEM h) {return isMacroItem(h);};
	bool mayDropInto(HTREEITEM h) {return isMacroFileItem(h);};
	void doOnExpand(HTREEITEM hItem);
	void doOnSelchanged(HTREEITEM itemOld, HTREEITEM itemNew);
	void doOnEndlabeledit(HTREEITEM selitem,char * newtext);
	void doOnDblclk(HTREEITEM hItem);
	void cleanOneItemData(UINT pData) {delete ((pitemstruct *)pData);};
	void doDropItem();
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MACTREECTRL_H__INCLUDED_)
