#if !defined(AFX_PROJTREECTRL_H__INCLUDED_)
#define AFX_PROJTREECTRL_H__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ProjTreeCtrl.h : header file
//
#include "TreeCtrl.h"
/////////////////////////////////////////////////////////////////////////////
// CProjTreeCtrl window



#define ppitemtype(h) (((pitemstruct*)GetItemData(h))->type)
#define ppitemdirty(h) (((pitemstruct*)GetItemData(h))->dirty)

class CProjTreeCtrl : public CFilerTree
{
// Construction
public:
	CProjTreeCtrl();
	~CProjTreeCtrl();

// Attributes
public:
	CStdioFile p;				//to Read/Write projects
	int piconindex;					//Project Icon
	int ppiconindex;					//Project Tree Icon
	int infoiconindex;


// Operations
public:
	void InitTree();
	void SetDirty(HTREEITEM h);

	void cleanOneItemData(UINT pData);
	void DropItemFromList ();
	bool mayDrag(HTREEITEM h) {int tt=GetItemType(h);return (tt!=TYPE_ROOT && tt!=0);};
	bool mayDropAfter(HTREEITEM h) {return (isFileItem(h));};
	bool mayDropInto(HTREEITEM h) {return (isProjectOrFolderItem(h));};
	void doDropItem();
	void doOnExpand(HTREEITEM hItem);
	void doOnSelchanged(HTREEITEM itemOld, HTREEITEM itemNew);
	void doOnEndlabeledit(HTREEITEM selitem,char * newtext);
	void doOnDblclk(HTREEITEM hItem);

	HTREEITEM InsertProjItem(const char * name,int image,int simage,HTREEITEM hParent,HTREEITEM after,int type,bool dirty);
	HTREEITEM InsertFile(const char * name,HTREEITEM parent,HTREEITEM after=TVI_LAST);
	HTREEITEM InsertFolder(const char * name,HTREEITEM parent);
	HTREEITEM InsertProject(const char * name);
	HTREEITEM CopyItemTo(HTREEITEM h,HTREEITEM newparent,HTREEITEM after);

	bool ReadLine(Cstr * line);
	bool ImportDSP(const char * pname);				//Read a .dsp file
	bool AddProject(const char * pname);				//Add a project file to Project Tree
	void AddNewBranch(const char * s,HTREEITEM h);	//Add a folder to project
	void AddNewFile(const char * s,HTREEITEM after=TVI_LAST); //Add a file name to project
	void LoadProjects();						//loads projects from ini file
	void doSave(HTREEITEM h);				//Save selected project to disk
	void SaveBranch(HTREEITEM h,const char * indent);//Save a folder
	void fnew();								//New folder
	void fdel();								//Delete Folder
	void pnew();								//New Project
	void pdel();								//Close Project

	int GetItemType(HTREEITEM h){return ppitemtype(h);}
	bool isRootItem(HTREEITEM h) {return (GetItemType(h)==TYPE_ROOT);}
	bool isProjectItem(HTREEITEM h) {return (GetItemType(h)==TYPE_PROJECT);}
	bool isFolderItem(HTREEITEM h) {return (GetItemType(h)==TYPE_FOLDER);}
	bool isFileItem(HTREEITEM h) {return (GetItemType(h)==TYPE_FILE);}
	bool isProjectOrFolderItem(HTREEITEM h) {int tt=GetItemType(h);return (tt==TYPE_PROJECT || tt==TYPE_FOLDER);}
	void SetNullType(HTREEITEM h) {ppitemtype(h)=0;}
	void SetItemType(HTREEITEM h,int typ){ppitemtype(h)=typ;}
	char * GetItemPath(HTREEITEM h,char * path);
	
	
	void AddTimeChild(HTREEITEM h,CTime t,const char * s);
	int GetIcon(const char * s);				//Get icon from System
	void ExecMenuCommand(int rep);

};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PROJTREECTRL_H__INCLUDED_)
