// TreeNode.h: interface for the TreeNode class.

#if !defined(AFX_TREENODE_H__INCLUDED_)
#define AFX_TREENODE_H__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


 
class TreeNode   
{
public:
	TreeNode();								//Root Construction
	TreeNode(TreeNode*, LPITEMIDLIST pID);	//Other nodes construction
	~TreeNode();

	void	Cleanup();						//frees tree
	void	EnumChildren();
	TreeNode*	FindChild(const char*);		//finds subfolders & files
	TreeNode*	FindRootChild(const char* path);	//finds My Computer or Network in root
	bool	CompareIDL(SHITEMID&, SHITEMID&);	//Compares 2 IDLs
    void  GetIcons();							//Get icon/Open icon from System image list
	void GetFriendlyName(LPSHELLFOLDER lpsf,	//Get name/path
		LPITEMIDLIST lpi,DWORD dwFlags,char ** FriendlyName);
	UINT GetIDLSize(LPITEMIDLIST);			//IDL size ...

	TreeNode*			m_pParent;			//parent node
	TreeNode*			m_Folders;			//List of subfolders (0 if empty)
	TreeNode*			m_Files;			//List of files (0 if empty)
	TreeNode*			m_next;				//Next file/folder brother (0 if none)
	IShellFolder*       m_pShellFolder;		//IShellFolder interface
	LPITEMIDLIST   	    m_pID;				//ID
	LPITEMIDLIST   	    m_pFullID;			//Full ID
	char *				m_strName;			//File name
	char *				m_strPath;			//File path
	bool				m_hassubfolders;	//true if node has subfolders
	bool				m_explored;			//true when node has been explored
	int					m_icon;				//closed icon
	int					m_oicon;			//open icon
	HTREEITEM			m_hItem;			//Corresponding tree item

};

#endif // !defined(AFX_TREENODE_H__INCLUDED_)
