// inifile.cpp : implementation file
//

#include "stdafx.h"
#include "inifile.h"
#include  <io.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



/*
#define SECTION_MAX 12
#define SECTION_WINDOW 0
#define SECTION_WORK 1
#define SECTION_FILTERS 2
#define SECTION_PROJECTS 3
#define SECTION_MACROS 4
#define SECTION_FILELISTMENU 5
#define SECTION_FILETREEMENU 6
#define SECTION_PROJECTMENU 7
#define SECTION_TLBMENU 8
#define SECTION_TLBFAVORITES 9
#define SECTION_SHORTCUTS 10
#define SECTION_MACROBAR 11
#define SECTION_MACROBARMENU 12
*/

static char*  filerxsections[] = { "window","work","filters","projects","macros",
	"filelistmenu","filetreemenu","projectmenu","tlbmenu","tlbfavorites",
	"shortcuts","macrobar","macrobarmenu","scintillamenu"};

extern char * gInipath;
extern char * gMacrobarpath;
extern char * gMyDirectory;



///////////////////////////////////////////////////////////////////////
// ini file handling

void BuildPath(char * iniline,char * path,char * name){
	*path='\0';
	GetIniWorkString(iniline,path);
	if ((_access( path, 0 ) == -1) || (*path=='\0')){
		lstrcpy(path,gMyDirectory);
		lstrcat(path,name);
	}
}


UINT GetIniWorkInt(const char * s,UINT deflt)
{
	return GetPrivateProfileInt(filerxsections[SECTION_WORK],s,deflt,gInipath);
}

void GetIniWorkString(const char * item,char * value)
{
	GetPrivateProfileString(filerxsections[SECTION_WORK],item,"",value,MAX_PATH,gInipath);
}

DWORD GetIniShortcutInt(const char * s)
{
	char bu[256];
	UINT cod;
	UINT mod;
	GetPrivateProfileString(filerxsections[SECTION_SHORTCUTS],s,"0,0",bu,256,gInipath);
	sscanf(bu,"%u,%u",&cod,&mod);
	return cod + (mod<<16);
}


int GetIniMacrobarInt(const char * item,int dflt)
{
	return GetPrivateProfileInt(filerxsections[SECTION_MACROBAR],item,dflt,gMacrobarpath);
}

void SetIniMacrobarInt(const char * s,UINT value)
{
	char buf[15];
	sprintf(buf,"%u",value);
	WritePrivateProfileString(filerxsections[SECTION_MACROBAR],s,buf,gMacrobarpath);
}

void GetIniMacrobarString(const Cstr * item,Cstr * rpath,int pnum)
{
	char path[5*MAX_PATH];

	GetPrivateProfileString(filerxsections[SECTION_MACROBAR],item->buf,"_?_",path,MAX_PATH,gMacrobarpath);
	if (!lstrcmp(path,"_?_") || *path=='\0')
		*rpath=path;
	else {
		char * vg=strstr(path,",");
		if (vg!=NULL) *vg='\0';
		if (pnum==0) {
			*rpath=path;
		} else {
			if (vg==NULL)
				*rpath="";
			else
				*rpath=vg+1;
		}
	}
}

/////////////////////////////////////////////////////////////////////////
// Filerx Only

#ifndef _MINI

int GetSectionNum(const char * name) {

	int section;
	for (section=0;section<=SECTION_MAX;section++) {
		if (!lstrcmp(name,filerxsections[section]))
			return section;
	}
	return -1;
}

char * GetSectionName(int num)
{
	return filerxsections[num];
}


void WriteIniSection(int sectionnum,char * inibuff)
{
	char * path;
	if (sectionnum==SECTION_MACROBAR)
		path=gMacrobarpath;
	else
		path=gInipath;
	WritePrivateProfileSection(filerxsections[sectionnum],inibuff,path);
}

void SetIniNewString(int sectionnum,const char * pname){

	char path[MAX_PATH];
	char * section=filerxsections[sectionnum];
	int n=0;
	char nn[30];
	*path='!';*(path+1)='\0';
	while (*path!='\0'){
		n++;
		itoa(n,nn,10);
		GetPrivateProfileString(section,nn,"",path,MAX_PATH,gInipath);
	}
	WritePrivateProfileString(section,nn,pname,gInipath);
}


UINT GetIniWindowInt(const char * s,UINT deflt)
{
	return GetPrivateProfileInt(filerxsections[SECTION_WINDOW],s,deflt,gInipath);
}


void SetIniWindowInt(const char * s,UINT value)
{
	char buf[15];
	sprintf(buf,"%u",value);
	WritePrivateProfileString(filerxsections[SECTION_WINDOW],s,buf,gInipath);
}

void SetIniShortcutInt(const char * s,UINT value,UINT value2,const char * descrip)
{
	char * buf=new char[lstrlen(descrip)+50];
	sprintf(buf,"%u,%u,%s",value,value2,descrip);
	WritePrivateProfileString(filerxsections[SECTION_SHORTCUTS],s,buf,gInipath);
	delete [] buf;
}


void SetIniString(int sectionnum,const char * item, const char * value)
{
	WritePrivateProfileString(filerxsections[sectionnum],item,value,gInipath);
}



void SetIniMacrobarString(const Cstr * item, const char * value,int pnum)
{
	Cstr ico;
	char * sep=",";
	Cstr parm;
	if (pnum==0) {
		ico=value;
		GetIniMacrobarString(item,&parm,1);
		if (parm=="_?_" ||  parm=="") {sep="";parm="";};
	} else {
		parm=value;
		GetIniMacrobarString(item,&ico);
		if (ico=="_?_") ico="";
	}
	ico+=sep;
	ico+=parm;
	WritePrivateProfileString(filerxsections[SECTION_MACROBAR],item->buf,ico.buf,gMacrobarpath);
}

#endif //ndef _MINI


/////////////////////////////////////////////////////////////////////
//CIniSection


CIniSection::CIniSection(int sectionnum) {
	char * section=filerxsections[sectionnum];
	char * path;
	int inilen;
	if (sectionnum==SECTION_MACROBAR)
		path=gMacrobarpath;
	else
		path=gInipath;
	HANDLE hFile = CreateFile(path,         
                GENERIC_READ,              // open for reading 
                FILE_SHARE_READ,           // share for reading 
                NULL,                      // no security 
                OPEN_EXISTING,             // existing file only 
                FILE_ATTRIBUTE_NORMAL,     // normal file 
                NULL);                     // no attr. template 
 
	if (hFile != INVALID_HANDLE_VALUE) {
		inilen=GetFileSize(hFile,NULL);
		inibuff=new char[inilen+1];
		CloseHandle(hFile);
		GetPrivateProfileSection(section,inibuff,inilen,path);
	} else {
		inibuff=new char[1];
		*inibuff='\0';
	}
	fptr=inibuff;
	separe=true;
}

CIniSection::~CIniSection()
{
	delete [] inibuff;
}

bool CIniSection::GetNextKey()
{
	if (*fptr=='\0') return false;
	char * equal=fptr;
	int flen=lstrlen(fptr);
	key=fptr;
	while (*key==' ' || *key=='\t') key++;
	while((*equal)!='=' && (*equal)!='\0') equal++;
	value=equal;
	if (*equal=='='){
		if (separe) *equal='\0';
		value++;
		while (*value==' ' || *value=='\t') value++;
	}
	fptr+=(flen+1);
	return true;

}

bool CIniSection::KeyExists(char * text)
{
	fptr=inibuff;
	while(*fptr!='\0'){		
		if (!lstrcmp(fptr,text))
			return true;
		fptr+=(lstrlen(fptr)+1);
	}
	return false;

}
