#include "stdafx.h"
#include "..\common\defines.h"
#include "..\common\macro.h"
#include "maccore.h"
#include <time.h>
#include <process.h>
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



extern int calling;
extern bool stopped;
extern macro * dynmacro;
extern bool debugging;
extern bool preparecopydata;

extern int xcommands;
extern mdesc * xcommandtable;
extern int xfunctions;
extern fdesc * xfunctiontable;
//extern int namelen;

//extern char * ifacebuff;
//extern int ifacebufflen;

extern int SCI_ADDTEXT;
extern int SCI_APPENDTEXT;

extern int execerror;

//extern int (*GetInfo)(int,char *,int,int);
//extern void (*ToSendMessage)(int,const char *,const char *);
//extern void (*SendMacroCommand)(int ,int ,char * ,char * );

extern CMacroCommunicator * cmc;



macro::macro()
{
	len=0;
	prev=NULL;
	next=NULL;
	//num=0;
	maxlen=400;
	buff=new char[maxlen];
	*name='\0';
	vars=NULL;
	savedvars=NULL;
	charbuff=NULL;
	type=0;
	parms=0;
	pparms=NULL;
	errmsg=NULL;
	cd=NULL;
	inputseparator='\1';
	for (int i=0;i<10;i++) {
		breakpoints[i]=-1;
	}
}

macro::~macro()
{
	if (buff!=NULL) delete []buff;
	if (charbuff!=NULL) delete []charbuff;
	if (errmsg!=NULL) delete []errmsg;
	DeleteVars();
}



mdesc commandtable[]={
	 {SCD_OPEN,"Open","0S0"},
	 {SCD_FIND,"Find","0S0"},
	 {SCD_REPLACEALL,"ReplaceAll","0SS"},
	 {SCD_CLOSE,"Close","000"},
	 {SCD_OUTPUT,"Output","0S0"},
	 {SCD_OUTPUTSIZE,"OutputSize","0I0"},
	 {SCD_MINIMIZE,"MinimizeSciTE","000"},
	 {SCD_RESTORE,"RestoreSciTE","000"},
	 {SCD_QUIT,"Quit","000"},
	 {SCD_SAVEAS,"SaveAs","0S0"},
	 {SCD_EXPORTASHTML,"ExportAsHTML","0S0"},
	 {SCD_EXPORTASPDF,"ExportAsPDF","0S0"},
	 {SCD_EXPORTASRTF,"ExportAsRTF","0S0"},
	 {SCD_MENUCOMMAND,"MenuCommand","0S0"},
	 {SCD_MENUCOMMANDW,"MenuCommandw","0SI"},
	 {SCD_LOADSCRIPT,"LoadScript","0S0"},
	 {SCD_EXTENDER,"Extender","0S0"},
		{SCD_CWD,"Cwd","0S0"},
		{SCD_EXPORTASLATEX,"ExportasLATEX","0S0"},
		{SCD_EXPORTASXML,"ExportasXML","0S0"},
		{SCD_GOTO,"Goto","0II"},
		{SCD_INSERT,"Insert","0S0"},
		{SCD_LOADSESSION,"Loadsession","0S0"},
	 {MAC_SHELLEXECUTE,"shellexecute","0SSI"},
	 {MAC_SHELLEXECUTEEX,"shellexecutewait","0SSI"},
	 {MAC_SETCURDIR,"setcurdir","0S"},
	 {MAC_CREATEDIR,"createdir","0S"},
	 {MAC_COPYFILE,"copyfile","0SSI"},
	 {MAC_MOVEFILE,"movefile","0SS"},
	 {MAC_SAVESTRINGAS,"savestringas","0SS"},

	 {FLX_EXPANDITEM,"expanditem","0II"},
	 {FLX_COLLAPSEITEM,"collapseitem","0II"},
	 {FLX_SELECTITEM,"selectitem","0II"},
	 {FLX_SORTCHILDREN,"sortchildren","0II"},
	 {FLX_WINDOWSIZE,"windowsize","0II"},
	 {FLX_WINDOWPOS,"windowpos","0II"},
	 {FLX_WINDOWARRANGE,"windowarrange","0II"},
	 {FLX_SHOWTREE,"showtree","0I"},
	 {FLX_SHOWTAB2,"showtab2","0I"},
	 {FLX_STATUS,"status","0S"},
	 {FLX_SCRIPTINIT,"scriptinit","0S"},
	 {FLX_SCRIPTEXIT,"scriptexit","0"},
	 {FLX_SCRIPTADDCODE,"scriptaddcode","0S"},
	 {FLX_SCRIPTEXECUTE,"scriptexecute","0S"},
	 {FLX_VIEWMACROBAR,"viewmacrobar","0I"},
	 {FLX_SPLASH,"splash","0SS"},
	 {MAC_SORT,"sortstrings","0SII"},
	 {MAC_WAIT,"wait","0I0"},
	 {MAC_EXECUTE,"execute","0S0"},
	 {MAC_MESSAGE,"message","0SS"},
	 {MAC_SETINPUTSEPARATOR,"setinputseparator","0S"},
	 {MAC_DUMP,"DumpCommands","0II"},//last tooltip
	 {MAC_CALL,"call","S"},
	 {MAC_WHILE,"while",""},
	 {MAC_DO,"do",""},				//not used
	 {MAC_IF,"if",""},
	 {MAC_ELSE,"else",""},
	 {MAC_RETURN,"return",""},
	 {MAC_FOR,"for",""},
	 {MAC_BREAK,"break",""},
	 {MAC_CONTINUE,"continue",""},
	 {MAC_VOID,"void","I"},
	 {MAC_INT,"int","I"},
	 {MAC_SCRIPTBEG,"SCRIPTSTART",""},
	 {MAC_SCRIPTEND,"SCRIPTEND",""},
	 {MAC_STRING,"string","S"},//<----------- last coloured keyword
	 {MAC_INTAFFECT,"int",""},		//internal
	 {MAC_STRINGAFFECT,"string",""},//internal
	 {MAC_AFFECTINT,"!int=",""},			//internal
	 {MAC_AFFECTSTRING,"!str=",""},		//internal
	 {MAC_INCR,"++",""},				//internal
	 {MAC_DECR,"--",""},				//internal
	 {MAC_BLOCKBEG,"!{",""},			//internal
	 {MAC_BLOCKEND,"!}",""},			//internal
	 {MAC_FOR2,"!for",""},				//internal
	 {MAC_JUMP,"!jmp",""},				//internal
	 {MAC_NOP,"!nop",""},			//internal
	 {MAC_ERROR,"!err","S"},			//internal
	 {MAC_WARNING,"!war","S"},			//internal
	 {MAC_AFFECTCHAR,"!ch=",""},			//internal
	 {MAC_INTARRAY,"int",""},		//internal
	 {MAC_AFFECTINTARRAY,"!inta=",""},		//internal
	 {MAC_STRINGARRAY,"string",""},		//internal
	 {MAC_AFFECTSTRINGARRAY,"!stra=",""},		//internal
	 {MAC_SCRIPTLINE,"!scriptline",""},		//internal

	 {MAC_VOID,"!void","S"},
	 {MAC_EMPTY,"!empty","S"},

	 {MAC_COMMENT,"//","S"},//must be the last one

};

#define COMMANDS sizeof(commandtable)/sizeof(mdesc)-1




/////////////////////////////////////////////////////////////////////////////
//  COMPILE/DECOMPILE MACROS


// to get command number when command text is known
// used by compiler

int SearchKeywordByName(char * kword,char **pms){
	if (*kword=='\0') return MAC_EMPTY;
	int i=0;
	do{
		if (!lstrcmp(kword,commandtable[i].desc)){
			*pms=commandtable[i].parms;
			return commandtable[i].message;
		}
		i++;
	}while(i<=COMMANDS);

	i=0;
	do{
		if (!lstrcmp(kword,xcommandtable[i].desc)){
			*pms=xcommandtable[i].parms;
			return xcommandtable[i].message;
		}
		i++;
	}while (i<=xcommands);
	return MAC_COMMENT;
}


// to get command text when command code is known
// used by DumpCode and DecompileInstruction

static int SearchKeywordByCode(int code,char ** kword){
	int i=0;
	do{
		if (code==commandtable[i].message){
			*kword=commandtable[i].desc;
			return code;
		}
		i++;
	}while(i<=COMMANDS);

	i=0;
	do{
		if (code==xcommandtable[i].message){
			*kword=xcommandtable[i].desc;
			return code;
		}
		i++;
	}while (i<=xcommands);
	return MAC_EMPTY;
}

// Get command parameters description string
// used by Record

static char * GetxCommandParms(int code){
	int i=0;
	do{
		if (code==xcommandtable[i].message){
			return xcommandtable[i].parms;
		}
		i++;
	}while (i<=xcommands);
	return NULL;
}

// MAC_EXECUTE implementation
// Builds a temporary Macro to execute commands contained in a string

void macro::Execute(char * s){
	if (dynmacro!=NULL)
		delete dynmacro;
	dynmacro=new(macro);
	char * mbeg="Macro void dyn_mac\n";
	char * mtext=new char[strlen(mbeg)+strlen(s)+4];
	strcpy (mtext,mbeg);
	if (s!=NULL)
		strcat(mtext,s);
	strcat(mtext,"\n\n");
	char * mcend;
	dynmacro->Compile(mtext,&mcend);
	if (!dynmacro->macerror) {
		dynmacro->Play();
	}
}

////////////////////////////////////////////////////////////////////////////
// DECOMPILE

void ResizeBuffer(int toadd,int * actsize,char ** buf,char ** bend)
{
	int length=*bend-*buf;
	if (length+toadd >= *actsize) {
		char *newBuffer = new char[*actsize+toadd];
		memcpy(newBuffer, *buf, length);
		delete []*buf;
		*bend=newBuffer+length;
		*actsize = *actsize+toadd;
		*buf=newBuffer;
	}
}

// Dump macro code and variables

char * macro::DumpCode(){
	int size = 2000;			// total buffer size
	char *buffer;				// text buffer
	//char * psave;
	char * keyword;				// found keyword
	char * p=buff;				// code pointer
	char * bufend;
	buffer = new char[2000];
	*buffer = '\0';
	bufend=buffer;
	Instruction instr;

	bufend+=sprintf(bufend,"Name : %s \n",name);
	bufend+=sprintf(bufend,"Flags : 0x%x \n",flags);
	bufend+=sprintf(bufend,"Code buffer : 0x%x - Length : 0x%x\n",buff,len);
	bufend+=sprintf(bufend,"Vars : 0x%x \n\n",vars);
	
	while (p<buff+len){
		instr.field=(macfield *)p;
		int found=-2;
		int pa=0;
		int msg=instr.Getcode();
		int * ip=(int *)p;

		ResizeBuffer(500,&size,&buffer,&bufend);

		found=SearchKeywordByCode(msg,&keyword);
		if (msg==MAC_ERROR)
			*bufend++='#';
		int nlen=sprintf(bufend,"%x : %s ",p-buff,keyword);
		bufend+=nlen;
		nlen=nlen/4-1;
		while (nlen<5) {*bufend++='\t';nlen++;}
		int ii=(instr.Getlen())/4;
		bufend+=sprintf(bufend,"%i %i %i ",instr.Getlen(),instr.Getpnum(),msg);
		ii--;ip++;
		while (ii>0){
			bufend+=sprintf(bufend,"0x%x ",*ip);
			ii--;ip++;
		}
		*bufend++='\n';
		p=p+instr.Getlen();
	}
	ResizeBuffer(500,&size,&buffer,&bufend);
	bufend+=sprintf(bufend,"%x : !end\n",p-buff);
	bufend+=sprintf(bufend,"\nVariables:\n");


	macvar * v=vars;
	bool isparms=false;
	while (v!=NULL) {
		ResizeBuffer(500,&size,&buffer,&bufend);
		if (v->name!=NULL)
			bufend+=sprintf(bufend,"%s",v->name);
		else
			bufend+=sprintf(bufend,"(no name)");
		bufend+=sprintf(bufend," : 0x%x : \n",(int) v);
		if (v==pparms)
			isparms=true;
		if (isparms) {
			if ((v->type & TYP_INT)==TYP_INT)
				bufend+=sprintf(bufend,"\tint parm\n");
			else
				bufend+=sprintf(bufend,"\tstring parm\n");

		} else {
			if ((v->type & TYP_EXPR)==TYP_EXPR) {
				ResizeBuffer(strlen(v->eVal)+1000,&size,&buffer,&bufend);
				bufend+=sprintf(bufend,"\texpr=\"%s\"\n",v->eVal);
				if ((v->type & TYP_CONST)!=TYP_CONST) {
					bufend+=sprintf(bufend,"\tRPN=");
					if (v->cVal!=NULL) {
						CheckEval(v,bufend);
						bufend=buffer+strlen(buffer);
					} else
						bufend+=sprintf(bufend," bad expression");
					*bufend++='\n';
				}
			}
			if (v->dim!=0)
				bufend+=sprintf(bufend,"\tarray dim=%i\n",v->dim);
			else {
				if ((v->type & TYP_INT)==TYP_INT) {
					bufend+=sprintf(bufend,"\tint=%i\n",v->iVal);
				} else if ((v->type & TYP_STRING)==TYP_STRING) {
					ResizeBuffer(strlen(v->sVal)+500,&size,&buffer,&bufend);
					bufend+=sprintf(bufend,"\tstr=\"%s\"\n",v->sVal);
				}
			}
		}
		v=v->next;
	}
	*bufend='\0';
	return buffer;
}

// Decompiles one instruction
// called by Decompile
// ip : points to instruction to decompile
// bend : text buffer
// lastmsg : last decompiled instruction code
// crandtab : if non-zero , indents line and adds \n
// return value : instruction code

int macro::DecompileInstruction(char ** ip,char ** bend, int lastmsg,int crandtab)
{
	char * p;
	char * bufend=*bend;
	static sIndent=1;
	char * keyword;				// found keyword

	if (*ip==buff) sIndent=1;

	Instruction instr;
	int ilen;
	int found=-2;
	//int pa=0;
	int msg;
	bool doeol=true;
	bool dopvg=true;

	while (*ip<buff+len) {
		instr.field=(macfield *)*ip;
		msg=instr.Getcode();
		ilen=instr.Getlen();
		if (msg!=MAC_JUMP) break;
		*ip+=ilen;
	}
	if (*ip>=buff+len) return 0;
	p=*ip;
	//psave=p;

	found=SearchKeywordByCode(msg,&keyword);
	bool scripting=(msg==MAC_SCRIPTLINE);

	if (found==MAC_EMPTY){
		bufend+=sprintf(bufend,"//Decompile error : ip=0x%x\n",len);
		dopvg=false;
	}
	else{
		if (!scripting && crandtab && !(msg==MAC_IF && lastmsg==MAC_ELSE)){
			int ind=sIndent;
			while (ind>0) {*bufend++='\t';ind--;}
		}

		if (msg==MAC_SCRIPTLINE) {
			bufend+=sprintf(bufend,"%s",instr.Getv1()->sVal);
			doeol=false;
			dopvg=false;
		} else if (msg==MAC_INT || msg==MAC_STRING || msg==MAC_SCRIPTBEG)
			bufend+=sprintf(bufend,"%s %s",keyword,instr.Getv1()->name);
		else if (msg==MAC_INTARRAY || msg==MAC_STRINGARRAY)
			bufend+=sprintf(bufend,"%s %s[%s]",keyword,instr.Getv1()->name,instr.Getv2()->eVal);
		else if (msg==MAC_INTAFFECT || msg==MAC_STRINGAFFECT)
			bufend+=sprintf(bufend,"%s %s = %s",keyword,instr.Getv1()->name,instr.Getv2()->eVal);
		else if (msg==MAC_AFFECTINT || msg==MAC_AFFECTSTRING)
			bufend+=sprintf(bufend,"%s = %s",instr.Getv1()->name,instr.Getv2()->eVal);
		else if (msg==MAC_AFFECTCHAR || msg==MAC_AFFECTINTARRAY || msg==MAC_AFFECTSTRINGARRAY)
			bufend+=sprintf(bufend,"%s[%s] = %s",instr.Getv1()->name,instr.Getv2()->eVal,instr.Getv3()->eVal);
		else if (msg==MAC_WHILE || msg==MAC_IF) {
			bufend+=sprintf(bufend,"%s (%s) ",keyword,instr.Getv1()->eVal);
			doeol=false;
			dopvg=false;
		} else if (msg==MAC_ELSE) {
			bufend--;
			bufend-=sIndent;
			bufend+=sprintf(bufend," %s ",keyword);
			doeol=false;
			dopvg=false;
		} else if (msg==MAC_BLOCKBEG){
			bufend-=sIndent;
			*bufend++='{';sIndent++;
			dopvg=false;
		}else if (msg==MAC_BLOCKEND){
			if (sIndent>1) sIndent--;
			*(bufend-1)='}';
			dopvg=false;
		}else if (msg==MAC_FOR){
			bufend+=sprintf(bufend,"%s ( ",keyword);	//for (
			*ip=*ip+instr.Getlen();
			DecompileInstruction(ip,&bufend,0,0);			//for ( xxxx;
			*bufend++=' ';
			DecompileInstruction(ip,&bufend,0,0);			//for ( xxxx; yyyy
			*bufend++=' ';
			DecompileInstruction(ip,&bufend,0,0);			//for ( xxxx; yyyy; zzzz
			*(bufend-1)=')';
			*bufend++=' ';
			*bufend='\0';
			ilen=0;	//ip already updated
			doeol=false;
			dopvg=false;
		}else if (msg==MAC_FOR2){
			bufend+=sprintf(bufend,"%s",instr.Getv1()->eVal);
			doeol=false;
		}else if (msg==MAC_RETURN || msg==MAC_BREAK || msg==MAC_CONTINUE || msg==MAC_SCRIPTEND){
			if (instr.Getpnum()==1)
				bufend+=sprintf(bufend,"%s ( %s )",keyword,instr.Getv1()->eVal);
			else
				bufend+=sprintf(bufend,"%s",keyword);
		}else if (msg==MAC_AFFECTEXPR){
			bufend+=sprintf(bufend,"%s = %s",instr.Getv1()->eVal,instr.Getv2()->eVal);
		}else if (msg==MAC_INCR || msg==MAC_DECR){
			bufend+=sprintf(bufend,"%s%s",instr.Getv1()->name,keyword);
		}else if (msg==MAC_COMMENT || msg==MAC_WARNING){
			bufend-=sIndent;
			bufend+=sprintf(bufend,"//%s",instr.Getv1()->sVal);
			dopvg=false;
		}else if (msg==MAC_ERROR){
			bufend+=sprintf(bufend,"#%s",instr.Getv1()->sVal);
			if (*(bufend-1)=='{') sIndent++;
			dopvg=false;
		}else{
			bufend+=sprintf(bufend,"%s",keyword);
			int pnum=instr.Getpnum();
			macvar * mp=instr.GetFirstVar();
			if (msg==MAC_CALL)
				bufend+=sprintf(bufend," %s",((macro *)mp)->name);
			pnum--;
			mp=instr.GetNextVar();

			if (pnum>0){
				*bufend++='(';
				while (pnum>0){
					bufend+=sprintf(bufend,"%s, ",mp->eVal);
					pnum--;
					if (pnum>0) mp=instr.GetNextVar();
				}
				bufend--;
				*(bufend-1)=')';
			}
		}
		lastmsg=msg;
	}
	if (dopvg)
		*bufend++=';';
	if (doeol && crandtab)
		*bufend++='\n';
	*bufend='\0';
	*bend=bufend;
	*ip=*ip+ilen;
	return msg;
}

// Builds a string xxx Macro yyyyyy(ppp , qqq ...)
// Used by Decompile,GetToolTip and DumpCommands

char * macro::DecompileTitle(char * buffer)
{
	char * bufend=buffer;
	char * ts;					// type string
	char * ts2;

	switch (type){
		case 0 :ts="void";break;
		case 1 :ts="int";break;
		case 2 :ts="string";break;
	}

	bufend+=sprintf(bufend,"Macro %s %s",ts,name);
	if (parms>0){
		int pl=0;
		*bufend++='(';
		*bufend++=' ';
		macvar * prms=pparms;

		while (prms!=NULL){
			if(prms->type & TYP_INT)
				ts="int";
			else
				ts="string";

			if (prms->dim!=0)
				ts2="[]";
			else
				ts2="";
			bufend+=sprintf(bufend,"%s %s%s , ",ts,prms->name,ts2);
			prms=prms->next;
		}
		bufend--;
		*(bufend-1)=')';
	}
	*bufend='\0';
	return bufend;
	
}

// Decompiles a Macro


char * macro::Decompile(){
	int size = 2000;			// total buffer size
	char *buffer;				// text buffer
	//char * psave;
	int lastmsg=0;				// last decompiled instruction
	char * p=buff;				// code pointer
	bool elseif=false;			// true when doing "else if"
	char * bufend;
	buffer = new char[2000];
	*buffer = '\0';
	bufend=DecompileTitle(buffer);

	
	*bufend++='\n';


	while (p<buff+len){
		ResizeBuffer(500,&size,&buffer,&bufend);
		lastmsg=DecompileInstruction(&p,&bufend,lastmsg);
	}
	*bufend++='\n';
	*bufend='\0';
	return buffer;
}

//////////////////////////////////////////////////////////////////////////////
//   Debugging
// When debugging, used to calculate line position from Instruction pointer

int macro::ip2line(char ** ip,char * limit)
{
	static sLastmsg=0;
	Instruction instr;
	int ilen;
	int msg;

	while (*ip<limit) {
		instr.field=(macfield *)*ip;
		msg=instr.Getcode();
		ilen=instr.Getlen();
		if (msg!=MAC_JUMP) break;
		*ip+=ilen;
	}
	if (*ip>=limit) return 0;

	*ip+=ilen;
	if (msg==MAC_WHILE || msg==MAC_IF || msg==MAC_FOR2) {
		return 0;
	}else if (msg==MAC_FOR){
		ip2line(ip,limit);			//for ( xxxx;
		ip2line(ip,limit);			//for ( xxxx; yyyy
		ip2line(ip,limit);			//for ( xxxx; yyyy; zzzz
		return 0;
	}else if (msg==MAC_ELSE){
		return -1;
	}
	return 1;
}

// called by Play when debugging. Stops execution and displays debugged Macro

bool macro::DoDebug(char * macptr)
{
	char * p=buff;
	int lastl=0;
	int debuggedline=1;

	while (p<=macptr){
		lastl=ip2line(&p,macptr+1);
		debuggedline+=lastl;
	}
	if (lastl==1) debuggedline--;
	return cmc->FilerxDebug(this,debuggedline);
}


// Used by GetValue and GetExpressionValue

static char * getval(macvar * v)
{
	char * rval=NULL;
	if ((v->type & TYP_INT)==TYP_INT) {
		rval=new char[20];
		itoa(v->iVal,rval,10);
	} else {
		rval=new char[strlen(v->sVal)+3];
		strcpy(rval,"\"");
		strcat(rval,v->sVal);
		strcat(rval,"\"");
	}
	return rval;
}


//Get the value of a variable when debugging

char * macro::GetValue(char * varname)
{
	macvar * v=FindVar(varname);
	if (v!=NULL) {
		return getval(v);
	}
	return NULL;
}

// delete temporary variable created by GetExpressionValue

static void delonevar(macvar * vv) {
	if (vv->sVal!=NULL) delete [] vv->sVal;
	if (vv->eVal!=NULL) delete [] vv->eVal;
	if (vv->cVal!=NULL) delete [] vv->cVal;
	if (vv->name!=NULL) delete [] vv->name;
	delete vv;
}


// Given any string xpr, tries to evaluate it as an expression
// if not valid, returns "<error>"

char * macro::GetExpressionValue(char * xpr)
{

	cd=new compilerdata;
	cd->mac=this;
	macerror=false;
	char * rval;
	macvar * v;
	CompileExpression(xpr,TYP_INT);
	if (macerror) {
		v=vars->next;
		delonevar(vars);
		vars=v;
		macerror=false;
		CompileExpression(xpr,TYP_STRING);
	}
	if (!macerror) {
		int dummy=EvalExpression(vars);
		rval=getval(vars);
	} else {
		rval=new char[9];
		strcpy(rval,"<error>");
	}
	v=vars->next;
	delonevar(vars);
	vars=v;
	delete cd;
	return rval;
}


/////////////////////////////////////////////////////////////////////////////
//  Recording one message

// Adds one instruction to current Macro code
// Tries to compact using when possible :
// - a repeat argument : LineDown LineDown >>> LineDown(2)
// - text concatenation : AddText("a") AddText("b") >>> AddText("ab")

void macro::Record(int message,int wParam,int lParam) {
	bool sameaslast=FALSE;		// true if this notification is the same as the last one
	bool havetext=FALSE;		// true if we have text
	int thisnotif=message;		//current message

	//initialize before recording first message in a macro
	if (len==0){
		charbuff=new char[1000];
		*charbuff='\0';
		cd=new compilerdata;
		cd->samecount=1;
		cd->lastnotif=-1;
		cd->lastwParam=-1;
	}
	// select messages that may have text and messages we can compact
	if (thisnotif==GetCommandCode("ReplaceSel") || thisnotif==GetCommandCode("AddText")){
		if (thisnotif==cd->lastnotif) sameaslast=TRUE;
		havetext=TRUE;
	} else if (thisnotif==GetCommandCode("InsertText")){
		if (thisnotif==cd->lastnotif && wParam==cd->lastwParam+1) sameaslast=TRUE;
		havetext=TRUE;
	} else if (thisnotif==GetCommandCode("SearchNext") || thisnotif==GetCommandCode("SearchPrev")){
		havetext=TRUE;
	} else if (thisnotif==cd->lastnotif) {
		sameaslast=true;
	}

	if (sameaslast){
		if (havetext)
			strcat(charbuff,(char *)lParam);
		else
			cd->samecount++;
	}else{
		if (*charbuff!='\0'){
			AppendStringParm(charbuff);
			*charbuff='\0';
		} else if (cd->samecount>1)
			AppendIntParm(cd->samecount);

		if (thisnotif!=0){
			char * prms=GetxCommandParms(thisnotif);
			if (prms!=NULL){
				AddField(thisnotif);
				AppendParm((int) prms);
				if(*prms=='I')
					AppendIntParm(wParam);
				if (havetext)
					strcpy(charbuff,(char *)lParam);
			}
			cd->samecount=1;
		}else{
			delete []charbuff;
			delete cd;
			charbuff=NULL;
			flags=good_recorded_macro;
			return;
		}
		cd->lastnotif=thisnotif;						// for next record ...
		cd->lastwParam=wParam;
	}
}


///////////////////////////////////////////////////////////////////////////
// Variables

// Finds a variable by name in the Macro variables list

macvar * macro::FindVar(char * name)
{
	macvar * v=vars;
	while (v!=NULL){
		if (v->name!=NULL)
			if (!lstrcmp(v->name,name))
				return v;
		v=v->next;
	}
	return NULL;
}

// Deletes the array in an array variable

void macro::DeleteArray(macvar * mv)
{
	int dims=mv->dim;
	if (dims<=0) return;
	if ((mv->type & TYP_STRING)==TYP_STRING && mv->array!=NULL){
		int * s=mv->array;
		while (dims!=0){
			if (*s!=0) delete[] (char *)*s;
			s++;
			dims--;
		}
	}
	delete [] mv->array;
	mv->array=NULL;
}

// Deletes all variables of a Macro

void macro::DeleteVars()
{
	macvar * nextvar;
	macsavedvar * svnext;
	bool isparm=false;

	while (vars!=NULL){
		nextvar=vars->next;
		if (vars==pparms) isparm=true;
		if (vars->sVal!=NULL) delete [] vars->sVal;
		if (vars->eVal!=NULL) delete [] vars->eVal;
		if (vars->cVal!=NULL) delete [] vars->cVal;
		if (vars->name!=NULL) delete [] vars->name;
		if (!isparm && !(vars->type & TYP_EXPR)){
			DeleteArray(vars);
		}
		delete vars;
		vars=nextvar;
	}
	while (savedvars!=NULL){
		svnext=savedvars->next;
		if (savedvars->sVal!=NULL) delete [] savedvars->sVal;
		delete savedvars;
		savedvars=svnext;
	}
}

// Saves called Macro named variables to allow recursive calls
// Saved variables are placed in a linked list
// Returns number of saved variables

int macro::SaveVars()
{
	int count=0;
	macvar * v=vars;
	macsavedvar * sv;
	while (v!=NULL){
		if (v->name!=NULL){
			sv=new macsavedvar;
			if (v->type & TYP_INT){
				sv->type=TYP_INT;
				sv->iVal=v->iVal;
			}else{
				sv->type=TYP_STRING;
				sv->sVal=new char[strlen(v->sVal)+1];
				strcpy(sv->sVal,v->sVal);
			}
			sv->savedfrom=v;
			sv->next=savedvars;
			savedvars=sv;
			count++;
		}
		v=v->next;
	}
	return count;
}

// Restore called Macro saved variables and deletes them

void macro::RestoreVars(int cnt)
{
	macsavedvar * svnext;
	macvar * sf;
	int count=cnt;
	while(count>0){
		if (savedvars==NULL) return;
		svnext=savedvars->next;
		sf=savedvars->savedfrom;
		if (savedvars->type==TYP_INT){
			sf->iVal=savedvars->iVal;
		}else{
			ReaffectString(&sf->sVal,savedvars->sVal);
			delete []savedvars->sVal;
		}
		delete savedvars;
		savedvars=svnext;
		count--;
	}
}

// Called by compiler to add one variable to the list
// When a Macro accepts parameters, each parameter
// is considered as a variable placed at the end of the list
// This happens when PickParameters calls DeclareVar with toend=TRUE
// When the Macro is called, all parameters are at the end of the list
// in the same order as the caller's.

macvar * macro::AddVar(char * name,int typ,int slen/*=1*/,bool toend/*=false*/)
{
	macvar * v=new macvar;
	if (name==NULL)
		v->name=NULL;
	else{
		v->name=new char[strlen(name)+1];
		strcpy(v->name,name);
	}
	v->iVal=0;
	v->eVal=NULL;
	v->cVal=NULL;
	v->type=typ;
	v->dim=0;
	v->array=NULL;
	if (typ & TYP_STRING){
		v->sVal=new char[slen];
		*v->sVal='\0';
	}else
		v->sVal=NULL;
	if (toend){
		macvar * vv=vars;
		if (vv!=NULL){
			while(vv->next!=NULL)
				vv=vv->next;
			vv->next=v;
		}else
			vars=v;
		v->next=NULL;
	}else{
		v->next=vars;
		vars=v;
	}
	return v;
}

// When a string (variable) is reaffected, during execution
// if the new string is shorter than the old one
// the buffer is not resized ...
// Should remember the buffer size to be more efficient ...

void macro::ReaffectString(char ** s,char * value)
{
	if (*s!=NULL){
		if (strlen(value)>strlen(*s)){
			delete []*s;
			*s=new char[strlen(value)+1];
		}
	}else
		*s=new char[strlen(value)+1];
	strcpy(*s,value);
}

// Variable affectation
// Used by Play 
// eval is always FALSE ... ??? ...

void macro::AffectVar(macvar * v,macvar * v2,bool eval/*=true*/)
{
	if (v->dim!=0) {
		macvar * v3=*((macvar **)(v2->cVal+1));
		v->dim=v3->dim;
		v->array=v3->array;
	} else if (v->type & TYP_STRING){
		char * value;
		if ((v2->type & TYP_EXPR) && !(v2->type & TYP_CONST) && eval)
			value=(char *)EvalExpression(v2);
		else
			value=v2->sVal;
		ReaffectString(&v->sVal,value);
	}else{
		if ((v2->type & TYP_EXPR) && !(v2->type & TYP_CONST) && eval)
			v->iVal=EvalExpression(v2);
		else
			v->iVal=v2->iVal;
	}
}

/////////////////////////////////////////////////////////////////////////////
// Called by :
//	-	Filerx
//	-	itself : to execute Call <other_macro> instruction
//	-	macro::EvalExpression() (macexp.cxx) to evaluate expressions containing non void macro calls


// Test Ctrl-Shift keys to stop Macro execution

static bool CtrlShift()
{
	if (GetAsyncKeyState(VK_SHIFT) & 0x8000){
		if (GetAsyncKeyState(VK_CONTROL) & 0x8000) {
			return true;
		}
	}
	return false;
}

//used by qsort for MAC_SORT

int compare( const void *arg1, const void *arg2 )
{
	if (*(int *)arg1==0) {
		if (*(int *)arg2==0) return 0;
		return 1;
	}
	if (*(int *)arg2==0) return -1;
   /* Compare all of both strings: */
   return lstrcmp( * ( char** ) arg1, * ( char** ) arg2 );
}

// two first instruction parameters : pointers to macvars
#define mp1 mp[0]
#define mp2 mp[1]
// first parameters values : integers or pointers to strings  
#define	iv1 iv[0]
#define	iv2 iv[1]
#define	iv3 iv[2]
#define	iv4 iv[3]


void macro::Play(){
	//current instruction
	Instruction instr;	//current instruction
	int command;		//code
	int curlen;			//total length
	int pnum;			//parameters
	//parameters
	macvar * mp[16];	//var pointers
	int iv[16];			//values
	// Scintilla function parameters
	// To transmit parameters
	macro * calledmacro;
	macvar * prm;		// called macro parameter variables
	//scripts
	macvar * curscript;	//script text
	char * newscript;
	char * cu;
	char * li;
	//used for char affectation;
	UINT charpos;
	UINT charval;

	srand( (unsigned)time( NULL ) );

	int savedcount=0;	// saved variables count between calls

	char * macptr=buff; // execution pointer

	//if (stepping && macptrsav!=NULL) macptr=macptrsav;

	if (flags == bad_macro) return;
	if (len==0) return;

	while (macptr<buff+len){
		//execution may have been stopped here or in a called macro
		if (stopped) return;
		//get current instruction
		instr.field=(macfield *)macptr;
		curlen=instr.Getlen();
		command=instr.Getcode();
		pnum=instr.Getpnum();
		//evaluate parameters if any
		int i=1;
		mp[0]=instr.GetFirstVar();
		while (pnum>i) {
			mp[i]=instr.GetNextVar();
			if (mp[i]->dim==0)
				iv[i]=EvalExpression(mp[i]);
			i++;
		}

		if (debugging) {
			switch(command){
				case MAC_COMMENT :
				case MAC_WARNING :
				case MAC_ERROR :
				case MAC_BLOCKBEG :
				case MAC_BLOCKEND :
				case MAC_NOP :
				//case MAC_BREAK :
				//case MAC_CONTINUE :
				case MAC_INT:
				case MAC_STRING:
				case MAC_ELSE:
				case MAC_JUMP:
				case MAC_FOR2:
				case MAC_SCRIPTLINE:
				// don't stop on these ...
					break;
				default:
				// calls SciCtrl debugging code
					stopped=DoDebug(macptr);
				// User may have stopped debugging
			}
		}
		switch(command){
			case MAC_COMMENT :
			case MAC_WARNING :
			case MAC_ERROR :
			case MAC_BLOCKBEG :
			case MAC_BLOCKEND :
			case MAC_NOP :
			case MAC_BREAK :
			case MAC_CONTINUE :
			case MAC_INT:
			case MAC_STRING:
			case MAC_ELSE:
			case MAC_FOR:
			case MAC_SCRIPTEND:
				break;
			case MAC_SCRIPTBEG:
				curscript=mp1;
				ReaffectString(&curscript->sVal,"");
				break;
			case MAC_SCRIPTLINE:
				cu=curscript->sVal;
				li=mp1->sVal;
				newscript=new char[strlen(cu)+strlen(li)+1];
				strcpy(newscript,cu);
				strcat(newscript,li);
				delete []cu;
				curscript->sVal=newscript;
				break;
			case MAC_INTARRAY:
			case MAC_STRINGARRAY:
				charpos=(UINT)iv2;
				if (charpos>0) {
					if (mp1->dim<(int)charpos) {
						DeleteArray(mp1);
						mp1->array=new int[charpos];
						memset(mp1->array,0,charpos*4);
					}
					mp1->dim=charpos;
				}
				break;
			case MAC_INCR:
				mp1->iVal++;
				break;
			case MAC_DECR:
				mp1->iVal--;
				break;
			case MAC_AFFECTINT:
			case MAC_INTAFFECT:
			case MAC_AFFECTSTRING:
			case MAC_STRINGAFFECT:
				AffectVar(mp1,mp2,false);
				break;
			case MAC_AFFECTCHAR:
				charpos=(UINT)iv2;
				charval=(UINT)iv3;
				if (charpos>=0 && charpos<=strlen(mp1->sVal))
					if (charval>=0 && charval<=255)
						mp1->sVal[charpos]=(char)charval;
				break;
			case MAC_AFFECTINTARRAY:
				charpos=(UINT)iv2;
				if (charpos>=0 && charpos<(UINT)mp1->dim)
					mp1->array[charpos]=iv3;
				break;
			case MAC_AFFECTSTRINGARRAY:
				charpos=(UINT)iv2;
				if (charpos>=0 && charpos<(UINT)mp1->dim){
					ReaffectString((char * *)&mp1->array[charpos],(char *)iv3);
				}
				break;
			case MAC_MESSAGE:
				MessageBox(NULL,(const char *)iv2,(const char *)iv3,MB_OK | MB_TOPMOST);
				break;
			case MAC_SETINPUTSEPARATOR:
				inputseparator=*((char *)iv2);
				break;
			case MAC_JUMP:
				macptr=buff+(int)mp1;
				continue;
				break;
			case MAC_WHILE:
			case MAC_IF:
				if (EvalExpression(mp1)!=0){
					macptr+=(curlen+INSTRLEN1+INSTRLEN0); //skip jump & block
					continue;
				}
				break;
			case MAC_FOR2:
				if (EvalExpression(mp1)==0){
					macptr+=(2*INSTRLEN1); //skip for2 && true jump
					continue;
				}
				break;
			case MAC_RETURN:
				if (pnum==1){
					if (type==TYP_INT)
						retval->iVal=EvalExpression(mp1);
					else
						ReaffectString(&retval->sVal,(char *)EvalExpression(mp1));
				}
				macptr=buff+len;
				continue;
				break;
			case MAC_CALL:
				calledmacro=(macro *)mp1;
				savedcount=calledmacro->SaveVars();
				prm=calledmacro->pparms;
				i=1;
				while (prm!=NULL){
					calledmacro->AffectVar(prm,mp[i],false);
					prm=prm->next;
					i++;
				}
				calling++;
				calledmacro->Play();
				calling--;
				calledmacro->RestoreVars(savedcount);
				break;
			case MAC_SORT:
				mp2=*((macvar **)(mp2->cVal+1));
				if (mp2->dim>0){
					int startindex=iv3;
					int endindex=iv4;
					if (startindex<0) startindex=0;
					if (endindex>=mp2->dim) endindex=mp2->dim-1;
					qsort((void *)(mp2->array+startindex), endindex-startindex+1, sizeof( char * ), compare );
				}
				break;
			case MAC_DUMP:{
				char * dumpbuff=DumpCommands(iv2,iv3,this);
				cmc->ToSendMacroCommand(SCI_ADDTEXT,strlen(dumpbuff),dumpbuff,"0IS");	//-1 to include '0' return value
				delete [] dumpbuff;
				break;
			}
			case MAC_SETCURDIR:
				execerror=0;
				if (!SetCurrentDirectory((char *)iv2))
					execerror=GetLastError();
				break;
			case MAC_CREATEDIR:
				execerror=0;
				if (!CreateDirectory((char *)iv2,0))
					execerror=GetLastError();
				break;
			case MAC_COPYFILE:{
				execerror=0;
				if (!CopyFile((char *) iv2,(char *) iv3,(bool)(iv4!=0)))
					execerror=GetLastError();
				break;
				}
			case MAC_MOVEFILE:{
				execerror=0;
				if (!MoveFile((char *) iv2,(char *) iv3))
					execerror=GetLastError();
				break;
				}
			case MAC_SAVESTRINGAS:{
				execerror=0;
				FILE* f=fopen((char *) iv3,"w+b");
				if (f!=NULL) {
					fputs((char *) iv2,f);
					fclose(f);
				}
				execerror=GetLastError();
				break;
				}
			case MAC_SHELLEXECUTE:
			case MAC_SHELLEXECUTEEX: {
				execerror=0;
				if (command==MAC_SHELLEXECUTE) {
					execerror=(int)ShellExecute(NULL,"open",(char *)iv2,(char *)iv3,NULL,(iv4==0 ? SW_SHOWDEFAULT : SW_HIDE));
				} else {
					SHELLEXECUTEINFO  sei;
					ZeroMemory(&sei, sizeof(sei));
					sei.cbSize = sizeof(sei);
					sei.fMask = SEE_MASK_NOCLOSEPROCESS ;
					sei.lpVerb = "open";
					sei.lpFile=(char *)iv2;
					sei.lpParameters=(char *)iv3;
					sei.nShow=(iv4==0 ? SW_SHOWDEFAULT : SW_HIDE);
					if (ShellExecuteEx(&sei))
						WaitForSingleObject(sei.hProcess,INFINITE);
					else
						execerror=GetLastError();
				}
				break;
			}
			case MAC_EXECUTE:
				calling++;
				Execute((char *)iv2);
				calling--;
				break;
			case MAC_WAIT:{
				time_t limit=(clock_t)iv2* CLOCKS_PER_SEC/1000 +clock();
				while( (limit > clock()) && !CtrlShift());
				break;
				}
/////////////////////////////////////////////////////////////////////////
// following are executed by
// - SciTE : SCD_xxxxxx
// - Filerx : FLX_yyyyyy
// - Scintilla : SCI_zzzzzz

			case SCD_QUIT:
			case SCD_CLOSE:
			case SCD_MINIMIZE:
			case SCD_RESTORE:
			case FLX_SCRIPTEXIT:
				cmc->ToSendMessage(command,NULL,NULL);
				break;
			case SCD_OPEN:
			case SCD_SAVEAS:
			case SCD_CWD:
			case SCD_EXPORTASHTML:
			case SCD_EXPORTASPDF:
			case SCD_EXPORTASRTF:
			case SCD_EXPORTASLATEX:
			case SCD_EXPORTASXML:
			case SCD_FIND:
			case SCD_INSERT:
			case SCD_GOTO:
			case SCD_LOADSESSION:
			case SCD_OUTPUT:
			case SCD_OUTPUTSIZE:
			case SCD_MENUCOMMAND:
			case SCD_LOADSCRIPT:
			case SCD_EXTENDER:
			case FLX_SHOWTREE:
			case FLX_SHOWTAB2:
			case FLX_STATUS:
			case FLX_SCRIPTINIT:
			case FLX_SCRIPTADDCODE:
			case FLX_SCRIPTEXECUTE:
			case FLX_VIEWMACROBAR:
				cmc->ToSendMessage(command,(char *) iv2,NULL);
				break;
			case SCD_REPLACEALL:
			case SCD_MENUCOMMANDW:
			case FLX_EXPANDITEM:
			case FLX_COLLAPSEITEM:
			case FLX_SELECTITEM:
			case FLX_SORTCHILDREN:
			case FLX_WINDOWSIZE:
			case FLX_WINDOWPOS:
			case FLX_WINDOWARRANGE:
			case FLX_SPLASH:
				cmc->ToSendMessage(command,(char *) iv2,(char *) iv3);
				break;

			default: {
				unsigned int p1=0;				// wParam
				char *p2=0;						// lParam
				int repeat=1;					// repetition value

				int pv=0;
				char * params=(char *) mp[pv++];// parameter format string
				// if non 0 first parm is an integer
				if (*params!='0') p1=iv[pv++];
				// if non 0 second parm is an integer or a string pointer
				if (*(params+1)!='0') p2=(char *)iv[pv++];
				// if allowed (non 0) and used here (pnum>pv) third parm is the repeat count
				if (*(params+2)!='0' && pnum>pv) repeat=iv[pv];

				//compiler made first parm point to the first parameter type
				//let it point to first char now (return value type)
				params--; 
				if (command==SCI_ADDTEXT || command==SCI_APPENDTEXT){
					//Macro syntax is AddText(text) (or AppendText ...)
					//But Scintilla syntax is AddText(length,text)
					params="0IS";
					p1=strlen(p2);
				}
				
				char * arg=NULL;
				while (repeat!=0){
					// Instead of calling ToSendMacroCommand
					// which calls ToSendMessage when working with SciTE
					// let us prepare data here and call directly ToSendMessage
					if (preparecopydata) {
						if (arg==NULL) {
							// only once
							char itoabuf1[14];
							char * arg1="\0";
							char itoabuf2[14];
							char * arg2="\0";
							char prms[4];

							strncpy(prms,params,3);
							*(prms+3)='\0';
							
							if (*(params+1)=='I'){
								itoa(p1,itoabuf1,10);
								arg1=itoabuf1;
							}else if (p1!=0)
								arg1=(char *) p1;

							if (*(params+2)=='I'){
								itoa((int)p2,itoabuf2,10);
								arg2=itoabuf2;
							}else if (p2!=0)
								arg2=p2;

							arg=new char [14+4+3+strlen(arg1)+strlen(arg2)];
							sprintf(arg, "%i;%s;%s;%s",command,prms,arg1,arg2);
						}
						cmc->ToSendMessage(SCD_MACROCOMMAND,arg,NULL);
					} else { // if !preparecopydata
						cmc->ToSendMacroCommand(command,p1,p2,params);
					}
					repeat--;
				} // repeat loop
				if (arg!=NULL) delete [] arg;
			} // default
		} //switch
		//point to next instruction
		macptr+=curlen;
		if (CtrlShift()) stopped=true;
	} //main loop
}

