#include "stdafx.h"
#include "..\common\defines.h"
#include "..\common\macro.h"
#include "resource.h"
#include "macexp.h"
#include <time.h>
#include  <io.h>
#include <sys/stat.h>

extern int calling;
extern macro * macros;
extern bool preparecopydata;

extern cdesc * constanttable;
extern int constants;
extern int xfunctions;
extern fdesc * xfunctiontable;
extern macro * dynmacro;
extern macro * FindMacroByName(char * mname,macro * m);

//extern int (*GetInfo)(int,char *,int,int);
//extern void (*ToSendMessage)(int,const char *,const char *);
//extern void (*SendMacroCommand)(int ,int ,char * ,char * );
extern CMacroCommunicator * cmc;

extern int execerror;
extern bool debugging;
///////////////////////////////////////////////////////////////////////////
// InputBox handling 

extern HINSTANCE instance;

int inputmax=1000;
int dlgbox;
char * dlgtext;
char * dlgtitle;
int inputid;
char  separator[2] ;


// Input Dialog

BOOL FAR PASCAL InputDlgProc (HWND hDlg, UINT msg, UINT wParam, LONG lParam) 
{  
	HWND editw;
	char * sepptr;
	char * tmptext=NULL;
	switch (msg)
	{     
		case WM_INITDIALOG:
			SetWindowText(hDlg,dlgtitle);

			tmptext=new char[strlen(dlgtext)+1];
			strcpy(tmptext,dlgtext);
			sepptr=strstr(dlgtext,separator);
			if (sepptr!=NULL) {
				inputid=IDC_COMBO;
			} else {
				inputid=IDC_INPUTEDIT;
			}
			editw=GetDlgItem(hDlg,inputid);
			ShowWindow(editw,SW_SHOW);
			if (sepptr!=NULL) {
				sepptr=strstr(tmptext,separator);
				char *oldsepptr=tmptext;
				while (sepptr!=NULL){
					*sepptr='\0';
					SendMessage(editw,CB_ADDSTRING,0,(LPARAM) oldsepptr);
					oldsepptr=sepptr+1;
					sepptr=strstr(oldsepptr,separator);
				}
				SendMessage(editw,CB_ADDSTRING,0,(LPARAM) oldsepptr);
			}
			SetDlgItemText(hDlg, inputid, tmptext);
			SendMessage(editw,EM_SETSEL,0,strlen(tmptext));
			delete [] tmptext;
			SetFocus(editw);
			return FALSE;      
		case WM_COMMAND:     
			if (wParam == IDOK || wParam == IDCANCEL)     
			{         

				EndDialog (hDlg, TRUE);
				if (wParam==IDOK) {
					dlgtext=new char[inputmax];
					GetDlgItemText(hDlg,inputid,dlgtext,inputmax);
					EndDialog(hDlg,true);
				} else {
					dlgtext=new char [1];
					*dlgtext='\0';
					EndDialog(hDlg,false);
				}
				return TRUE;     
			}     
			break;     
	}     
	return FALSE; 
} 


/////////////////////////////////////////////////////////////////////////
// Expression Compile/Evaluate



#define TOS TP[P]
#define TOSP TP[P+1]
#define TOSP2 TP[P+2]
#define TOS2 TP[P-1]
#define TOS3 TP[P-2]
#define TOS4 TP[P-3]


//////////////////////////////////////////////////////
// searching in misc tables

// Get Parameter descriptor for one function

static char * getfuncparams(unsigned char tok) {
	int i=0;
	do{
		if (ifunctiontable[i].message==tok){
			return ifunctiontable[i].parms;
		}
		i++;
	}while (ifunctiontable[i-1].message!=0);
	return NULL;
}

// Get function name

static char * getfuncdesc(unsigned char tok) {
	int i=0;
	do{
		if (ifunctiontable[i].message==tok){
			return ifunctiontable[i].desc;
		}
		i++;
	}while (ifunctiontable[i-1].message!=-1);
	return "??";
}

// Check expression validity ; dump RPN expression if dumpbuff!=NULL
// Convert '&' from TOK_BITAND to TOK_STRCAT
// and integer comparison operators to string operators
// when operands are two strings
// check number of temporary strings
// called by CompileExpression and DumpCode
// On error returns error code
// else returns a negative value :  -TYP_INT or -TYP_STRING

int macro::CheckEval(macvar * mv,char * dumpbuff)
{
		
	int TP[20];
	int P=-1;
	unsigned char * c=(unsigned char *)mv->cVal;
	unsigned char uToken;
	int err=0;
	int tempscount=0;
	char * descrip;

	if (*c=='\0'){
		if (dumpbuff!=NULL) *dumpbuff='\0';
		return ERR_EMPTYEXPR; 	
	}

	while (err==0 && *c!='\0'){
		uToken=*c;
		if (dumpbuff!=NULL)
			descrip=getfuncdesc(uToken);
		int specialp=1; //macros and xfunctions have a special parameter
		if (uToken>=TOK_CALL){
			int mcount;
			int retv;
			char * params;
			//external functions
			if (uToken>=TOK_XFUNCTION){
				//TOK_XFUNCTION : 0 parm
				//TOK_XFUNCTION+1 : 1 parm
				//TOK_XFUNCTION+2 : 2 parms
				mcount=uToken-TOK_XFUNCTION;
				P-=mcount;
				if (P>=0) {
					fdesc * fd=(fdesc *)((macvar *) TOS)->iVal;
					if (dumpbuff!=NULL)
						descrip=fd->desc;
					params=fd->parms;
					retv=typfromletter(params);
					params++;
				}
				//internal functions
			}else if (uToken>=TOK_STRLEN){
				params=getfuncparams(uToken);
				retv=typfromletter(params);
				params++; // skip return type
				mcount=strlen(params);
				P-=(mcount-1);
				specialp=0;
			// macro calls
			}else if (uToken>=TOK_CALL){
				mcount=uToken-TOK_CALL;
				//pop parms
				P-=mcount;
				if (P>=0) {
					if (mcount>0) {
						for (int ip=0;ip<mcount;ip++) {
							// stack must contain integers or strings
							if (TP[P+ip+1]!=TYP_INT && TP[P+ip+1]!=TYP_STRING) {
								err=ERR_MISSINGMACPARM;
								break;
							}
						}
					}
					if (err==0) {
						// TOS must contain a macro pointer
						if ((TOS==TYP_INT) || (TOS==TYP_STRING)) {
							err=ERR_TOOMANYMACPARMS; 
							break;
						}
						macro * mm=(macro *)((macvar *) TOS)->iVal;
						descrip=mm->name;
						params=mm->parmtyps;
						retv=mm->type;
					}
				}
			}

			if (P<0)
				err=ERR_MISSINGOPERAND; 
			else if (err==0){
				for (int ip=0;ip<mcount;ip++){
					//compare stack types with wanted types in type string
					if (*params!='0')
						if (TP[P+ip+specialp]!=typfromletter(params)) {
							err=ERR_MACPARMTYPMISMATCH;
							break;
						}
					params++;
				}
				if (err==0){
					TOS=retv;
					// We'll have a temp string
					if (TOS==TYP_STRING) tempscount++;
				}
			}
		}else if (uToken>=TOK_ICONST) { // TOK_xCONST TOK_xVAR TOK_xFUNC TOK_xMACRO
			P++;
			if (uToken==TOK_SCONST) {
				TOS=TYP_STRING;
				//skip included string
				c+=(strlen((char *)(c+1))+1);
			} else {
				if (uToken==TOK_SVAR){
					TOS=TYP_STRING;
				}else if (uToken==TOK_ICONST) {
					TOS=TYP_INT;
				} else if (uToken==TOK_IVAR) {
					TOS=TYP_INT;
				} else {
					//macro/fdesc pointer
					TOS=*((int *) (c+1));
				}
				//skip pointer
				c+=4;
			}
		// pseudo variables
		}else if (uToken>=TOK_SCITE_FILENAME){
			P++;
			TOS=typfromletter(getfuncparams(uToken));
		//unary operators
		}else if (uToken==TOK_NOT || uToken==TOK_OPP){
			if (P<0) 
				err=ERR_MISSINGOPERAND;
			else if (TOS!= TYP_INT) 
				err=ERR_TYPMISMATCH;
		// binary operators
		}else{
			if (P<1) 
				err=ERR_MISSINGOPERAND;	
			else if (TOS!=TOS2)
				err=ERR_TYPMISMATCH;
			else {
				bool tos2s=(TOS==TYP_STRING); // true when 2 strings on stack
				P--;
				int ttos=TYP_INT; //operation result type
				switch (uToken){
					case TOK_PLUS:
					case TOK_MINUS:
					case TOK_MUL:
					case TOK_DIV: 
					case TOK_MOD: 
					case TOK_PUI: 
					case TOK_OR:
					case TOK_AND:
					case TOK_BITOR:
					case TOK_BITXOR:
					case TOK_BITAND:
					case TOK_LSHIFT:
					case TOK_RSHIFT:
						if (tos2s) {
							if (uToken==TOK_BITAND){
								*c=TOK_STRCAT; // & is string concat
								ttos=TYP_STRING;
							} else
								err=ERR_TYPMISMATCH;
						}
						break;
					case TOK_EQUAL:
					case TOK_NEQUAL:
					case TOK_INF:
					case TOK_SUP:
					case TOK_INFEQ:
					case TOK_SUPEQ:
						if (tos2s)
							*c=uToken+DIFFS; // convert to string comparison
						break;
				}//switch
				TOS=ttos;
			}
		}//else
		if (dumpbuff!=NULL) {
			strcat(dumpbuff,descrip);
			strcat(dumpbuff," ");
		}
		c++;
	}//while
	if (err==0){
		if (P>0) err=ERR_MISSINGOPORFUNC; // stack not empty
		if (tempscount>19) err=ERR_TOOCOMPLEX; // too many temp strings
	}
	if (err!=0)
		return err;
	else{
		return(-TOS); //type
	}
}


// Evaluate an Integer expression : ieval implementation
// creates a temp Macro to compile expression
// called by EvalExpression

int macro::IEval(char * s){
	if (dynmacro!=NULL) {
		delete dynmacro;
	}
	dynmacro=new macro;
	char * mbeg="Macro int dyn_mac\n return(";
	char * mtext=new char[strlen(mbeg)+strlen(s)+4];
	strcpy (mtext,mbeg);
	if (s!=NULL)
		strcat(mtext,s);
	else
		strcat(mtext,"0");
	strcat(mtext,")\n\n");
	dynmacro->type=TYP_INT;
	char * mcend;
	dynmacro->Compile(mtext,&mcend);
	if (!dynmacro->macerror)
		dynmacro->Play();
	delete [] mtext;
	return dynmacro->retval->iVal;
}

// Evaluate a String expression : seval implementation
// creates a temp Macro to compile expression
// called by EvalExpression


char * macro::SEval(char * s){
	if (dynmacro!=NULL) {
		delete dynmacro;
	}
	dynmacro=new macro;
	char * mbeg="Macro string dyn_mac\n return(";
	char * mtext=new char[strlen(mbeg)+strlen(s)+4];
	strcpy (mtext,mbeg);
	strcat(mtext,s);
	if (s!=NULL)
		strcat(mtext,s);
	else
		strcat(mtext,"???");
	strcat(mtext,")\n\n");
	dynmacro->type=TYP_STRING;
	char * mcend;
	dynmacro->Compile(mtext,&mcend);
	dynmacro->Play();
	delete [] mtext;
	char * r=dynmacro->retval->sVal;
	if (r!=NULL){
		char * news=new char[strlen(r)+1];
		strcpy(news,r);
		return news;
	}
	char * news=new char[1];
	*news='\0';
	return news;

}

// replace implementation
// called by EvalExpression


static char * doreplace( char * srce, char * find, char * repl) {
	int cnt=0;
	int lfind=strlen(find);
	int lrepl=strlen(repl);
	int lsrce=strlen(srce);
	char * scanp=srce;
	char * found=NULL;
	char * sresult=NULL;

	//Handle special cases
	if (lsrce==0) {
		sresult=new char[1];
		*sresult='\0';
		return sresult;
	}

	if (lfind==0) {
		sresult=new char[lsrce+1];
		strcpy(sresult,srce);
		return sresult;
	}

	// Calculate new length
	while (scanp<srce+lsrce) {
		found=strstr(scanp,find);
		if (found==NULL) break;
		cnt++;
		scanp=found+lfind;
	}
	
	int newl=lsrce+cnt*(lrepl-lfind)+1;
	sresult=new char[newl];
	char * newsptr=sresult;
	scanp=srce;

	// Build new string
	while (scanp<srce+lsrce) {
		found=strstr(scanp,find);
		if (found==NULL) {
			strcpy(newsptr,scanp);	
			break;
		}
		if (found-scanp>0) {
			strncpy(newsptr,scanp,found-scanp);
			newsptr+=(found-scanp);
			*newsptr='\0';
		}
		if (lrepl>0) {
			strcpy(newsptr,repl);
			newsptr+=lrepl;
		}
		scanp=found+lfind;
	}
	return sresult;
}

//enumfiles implementation
// called by EvalExpression

int macro::EnumFiles(char * spec,bool dirs,macvar * t)
{
	WIN32_FIND_DATA * ff=new (WIN32_FIND_DATA);  
	UINT fileattr=0;
	if (dirs) fileattr=FILE_ATTRIBUTE_DIRECTORY;
	// Count files/directories
	HANDLE h=FindFirstFile(spec,ff);
	int filecount=0;
	if (h==INVALID_HANDLE_VALUE) {
		delete ff;
		return 0;
	}
	while (1) {
		if ((ff->dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)==fileattr)
			if (lstrcmp(ff->cFileName,".") && strcmp(ff->cFileName,".."))
				filecount++;
		if (!FindNextFile(h,ff)) break;
	}
	FindClose(h);

	// Redim array if necessary
	if (t->dim<filecount) {
		DeleteArray(t);
		t->array=new int[filecount];
		t->dim=filecount;
		memset(t->array,0,filecount*4);
	}
	// Copy names
	char ** s=(char **) t->array;
	h=FindFirstFile(spec,ff);
	while(1) {
		if ((ff->dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)==fileattr) {
			if (lstrcmp(ff->cFileName,".") && strcmp(ff->cFileName,"..")) { 
				if (*s!=0) delete [] *s;
				*s=new char[strlen(ff->cFileName)+1];
				strcpy(*s,ff->cFileName);
				s++;
			}
		}
		if (!FindNextFile(h,ff)) break;
	}
	FindClose(h);
	delete ff;
	return filecount;
}

// Main expression Evaluation routine

// called by :
// - CompileExpression : for constant expressions
// - Play : to evaluate parameters and others
// - AffectVar
// - GetExpressionValue

int macro::EvalExpression(macvar * mv)
{
	
	//constant : already evaluated during compilation
	if (mv->type & TYP_CONST){
		if (mv->type & TYP_INT)
			return mv->iVal;
		else
			return (int) mv->sVal;
	}
	
	
	int TP[20];
	char * temps[20];
	int tempsptr=-1;
	int P=-1;
	unsigned char * c=(unsigned char *)mv->cVal;
	unsigned char uToken;
	char * news;
	int bbool;
	int newsl;
	macvar * v;
	int lasttyp;
	int clen,cpos,olen;
	char * ins;

	macro * calledmacro;
	int prm;
	macvar * vprm;
	int PP;
	char * params;
	int savedcount;

	while (*c!='\0'){
		uToken=*c++;
		lasttyp=TYP_INT;
		news=NULL;
		// External functions
		if (uToken>=TOK_XFUNCTION){
			prm=uToken-TOK_XFUNCTION;
			P-=prm;
			fdesc * fd=(fdesc*)TOS;
			params=fd->parms;
			if (preparecopydata) {
				char itoabuf1[14];
				char * arg1="\0";
				char itoabuf2[14];
				char * arg2="\0";
				char prms[4];

				strncpy(prms,params,3);
				*(prms+3)='\0';
				
				if (*(params+1)=='I'){
					itoa(TP[P+1],itoabuf1,10);
					arg1=itoabuf1;
				}else if (prm>0)
					arg1=(char *) TP[P+1];

				if (*(params+2)=='I'){
					itoa((int)TP[P+2],itoabuf2,10);
					arg2=itoabuf2;
				}else if (prm>1)
					arg2=(char *)TP[P+2];

				char * arg=new char [14+4+3+strlen(arg1)+strlen(arg2)];
				sprintf(arg, "%i;%s;%s;%s",fd->message,prms,arg1,arg2);
				TOS=cmc->GetInfo(SCD_MACROCOMMAND,params,(int)arg,NULL);
				delete []arg;
				
			} else {
				if (prm==2)
					TOS=cmc->GetInfo(fd->message,params,TP[P+1],TP[P+2]);
				else if (prm==1)
					TOS=cmc->GetInfo(fd->message,params,TP[P+1],0);
				else
					TOS=cmc->GetInfo(fd->message,params,0,0);
			}
			if (*params=='S')
				news=(char *)1;
		//Internal functions
		}else if (uToken>=TOK_STRLEN){
			switch (uToken){
				case TOK_SCITE_PROPERTY:
					TOS=cmc->GetInfo(SCD_ASKPROPERTY,"SS0",TOS,0);
					news=(char *)1;
					break;
				case TOK_FLX_GETITEMTEXT:
					TOS2=cmc->GetInfo(FLX_GETITEMTEXT,"SII",TOS2,TOS);
					P--;
					news=(char *)1;
					break;
				case TOK_FLX_GETITEMPATH:
					TOS2=cmc->GetInfo(FLX_GETITEMPATH,"SII",TOS2,TOS);
					P--;
					news=(char *)1;
					break;
				case TOK_FLX_GETITEMTYPE:
					TOS2=cmc->GetInfo(FLX_GETITEMTYPE,"III",TOS2,TOS);
					P--;
					break;
				case TOK_FLX_GETROOTITEM:
					TOS=cmc->GetInfo(FLX_GETROOTITEM,"II0",TOS,0);
					break;
				case TOK_FLX_GETSELECTEDITEM:
					TOS=cmc->GetInfo(FLX_GETSELECTEDITEM,"II0",TOS,0);
					break;
				case TOK_FLX_GETCHILDITEM:
					TOS2=cmc->GetInfo(FLX_GETCHILDITEM,"III",TOS2,TOS);
					P--;
					break;
				case TOK_FLX_GETNEXTSIBLINGITEM :
					TOS2=cmc->GetInfo(FLX_GETNEXTSIBLINGITEM,"III",TOS2,TOS);
					P--;
					break;
				case TOK_FLX_GETPARENTITEM:
					TOS2=cmc->GetInfo(FLX_GETPARENTITEM,"III",TOS2,TOS);
					P--;
					break;
				case TOK_FLX_GETLISTCOUNT:
					P++;
					TOS=cmc->GetInfo(FLX_GETLISTCOUNT,"I00",0,0);
					break;
				case TOK_FLX_GETLISTITEMTEXT:
					TOS=cmc->GetInfo(FLX_GETLISTITEMTEXT,"SI0",TOS,0);
					news=(char *)1;
					break;
				case TOK_FLX_FINDITEM:
					TOS=cmc->GetInfo(FLX_FINDITEMPREPARE,"III",TOS,TOS3); //recurse,item 
					TOS4=cmc->GetInfo(FLX_FINDITEM,"IIS",TOS4,TOS2); // tree, string
					P-=3;
					break;
				case TOK_FLX_GETIMISCINFO:
					TOS=cmc->GetInfo(FLX_GETIMISCINFO,"II0",TOS,0);
					break;
				case TOK_FLX_GETSMISCINFO:
					TOS=cmc->GetInfo(FLX_GETSMISCINFO,"SI0",TOS,0);
					news=(char *)1;
					break;
				case TOK_FLX_SCRIPTEVAL:
					TOS=cmc->GetInfo(FLX_SCRIPTEVAL,"SS0",TOS,0);
					news=(char *)1;
					break;
				case TOK_FINDWINDOW:
					TOS2=(int)::FindWindow((char *)TOS2,(char *)TOS);
					P--;
					break;
				case TOK_MESSAGEBOX:
					TOS3=MessageBox(NULL,(char *)TOS3,(char *)TOS2,TOS | MB_TOPMOST);
					P-=2;
					break;
				case TOK_INPUTBOX:
					dlgtitle=(char *) TOS2;
					dlgtext=(char *) TOS;
					*separator=inputseparator;
					*(separator+1)='\0';
					dlgbox=DialogBox(instance,MAKEINTRESOURCE(IDD_INPUTDIALOG),NULL,InputDlgProc);
					news=dlgtext;
					P--;
					break;
				case TOK_RAND:
					TOS=rand()*TOS/RAND_MAX;
					break;
				case TOK_IEVAL:
					TOS=IEval((char *) TOS);
					break;
				case TOK_SEVAL:
					news=SEval((char *) TOS);
					break;
				case TOK_STRLEN:TP[P]=strlen((char *) TOS);
					break;
				case TOK_STRCAT:
					newsl=strlen((char *) TOS)+strlen((char *) TOS2)+1;
					news=new char[newsl];
					strcpy(news,(char *) TOS2);
					strcat(news,(char *) TOS);
					P--;
					break;
				case TOK_ATOI:
					TOS=atoi((char *) TOS);
					break;
				case TOK_ISALPHA:
					bbool=isalpha((char)(*(char *) TOS));
					if (bbool)
						TOS=1;
					else
						TOS=0;
					break;
				case TOK_ISDIGIT:
					bbool=isdigit((char)(*(char *) TOS));
					if (bbool)
						TOS=1;
					else
						TOS=0;
					break;
				case TOK_ISSPACE:
					bbool=isspace((char)(*(char *) TOS));
					if (bbool)
						TOS=1;
					else
						TOS=0;
					break;
				case TOK_ITOA:
					news=new char[33];
					itoa(TOS,news,10);
					break;
				case TOK_ITOAX:
					news=new char[20];
					*news='0';*(news+1)='x';
					itoa(TOS,news+2,16);
					break;
				case TOK_ASC:
					TOS=(int)(*((char *) TOS));
					break;
				case TOK_CHR:
					news=new char[2];
					if(TOS<256 && TOS>=0)
						*news=(char)TOS;
					else
						*news=' ';
					*(news+1)='\0';
					break;
				case TOK_CHAR:
					olen=strlen((char *)TOS2);
					if (TOS>=0 && TOS<=olen)
						TOS2=(int)(*((char *) TOS2+TOS));
					P--;
					break;
				case TOK_INTARRAY:
					olen=((macvar *)TOS2)->dim;
					if (TOS>=0 && TOS<olen)
						TOS2=((macvar *)TOS2)->array[TOS];
					else
						TOS2=0;
					P--;
					break;
				case TOK_STRINGARRAY:
					olen=((macvar *)TOS2)->dim;
					lasttyp=TYP_STRING;
					if (TOS>=0 && TOS<olen)
						if (((macvar *)TOS2)->array[TOS]!=0){
							TOS2=((macvar *)TOS2)->array[TOS];
							P--;
							break;
						}
					news=new char[1];
					*news='\0';
					P--;
					break;
				case TOK_LEFT:
					clen=TOS;
					olen=strlen((char *)TOS2);
					if (clen<0) clen=0;
					if (olen<clen) clen=olen;
					news=new char[clen+1];
					if (clen>0)
						strncpy(news,(char *) TOS2,clen);
					*(news+clen)='\0';
					P--;
					break;
				case TOK_RIGHT:
					clen=TOS;
					if (clen<0) clen=0;
					olen=strlen((char *)TOS2);
					if (olen<clen) clen=olen;
					news=new char[clen+1];
					if (clen>0)
						strncpy(news,(char *) (TOS2+olen-clen),clen);
					*(news+clen)='\0';
					P--;
					break;
				case TOK_MID:
					clen=TOS;
					cpos=TOS2;
					olen=strlen((char *)TOS3);
					if (cpos<olen && clen>=0 && cpos>=0){
						if (olen<clen+cpos) 
							clen=olen-cpos;
					}else
						clen=0;
					news=new char[clen+1];
					if (clen>0)
						strncpy(news,(char *) (TOS3+cpos),clen);
					*(news+clen)='\0';
					P-=2;
					break;
				case TOK_REPLACE:
					news=doreplace((char *)TOS3,(char *) TOS2, (char *) TOS);
					P-=2;
					break;
				case TOK_INSTR:
					P--;
					ins=strstr((char *)TOS,(char *)TOSP);
					if (ins==NULL)
						TOS=-1;
					else
						TOS=ins-(char *)TOS;
					break;
				case TOK_UCASE:
					news=new char[strlen((char *)TOS)+1];
					strcpy(news,(char *)TOS);
					strupr(news);
					break;
				case TOK_LCASE:
					news=new char[strlen((char *)TOS)+1];
					strcpy(news,(char *)TOS);
					strlwr(news);
					break;
				case TOK_CHARS:
					clen=TOS;
					if (TOS2<0 || TOS2>255) TOS2=32;
					if (clen<0) clen=0;
					news=new char[clen+1];
					cpos=0;
					while (cpos<clen) *(news+cpos++)=(char)TOS2;
					*(news+clen)='\0';
					P--;
					break;
				case TOK_PATHEXISTS:
					TOS=1+_access( (char *) TOS, 0 );
					break;
				case TOK_ENUMFILES:
					P-=2;
					TOS=EnumFiles( (char *) TOS, (bool)(TOSP!=0),(macvar *) TOSP2 );
					break;
				case TOK_LOADSTRINGFROM:
					struct _stat buf;
					int result;
					result=_stat((char *) TOS, &buf );
					if (result==0) {
						newsl=buf.st_size;
						news=new char[newsl+1];
						news[0]='\0';
						FILE* f=fopen((char *) TOS,"rb");
						if (f!=NULL) {
							fread(news,1,newsl,f);
							fclose(f);
						}
					} else {
						news=new char[1];
						news[0]='\0';
					}
					break;
			}
		//Macro calls
		}else if (uToken>=TOK_CALL){
			prm=uToken-TOK_CALL;
			P-=prm;
			calling++;
			calledmacro=(macro *)TOS;
			savedcount=calledmacro->SaveVars();
			vprm=calledmacro->pparms;
			PP=P+1;
			while (vprm!=NULL){
				if (vprm->dim!=0){
					vprm->dim=((macvar *)TP[PP])->dim;
					vprm->array=((macvar *)TP[PP])->array;
				} else if (vprm->type & TYP_INT)
					vprm->iVal=TP[PP];
				else{
					ReaffectString(&vprm->sVal,(char *) TP[PP]);
				}
				PP++;
				vprm=vprm->next;
			}
			calledmacro->Play();
			if (calledmacro->retval->type & TYP_INT)
				TOS=(int)(calledmacro->retval->iVal);
			else if (calledmacro->retval->type & TYP_STRING){
				TOS=(int)(calledmacro->retval->sVal);
				news=(char *)1;
			}
			calledmacro->RestoreVars(savedcount);
			calling--;
		// xCONST xVAR xMACRO xFUNC
		}else if (uToken>=TOK_ICONST){
			if (uToken==TOK_SCONST) {
				P++;
				TOS=(int)c;	//TOS points to included string
				c+=(strlen((char *)c)+1); // skip string
				lasttyp=TYP_STRING;
			} else {
				v=*((macvar **)c);
				c+=4;
				P++;
				if (uToken==TOK_ICONST || v->dim!=0) { // for ICONST : is value
					TOS=(int)v;
				} else if (uToken==TOK_SVAR) {
					TOS=(int)(v->sVal);
					lasttyp=TYP_STRING;
				} else {
					// For TOK_IVAR, is variable value
					// For TOK_xFUNC is a pointer to fdesc (used later by TOK_XFUNCTIONx)
					// For TOK_xMACRO is a pointer to Macro (used later by TOK_CALL)
					TOS=v->iVal;
				}
			}

		// Pseudo variables
		}else if (uToken>=TOK_SCITE_FILENAME){
			if (uToken==TOK_SCITE_FILENAME) {
				P++;
				TOS=cmc->GetInfo(SCD_ASKFILENAME,"S00",0,0);
				news=(char *)1;
			} else if (uToken==TOK_LASTERROR) {
				P++;
				TOS=execerror;
			}else {
				P++;
				time_t acttime;
				tm * loctime;
				time(&acttime);
				loctime=localtime(&acttime);

				switch (uToken) {
					case TOK_YEAR: TOS=loctime->tm_year+1900;break;
					case TOK_MONTH: TOS=loctime->tm_mon+1;break;
					case TOK_DAY: TOS=loctime->tm_mday;break;
					case TOK_HOUR: TOS=loctime->tm_hour;break;
					case TOK_MINUTE: TOS=loctime->tm_min;break;
					case TOK_SECOND: TOS=loctime->tm_sec;break;
				}
			}
		// Operators
		}else{
			P--;
			switch (uToken){
				case TOK_PLUS: TOS+=TOSP;break;
				case TOK_MINUS: TOS-=TOSP;break;
				case TOK_MUL: TOS*=TOSP;break;
				case TOK_DIV: 
					if (TOSP==0)
						TOS=0;
					else
						TOS/=TOSP;
					break;
				case TOK_MOD: 
					if (TOSP==0)
						TOS=0;
					else
						TOS%=TOSP;
					break;
				case TOK_PUI:
					if (TOSP<0)
						TOS=0;
					else
						TOS=0;
						//TOS2=pow((double)TOS2,(double)TOS);
					break;
				case TOK_EQUAL: TOS=(TOS==TOSP);break;
				case TOK_NEQUAL: TOS=(TOS!=TOSP);break;
				case TOK_INF: TOS=(TOS<TOSP);break;
				case TOK_SUP: TOS=(TOS>TOSP);break;
				case TOK_INFEQ: TOS=(TOS<=TOSP);break;
				case TOK_SUPEQ: TOS=(TOS>=TOSP);break;
				case TOK_OR: TOS=(TOS||TOSP);break;
				case TOK_AND: TOS=(TOS&&TOSP);break;
				case TOK_BITOR: TOS=(TOS|TOSP);break;
				case TOK_BITXOR: TOS=(TOS^TOSP);break;
				case TOK_BITAND: TOS=(TOS&TOSP);break;
				case TOK_LSHIFT: TOS=(TOS<<TOSP);break;
				case TOK_RSHIFT: TOS=(TOS>>TOSP);break;
				case TOK_NOT: P++;TOS=!TOS;break;
				case TOK_OPP: P++;TOS=-TOS;break;
				case TOK_SEQUAL: 
					TOS=(lstrcmp((char*)TOSP,(char*)TOS)==0);
					break;
				case TOK_SNEQUAL: 
					TOS=(lstrcmp((char*)TOSP,(char*)TOS)!=0);
					break;
				case TOK_SSUP: 
					TOS=(lstrcmp((char*)TOSP,(char*)TOS)<0);
					break;
				case TOK_SINF: 
					TOS=(lstrcmp((char*)TOSP,(char*)TOS)>0);
					break;
				case TOK_SSUPEQ: 
					TOS=(lstrcmp((char*)TOSP,(char*)TOS)<=0);
					break;
				case TOK_SINFEQ: 
					TOS=(lstrcmp((char*)TOSP,(char*)TOS)>=0);
					break;
			}//switch
		}//else
		// Keep trace of allocated temporary string
		if (news!=NULL){
			if (news==(char *)1){ //already on TOS
				news=new char[strlen((char *)TOS)+1];
				strcpy(news,(char *) TOS);
			}else
				TOS=(int)news;
			tempsptr++;
			temps[tempsptr]=news;
			lasttyp=TYP_STRING;
		}		
	}//while

	//store result and get return value
	int rval;
	if (lasttyp & TYP_INT){
		mv->iVal=TP[0];
		rval=mv->iVal;
	}else{
		ReaffectString(&mv->sVal,(char *)TP[0]);
		rval=(int)(mv->sVal);
	}
	//free temporary strings
	while (tempsptr!=-1){
		delete []temps[tempsptr];
		tempsptr--;
	}

	return rval;
}

// Main Expression compilation
// called by :
// - CompileParameters
// - CompileAffect
// - CompileOneInstruction
// - GetExpressionValue
 

char * macro::CompileExpression(char * p,int typ)
{

	unsigned char TP[20];		//RPN stack
	int P;						//RPN stackptr
	char * e=p;					//input pointer
	unsigned char Tokens[2000];	//tokenized expression
	unsigned char * tptr;		//temp compiled string pointer
	unsigned char * cptr;		//final compiled string pointer
	unsigned char uToken;		//current token
	char * kptr;				//pointer inside kword
	char stringp[500];			//temporary strings
	bool isbeg=true;			//true after '(' and when first entering
	int opar=0;					//opening '(' counter
	int fcalls=0;				// function/macro call counter
	int fcallpars[10];			//nested calls
	int croch=0;				// nested '[]'
	bool gotvar=false;			//true if vars/macro calls
	unsigned char lastfound=0;
	int found=0;
	macvar * gotarray=NULL;
	
	e=cd->SkipSpaces(e);
	char * ebeg=e;
	tptr=Tokens;
	
	while (*e!='\0' && *e!='\r' && *e!='\n' && *e!=';'&& *e!='{'){
		found=0;
		if (*e=='\"' || *e=='\''){
			int gnum=0;
			bool gfound=false;
			char limitchar=*e;
			char *sptr=stringp;
			e++;
			while(!gfound){
				if (*e=='\\'){
					e++;
					if (*e=='n'){
						*sptr++='\n';e++;
					} else if (*e=='r'){
						*sptr++='\r';e++;
					} else if (*e=='t'){
						*sptr++='\t';e++;
					} else if (*e=='\\'){
						*sptr++='\\';e++;
					} else
						*sptr++=*e++;
				} else if (*e==limitchar){
					gfound=true;
				} else if(*e=='\0' || *e=='\r' || *e=='\n'){
					CompileError(ERR_MISSINGCQUOTE);
					break;
				} else
					*sptr++=*e++;
			}
			if (gfound){
				*sptr='\0';
				if (limitchar=='\'') {
					*tptr++=(char)(TOK_ICONST);		//const
					*((int *)tptr)=(int)(*stringp);tptr+=4;
				} else {
					*tptr++=(char)(TOK_SCONST);		//const
					strcpy((char *)tptr,stringp);
					tptr+=(strlen(stringp)+1);
				}
				e=cd->SkipSpaces(e+1);
			}
		}
		else if (isalpha(*e)){
			e=cd->PickWord(e);
			// search constant
			int i=0;
			found=65535;
			do{
				if (!lstrcmp(cd->keyword,constanttable[i].desc)){
					found=constanttable[i].value;
					break;
				}
				i++;
			}while (i<constants);
			if (found!=65535){
				AddVar(NULL,TYP_INT);
				vars->iVal=found;
				*tptr++=(char)(TOK_IVAR);		//var
				*((int *)tptr)=(int)vars;tptr+=4;		
				isbeg=false;
				found=0;
				continue;
			}
			
			//search function
			i=0;
			found=0;
			bool xfunc=false;
			char * params;
			do{
				if (!lstrcmp(cd->keyword,ifunctiontable[i].desc)){
					found=ifunctiontable[i].message;
					params=ifunctiontable[i].parms;
					break;
				}
				i++;
			}while (ifunctiontable[i-1].message!=0);
			if (found==0){
				//is it a Scintilla Function ?
				i=0;
				do{
					if (!lstrcmp(cd->keyword,xfunctiontable[i].desc)){
						found=xfunctiontable[i].message;
						params=xfunctiontable[i].parms;
						xfunc=true;
						break;
					}
					i++;
				}while (i<=xfunctions);
			}
			//function
			if (found!=0){
				if (xfunc){
					// will compile to <TOK_XFUNCTIONx><TOK_xFUNC> fdesc*
					int nparms=0;
					if (*(params+1)!='0' && *(params+1)!='R') nparms++;
					if (*(params+2)!='0' && *(params+2)!='R') nparms++;
					*tptr++=TOK_XFUNCTION+nparms;
					AddVar(NULL,TYP_INT);	
					vars->iVal=(int)(&xfunctiontable[i]);
					if (*params=='I')
						*tptr++=(char)(TOK_IFUNC);			//int function
					else
						*tptr++=(char)(TOK_SFUNC);			//string function
					*((int *)tptr)=(int)vars;tptr+=4;	//params *		
					gotvar=true;
					//lastfound=TOK_XFUNCTION+nparms;
				}else{
					if ((found==TOK_RAND) || 
						(found==TOK_MESSAGEBOX)|| 
						(found==TOK_INPUTBOX)||
						(found==TOK_SCITE_PROPERTY)||
						(found>=TOK_FLX_GETROOTITEM)||
						(found>=TOK_SCITE_FILENAME && found<TOK_IVAR))
						gotvar=true;
					*tptr++=found;
				}
			//Macro or var
			}else{
				macvar * v=FindVar(cd->keyword);
				if (v==NULL){
					cd->gotcall=calling_macro;
					macro * foundm=FindMacroByName(cd->keyword,this);
					if (foundm!=NULL){
						found=TOK_CALL;
						//will compile to : <TOK_CALLx><TOK_xMACRO> macro*
						*tptr++=(char)(TOK_CALL+foundm->parms);	//call
						AddVar(NULL,TYP_INT);	
						vars->iVal=(int)foundm;
						if (foundm->type==TYP_INT)
							*tptr++=(char)(TOK_IMACRO);			//int macro
						else if (foundm->type==TYP_STRING)
							*tptr++=(char)(TOK_SMACRO);			//string macro
						else
							CompileError(ERR_MACTYPMISMATCH);
						*((int *)tptr)=(int)vars;tptr+=4;	//macro *		
					}else
						CompileError(ERR_VARMACNOTFOUND);
				}else{
					if (v->type & TYP_INT) {
						if (*e=='['){
							if (v->dim!=0)
								*tptr++=TOK_INTARRAY;
							else
								CompileError(ERR_ARRAYNOTDECLARED);
						}
						else
							if (v->dim!=0)
								gotarray=v;
						*tptr++=(char)(TOK_IVAR);	//int var					
					} else {
						if (*e=='[')
							if (v->dim!=0)
								*tptr++=TOK_STRINGARRAY;
							else
								*tptr++=TOK_CHAR;
						else
							if (v->dim!=0)
								gotarray=v;
						*tptr++=(char)(TOK_SVAR);	//string var
					}
					*((int *)tptr)=(int)v;tptr+=4;		
				}
				gotvar=true;
			}
			isbeg=false;
		}else if (isdigit(*e)){
			kptr=cd->keyword;
			char * nformat;
			if (*e=='0' && (*(e+1)=='x' || *(e+1)=='X')){
				*kptr++=*e++;*kptr++=*e++;
				while(isxdigit(*e)) *kptr++=*e++;
				nformat="%x";
			} else {
				while(isdigit(*e)) *kptr++=*e++;
				nformat="%i";
			}
			*kptr='\0';
			*tptr++=(char)(TOK_ICONST);		//const
			sscanf(cd->keyword,nformat,(int *) tptr);
			tptr+=4;		
			isbeg=false;
			e=cd->SkipSpaces(e);
		}else{
			char * etemp=e;
			char ch1=*e;
			char ch2[]="xx";
			char * isop1=strchr(ops1,ch1);
			if (isop1!=NULL){
				*ch2=ch1;
				e++;
				e=cd->SkipSpaces(e);
				*(ch2+1)=*e;
				int op1=tops1[isop1-ops1];
				char * isop2=strstr(ops2,ch2);
				if (isop2!=NULL) 
					*tptr++=(char) tops2[(isop2-ops2)/3];
				else {
					if (op1==0)
						CompileError(ERR_BADOP); // '=' alone
					else {
						e=etemp;
						
						if (isbeg && op1==TOK_MINUS)
							op1=TOK_OPP;
						*tptr++=op1;
					}
				}
			}

			if (*e=='('){
				if (lastfound>=TOK_CALL){
					fcalls++;fcallpars[fcalls]=opar;
				}
				opar++;
				isbeg=true;
			} else if (*e==')'){
				isbeg=false;
				opar--;
				if (fcalls!=0)
					if (fcallpars[fcalls]==opar)
						fcalls--;
				if (opar==-1) {
					tptr--;
					break;
				}
			} else if (*e=='['){
				croch++;
			} else if (*e==']'){
				croch--;
				if (croch==-1)
					break;
			} else if (*e==',') { 
				isbeg=true;
				if (fcalls==0) {
					tptr--;
					break;
				}
			} else
				isbeg=false;
			e=cd->SkipSpaces(e+1);
		}//if
		lastfound=(unsigned char)found;
	}//while ...
	*tptr='\0';

//Conversion en postfixe
	P=0;
	tptr=Tokens;
	cptr=tptr;
	while (*tptr!='\0')
	{	
		uToken=*tptr++;
		// Parenthse fermante
		if (uToken==TOK_CPAR) {						  	
			while (P>0 && TP[P-1]!=TOK_OPAR) 
				*cptr++=TP[--P];			//depile; 
			if (TP[P-1]!=TOK_OPAR){
				CompileError(ERR_MISSINGOPAR);       	//manque ouvrante
				break;
			}
			P--;                       	//depile ouvrante
		//Parenthse ouvrante ou fonc 
		} else if (uToken>=TOK_OPAR){ 
			TP[P++]=uToken;				//empile
		//variables xMacro xFunc
		}else if (uToken>=TOK_ICONST){
			*cptr++=uToken;
			if (uToken==TOK_SCONST) {
				while (*tptr!='\0') *cptr++=*tptr++;
				*cptr++=*tptr++;
			} else {
				*((int *)cptr)=*((int *)tptr);
				tptr+=4;cptr+=4;
			}
		//pseudo variables
		} else if (uToken>=TOK_SCITE_FILENAME){
			*cptr++=uToken;
		//Operation
		} else {
			while (P!=0 && TP[P-1]!=TOK_OPAR && TP[P-1]>=uToken) 
				*cptr++=TP[--P];//depile; 
			if (uToken!=TOK_COMMA) 
				TP[P++]=uToken; //empile;	
		}
	}

	while (P!=0){
	   if (TP[P-1]==TOK_OPAR){ 
		   CompileError(ERR_MISSINGCPAR);      // manque fermante
		   break;
	   }
	   *cptr++=TP[--P];//depile;
	}
	*cptr='\0';
/*	if (cptr==Tokens){
		CompileError(ERR_EMPTYEXPR);
	}*/

	// Remove trailing blanks
	char * ee=e;
	while ((*(ee-1)==' '  || *(ee-1)=='\t') && ee>ebeg) ee--;

	// Create a variable
	// The variable is added to the list head, and vars point to it
	AddVar(NULL,TYP_EXPR|typ);
	// Copy the expression text
	vars->eVal=new char[ee-ebeg+1];
	memcpy(vars->eVal,ebeg,ee-ebeg);
	*(vars->eVal+(int)(ee-ebeg))='\0';

	// If not debugging, compiled expression is some parameter
	// for instruction being compiled : append parameter
	if (!debugging)
		AppendParm((int)vars);
						
	// Check expression
	if (!macerror){
		int l1=cptr-Tokens+1;
		vars->cVal=new char[l1];
		//Copy the RPN string
		memcpy(vars->cVal,Tokens,l1);
		int chk=CheckEval(vars);
		if (chk>0) 
			CompileError(chk);
		else if (-chk!=typ)
			CompileError(ERR_TYPMISMATCH);	
	}
	
	if (!macerror){	
	// Evaluate expression if constant	
		if (!gotvar){
			EvalExpression(vars);
			vars->type|=TYP_CONST;
		} else if (gotarray){
			if (((unsigned char)vars->cVal[0]==TOK_IVAR) || ((unsigned char)vars->cVal[0]==TOK_SVAR))
				if (vars->cVal[5]==0)
					//This happens when declaring a Macro having an array as parameter
					//Then the expression is an array name alone, and compiles to :
					// <TOK_xVAR> varptr <0> five bytes plus ending zero
					vars->dim=-2;
			
		}
	}else{
		// In case of error : delete the compiled expression
		if (vars->cVal!=NULL){
			delete []vars->cVal;
			vars->cVal=NULL;
		}
		// This expression is bad and should not be evaluated ...
		// But, who knows ? ...
		// Give null values, just in case ...
		if (vars->type & TYP_INT)
			vars->iVal=0;
		else{
			vars->sVal=new char[1];
			*(vars->sVal)='\0';
		}
	}


	return e;
}

