#if !defined(MACEXP_H__INCLUDED_)
#define MACEXP_H__INCLUDED_

//Defined tokens : numbering reflects priority
//Binary operators
#define TOK_COMMA 1
#define TOK_AND 2
#define TOK_OR 3
#define TOK_BITAND 4
#define TOK_BITXOR 5
#define TOK_BITOR 6

#define TOK_EQUAL 7
#define TOK_INF 8
#define TOK_SUP 9
#define TOK_NEQUAL 10
#define TOK_INFEQ 11
#define TOK_SUPEQ 12

#define TOK_LSHIFT 13
#define TOK_RSHIFT 14

#define TOK_PLUS 15
#define TOK_MINUS 16
#define TOK_MUL 17
#define TOK_DIV 18
#define TOK_MOD 19
#define TOK_PUI 20

//string comparison in same order as number comparison tokens
#define TOK_SEQUAL 25
#define TOK_SINF 26
#define TOK_SSUP 27
#define TOK_SNEQUAL 28
#define TOK_SINFEQ 29
#define TOK_SSUPEQ 30
//unary operators
#define TOK_NOT 31
#define TOK_OPP 32

//pseudo-variables (SciTE info)
#define TOK_SCITE_FILENAME 52

//pseudo-variables (Date/Time)
#define TOK_LASTERROR 64
#define TOK_YEAR 65
#define TOK_MONTH 66
#define TOK_DAY 67
#define TOK_HOUR 68
#define TOK_MINUTE 69
#define TOK_SECOND 70
//Integer/String constants
#define TOK_ICONST 128
#define TOK_SCONST 129
//Integer/String variables
#define TOK_IVAR 130
#define TOK_SVAR 131
//Integer/String macro calls
#define TOK_IMACRO 132
#define TOK_SMACRO 133
//Integer/String function calls
#define TOK_IFUNC 134
#define TOK_SFUNC 135
//Parentheses
#define TOK_OPAR 140
#define TOK_CPAR 141
//Call 144+i = Call with i parameters
#define TOK_CALL 144
//functions
#define TOK_STRLEN 160
#define TOK_STRCAT 161
#define TOK_ATOI 162
#define TOK_ITOA 163
#define TOK_CHR 164
#define TOK_ASC 165
#define TOK_LEFT 166
#define TOK_RIGHT 167
#define TOK_MID 168
#define TOK_INSTR 169
#define TOK_ISALPHA 170
#define TOK_ISDIGIT 171
#define TOK_ISSPACE 172
#define TOK_IEVAL 173
#define TOK_SEVAL 174
#define TOK_UCASE 175
#define TOK_LCASE 176
#define TOK_RAND 177
#define TOK_CHARS 178
#define TOK_ITOAX 179
#define TOK_CHAR 180
#define TOK_INTARRAY 181
#define TOK_STRINGARRAY 182
#define TOK_MESSAGEBOX 183
#define TOK_INPUTBOX 184
#define TOK_REPLACE 185
#define TOK_FINDWINDOW 186
#define TOK_SCITE_PROPERTY 187
#define TOK_PATHEXISTS 188
#define TOK_ENUMFILES 189
#define TOK_LOADSTRINGFROM 190

#define TOK_FLX_GETROOTITEM 200
#define TOK_FLX_GETCHILDITEM 201
#define TOK_FLX_GETNEXTSIBLINGITEM 202
#define TOK_FLX_GETPARENTITEM 203
#define TOK_FLX_GETSELECTEDITEM 204
#define TOK_FLX_GETITEMTEXT 205
#define TOK_FLX_GETITEMPATH 206
#define TOK_FLX_GETITEMTYPE 207
#define TOK_FLX_FINDITEM 208
#define TOK_FLX_FINDITEMPREPARE 209
#define TOK_FLX_GETLISTCOUNT 210
#define TOK_FLX_GETLISTITEMTEXT 211
#define TOK_FLX_GETIMISCINFO 212
#define TOK_FLX_GETSMISCINFO 213
#define TOK_FLX_SCRIPTEVAL 214

#define TOK_XFUNCTION 253


#define DIFFS TOK_SEQUAL-TOK_EQUAL
// For functions, parms is :
//	-	First char : result type (Integer or String)
//	-	Following chars : parameters types (Integer or String)

fdesc ifunctiontable[]={
				 {TOK_SCITE_FILENAME,"scite_filename","S"},
				 {TOK_SCITE_PROPERTY,"scite_property","SS"},
				 {TOK_ENUMFILES,"enumfiles","ISIS"},
				 {TOK_PATHEXISTS,"pathexists","IS"},
				 {TOK_FLX_GETITEMTEXT,"getitemtext","SII"},
				 {TOK_FLX_GETITEMPATH,"getitempath","SII"},
				 {TOK_FLX_GETITEMTYPE,"getitemtype","III"},
				 {TOK_FLX_GETROOTITEM,"getrootitem","II"},
				 {TOK_FLX_GETCHILDITEM,"getchilditem","III"},
				 {TOK_FLX_GETNEXTSIBLINGITEM,"getnextsiblingitem","III"},
				 {TOK_FLX_GETPARENTITEM,"getparentitem","III"},
				 {TOK_FLX_GETSELECTEDITEM,"getselecteditem","II"},
				 {TOK_FLX_GETLISTCOUNT,"getlistcount","I"},
				 {TOK_FLX_GETLISTITEMTEXT,"getlistitemtext","SI"},
				 {TOK_FLX_FINDITEM,"finditem","IIISI"},
				 {TOK_FLX_GETIMISCINFO,"getimiscinfo","II"},
				 {TOK_FLX_GETSMISCINFO,"getsmiscinfo","SI"},
				 {TOK_FLX_SCRIPTEVAL,"scripteval","SS"},
				 //{TOK_FLX_GETLISTITEMPATH,"getlistitempath","SI"},
				 {TOK_MESSAGEBOX,"messagebox","ISSI"},
				 {TOK_INPUTBOX,"inputbox","SSS"},
				 {TOK_STRLEN,"strlen","IS"},
				 {TOK_STRCAT,"strcat","SSS"},
				 {TOK_ATOI,"atoi","IS"},
				 {TOK_ITOA,"itoa","SI"},
				 {TOK_ITOAX,"itoax","SI"},
				 {TOK_CHR,"chr","SI"},
				 {TOK_ASC,"asc","IS"},
				 {TOK_LEFT,"left","SSI"},
				 {TOK_RIGHT,"right","SSI"},
				 {TOK_MID,"mid","SSII"},
				 {TOK_REPLACE,"replace","SSSS"},
				 {TOK_FINDWINDOW,"findwindow","ISS"},
				 {TOK_INSTR,"instr","ISS"},
				 {TOK_ISALPHA,"isalpha","IS"},
				 {TOK_ISDIGIT,"isdigit","IS"},
				 {TOK_ISSPACE,"isspace","IS"},
				 {TOK_IEVAL,"ieval","IS"},
				 {TOK_SEVAL,"seval","SS"},
				 {TOK_UCASE,"ucase","SS"},
				 {TOK_LCASE,"lcase","SS"},
				 {TOK_RAND,"rand","II"},
				 {TOK_CHARS,"chars","SII"},
				 {TOK_LOADSTRINGFROM,"loadstringfrom","SS"},

				 {TOK_LASTERROR,"lasterror","I"},
				 {TOK_YEAR,"year","I"},
				 {TOK_MONTH,"month","I"},
				 {TOK_DAY,"day","I"},
				 {TOK_HOUR,"hour","I"},
				 {TOK_MINUTE,"minute","I"},
				 {TOK_SECOND,"second","I"},//last colored
				 {TOK_CHAR,"_!_","ISI"},
				 {TOK_INTARRAY,"_!_","III"},
				 {TOK_STRINGARRAY,"_!_","SSI"},

				 {0,"","I"},
				 {TOK_COMMA,",","I"},
				 {TOK_AND,"&&","I"},
				 {TOK_OR,"||","I"},
				 {TOK_BITAND,"&","I"},
				 {TOK_BITOR,"|","I"},
				 {TOK_BITXOR,"^","I"},
				 {TOK_EQUAL,"==","I"},
				 {TOK_SEQUAL,"==","I"},
				 {TOK_NEQUAL,"!=","I"},
				 {TOK_SNEQUAL,"!=","I"},
				 {TOK_INF,"<","I"},
				 {TOK_SUP,">","I"},
				 {TOK_LSHIFT,"<<","I"},
				 {TOK_RSHIFT,">>","I"},
				 {TOK_INFEQ,"<=","I"},
				 {TOK_SUPEQ,">=","I"},
				 {TOK_PLUS,"+","I"},
				 {TOK_MINUS,"-","I"},
				 {TOK_MUL,"*","I"},
				 {TOK_DIV,"/","I"},
				 {TOK_MOD,"%","I"},
				 {TOK_PUI,"^","I"},
				 {TOK_STRCAT,"&","S"},
				 {TOK_NOT,"!","I"},
				 {TOK_OPP,"opp","I"},
				 {TOK_IVAR,"ivar","I"},
				 {TOK_SVAR,"svar","S"},
				 {TOK_ICONST,"iconst","I"},
				 {TOK_SCONST,"sconst","S"},
				 {TOK_IFUNC,"ifunc","I"},
				 {TOK_SFUNC,"sfunc","S"},
				 {TOK_IMACRO,"ifunc","I"},
				 {TOK_SMACRO,"sfunc","S"},
				 {-1,"??","I"},
};
#define FUNCTIONS sizeof(ifunctiontable)/sizeof(fdesc)-1

char ops1[]=",=!<>&|+-*/%^()";
static int tops1[]={
	TOK_COMMA,
	0,
	TOK_NOT,
	TOK_INF,
	TOK_SUP,
	TOK_BITAND,
	TOK_BITOR,
	TOK_PLUS,
	TOK_MINUS,
	TOK_MUL,
	TOK_DIV,
	TOK_MOD,
	TOK_BITXOR,
	TOK_OPAR,
	TOK_CPAR};
char ops2[]="==\n!=\n<=\n<<\n>=\n>>\n&&\n||\n";
static int tops2[]= {
	TOK_EQUAL,
	TOK_NEQUAL,
	TOK_INFEQ,
	TOK_LSHIFT,
	TOK_SUPEQ,
	TOK_RSHIFT,
	TOK_AND,
	TOK_OR };


#endif //!defined(MACEXP_H__INCLUDED_)/////////////////////////////////////////////////////////////////////////////

