// MiniFilxDlg.cpp : implementation file
//


#include "stdafx.h"
#include "..\inifile.h"
#include "MiniFilxDlg.h"
#include "resource.h"
#include "../shortcutdlg.h"
#include  <io.h>



#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


#define	hbut 20		//button dim
#define	marg 3		//margins



bool gPlaying;				//true when playing a macro
bool gRecording;				//true when recording a macro

extern char * gMacrobarpath;
macro * gCurmac=NULL;		//current macro
macro * gMacros=NULL;		//list of loaded macros
extern char * gMyDirectory;
extern CAtom gAtom;
extern bool gLaunchedfirst;
extern HWND gDest;
extern char * gMyName;

/////////////////////////////////////////////////////////////////////////////
// CSplashDlg dialog
/////////////////////////////////////////////////////////////////////////////


CSplashDlg::CSplashDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSplashDlg::IDD, pParent)
{
	withname=false;
}



void CSplashDlg::SetMessage(const char * message1,const char * message2/*=""*/)
{
	char * info;
	if (withname) {
		info=(char *)message1;
	} else {
		GetDlgItem(IDC_STATIC_LOAD)->ShowWindow(SW_HIDE);
		if (message2!=NULL) info=(char *)message2;
		GetDlgItem(IDC_STATIC_1)->SetWindowText(message1);	
	}
	GetDlgItem(IDC_STATIC_INFO)->SetWindowText(info);
}

/////////////////////////////////////////////////////////////////////////////
// CMiniFilxDlg dialog
/////////////////////////////////////////////////////////////////////////////




void CMiniFilxDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMiniFilxDlg)
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMiniFilxDlg, CDialog)
	//{{AFX_MSG_MAP(CMiniFilxDlg)
	ON_WM_CLOSE()
	ON_WM_COPYDATA()
	ON_WM_CONTEXTMENU()
	ON_WM_DESTROY()
	ON_WM_HELPINFO()
	ON_WM_SIZE()
	ON_WM_NCRBUTTONDOWN( )
	ON_WM_NCLBUTTONDBLCLK( )
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()



/////////////////////////////////////////////////////////////////////////////
// CMiniFilxDlg Creation



CMiniFilxDlg::CMiniFilxDlg()
	: CDialog(CMiniFilxDlg::IDD, NULL)
{
	SetCommunicator((CMacroCommunicator *) this); //testing=false
	gotinfo=false;
	wCorrespondent=0;
	logging=0;
	gPlaying=FALSE;
	gRecording=FALSE;
	buttons=NULL;
	lines=0;
	bcount=0;
	cols=0;
	haverecorded=false;
	m_splash=NULL;
}


CMiniFilxDlg::~CMiniFilxDlg()
{
}

BOOL CMiniFilxDlg::OnInitDialog()
{
	tooltip.Create(this);
	tooltip.SetMaxTipWidth(SHRT_MAX);
	tooltip.SetDelayTime(200);
    CDialog::OnInitDialog();
	if (!gLaunchedfirst) gAtom.Add((unsigned int)gDest);


	CRect drect;				//client rect
	SetWindowText(gMyName);
	SetIcon(FlxLoadIcon(IDI_ICON1),true);
	SetIcon(FlxLoadIcon(IDI_ICON1),false);


	int dolog=GetIniWorkInt("logging",0);
	*logpath='\0';
	if (dolog==1) {
		BuildPath("minilogpath",logpath,"MiniFilx.log");
		if (!logfile.Open(logpath,CFile::modeCreate | CFile::modeWrite))
			dolog=0;
	}
	logging=dolog;

	char ifacename[MAX_PATH];		//Scintilla.iface
	BuildPath("ifacepath",ifacename,"scintilla.iface");
	ifaceok=LoadIface(ifacename);

	if (!ifaceok)
		MessageBox("scintilla.iface not loaded ...","Check iface",MB_OK);
	else
		LoadMacros();

	char hw[10];
	itoa((int)m_hWnd,hw,10);

	ToSendMessage(SCD_IDENTIFY,hw);
	if (ifaceok)
		ToSendMessage(SCD_MACROENABLE,"1");

	if (gDest==0 && gLaunchedfirst)
		SciTEOpen("");

	///////////// Macro  Bar

	GetIniWorkString("macrobarpath",gMacrobarpath);
	AddButtons(true);
	EnableShortcuts(true);
	lastsk=0;
	lastskname="";
	PrepareCopyData(true);
	PlayMacro("_auto_run_");
	return TRUE;  // return TRUE unless you set the focus to a control
                // EXCEPTION: OCX Property Pages should return FALSE
}


/////////////////////////////////////////////////////////////////////////////
// CMiniFilxDlg Destruction


void CMiniFilxDlg::OnClose()
{
	//Tell user I'm closed
	ToSendMessage(SCD_MACROENABLE,"0");
	if (gDest!=0)
		BringSciTEToForeground();
	ToSendMessage(SCD_CLOSING);
	if (haverecorded)
		SaveMacroFile();

	CleanBeforeClosing();
	if (logging)
		logfile.Close();
	gAtom.Delete();
	CDialog::OnClose();
}


void CMiniFilxDlg::CleanBeforeClosing()
{
	DoSplash("");
	DeleteButtons();
	macro * m=gMacros;
	macro * mm;
	while (m!=NULL){
		mm=m;
		m=m->next;
		DeleteMacro(mm);
	}
}

/////////////////////////////////////////////////////////////////////////////
// CMiniFilxDlg Resizing / Redrawing


BOOL CMiniFilxDlg::PreTranslateMessage(MSG* pMsg)
{

	// If edit control is visible in tree view control, sending a
      // WM_KEYDOWN message to the edit control will dismiss the edit
      // control.  When ENTER key was sent to the edit control, the parent
      // window of the tree view control is responsible for updating the
      // item's label in TVN_ENDLABELEDIT notification code.

	if (pMsg->message==WM_HOTKEY) {
		int scut=pMsg->wParam;
		if (globalshortcut!=0) {
			ExecuteMacroShortcut();
		} else {
			macro * m=FindMacroByShortcut(scut);
			if (m!=NULL) {
				while (1) {
					if ((GetAsyncKeyState(VK_SHIFT) & 0x8000)==0) break;
					if ((GetAsyncKeyState(VK_CONTROL) & 0x8000)==0) break;
				}
				PlayMacro(m->name);
			}
		}
	}
	if (pMsg->message == WM_KEYDOWN &&
       pMsg->wParam == VK_ESCAPE) {
			return TRUE; //<Escape> won't close ...
	}

	tooltip.RelayEvent(pMsg);
	return CDialog::PreTranslateMessage(pMsg);
}


void CMiniFilxDlg::OnNcRButtonDown( UINT nHitTest, CPoint point )
{
	DoToolBarMenu(point);
}

void CMiniFilxDlg::OnNcLButtonDblClk( UINT nHitTest, CPoint point )
{
	bool takenext=false;
	char * newbarpath=NULL;
	char * firstbar=NULL;

	CIniSection * inisec=new CIniSection(SECTION_MACROBARMENU);
	while (inisec->GetNextKey()) {
		char * bpath=inisec->value;
		if (firstbar==NULL)
			firstbar=bpath;
		if (takenext) {
			newbarpath=bpath;
			break;
		}
		if (!stricmp(gMacrobarpath , bpath))
			takenext=true;
	}
	if (takenext && (newbarpath==NULL))
		newbarpath=firstbar;
	if (newbarpath!=NULL){
		DeleteButtons();
		lstrcpy(gMacrobarpath,newbarpath);
		AddButtons(false);
	}
	delete inisec;
}




void CMiniFilxDlg::ExecuteMacroShortcut()
{
	CShortcutDlg skdlg;
	skdlg.m_execute=true;
	skdlg.m_shortcut=lastsk;
	skdlg.m_name=lastskname;
	EnableShortcuts(false);
	if (skdlg.DoModal()==IDOK){
		lastsk=skdlg.macroshortcut;
		macro * m=FindMacroByShortcut(lastsk);
		if (m!=NULL) PlayMacro(m->name);
		lastskname=m->name;
	}
	EnableShortcuts(true);
}

BOOL CMiniFilxDlg::OnHelpInfo(HELPINFO* pHelpInfo)
{
	ShellExecute(NULL,"open","filerx.chm",NULL,gMyDirectory,SW_SHOWDEFAULT);
	return true;
}

void CMiniFilxDlg::OnSize(UINT nType, int cx, int cy)
{
	if (!noresize) {
		CToolButton * b=buttons;
		if (bcount!=0 && ::IsWindow(b->m_hWnd) && cx>(*buttonw)) {
			cols=(int)(cx/(*buttonw));
			lines=(int)(bcount/cols);
			if (lines*cols!=bcount) lines++;
			while (b!=NULL) {
				if (b->next==NULL) break;
				b=b->next;
			}
			CRect r;
			int tempcol=0;
			int templine=0;
			while (b!=NULL) {
				r.left=tempcol*(*buttonw);
				r.top=templine*(*buttonh);
				r.right=r.left+(*buttonw);
				r.bottom=r.top+(*buttonh);
				b->MoveWindow(&r);
				tempcol++;
				if (tempcol==cols) {
					tempcol=0;
					templine++;
				}
				b=b->prev;
			}
			*bcols=cols;
		}
	} else
		noresize=false;
	CDialog::OnSize(nType, cx, cy);
}


void CMiniFilxDlg::AddButtons(bool firstin)
{
	for (int i=0;i<=propmax;i++) {
		props[i]=GetIniMacrobarInt(barprops[i],bardefaults[i]);
	}

	buttonh= (havicons!=0 ? &ibuttonh : &tbuttonh);
	buttonw= (havicons!=0 ? &ibuttonw : &tbuttonw);
	bcols= (havicons!=0 ? &ibcols : &tbcols);

	CIniSection * inisec=new CIniSection(SECTION_MACROBAR);
	while (inisec->GetNextKey()) {
		char * subend=inisec->key;
		char * subname="";
		while((*subend)!='!' && (*subend)!='\0') subend++;
		if (*subend=='!') {*subend++='\0';subname=subend;}
		macro * m=FindMacroByName(inisec->key);
		if (m!=NULL) {
			AddOneButton(inisec->key,subname);
		}
	}
	delete inisec;

	macro * m=gMacros;
	while (m!=NULL){
		if (!strncmp(m->name,"Recorded",8))
			AddOneButton(m->name,"");
		m=m->next;
	}
	int borderx=2*GetSystemMetrics(SM_CXSIZEFRAME);
	int bordery=GetSystemMetrics(SM_CYCAPTION)+2*GetSystemMetrics(SM_CXSIZEFRAME);
	noresize=true;
	if ((*bcols)*lines==bcount) lines--;
	const CWnd * wp = (ontop ? &wndTopMost : &wndNoTopMost);
	if (!firstin) {
		xpos=xpossave;
		ypos=ypossave;
	}
	SetWindowPos(wp,xpos,ypos,(*bcols)*(*buttonw)+borderx,(lines+1)*(*buttonh)+bordery,SWP_SHOWWINDOW);
	tooltip.Activate(havicons);
}


void CMiniFilxDlg::AddOneButton(char * name,char * subname)
{

	CToolButton * b=new CToolButton;
	b->name=name;
	b->subname=subname;
	Cstr cininame=b->name;
	if (b->subname.len!=0) {
		cininame+="!";
		cininame+=b->subname;
	}

	char * ininame=cininame.buf;
	GetIniMacrobarString(&cininame,&b->iconpath);
	GetIniMacrobarString(&cininame,&b->args,1);
	b->buttonid=0;
	b->next=buttons;
	b->prev=NULL;
	if (buttons!=NULL) buttons->prev=b;
	buttons=b;

	RECT r;

	r.left=cols*(*buttonw);
	r.top=lines*(*buttonh);
	r.right=r.left+(*buttonw);
	r.bottom=r.top+(*buttonh);
	b->buttonid=bcount+10000;

	if (havicons) {
		b->Create("",BS_PUSHBUTTON | BS_ICON | WS_VISIBLE | WS_CHILD,r,this,b->buttonid);
		HICON  h=(HICON)LoadImage(0,b->iconpath.buf,IMAGE_ICON,16,16,LR_LOADFROMFILE);
		if (h==NULL){
			if (!strncmp(name,"Recorded",8))
				h=FlxLoadIcon(IDI_ICON_RECORD);
			else
				h=FlxLoadIcon(IDI_ICON_NEWMACRO);
		}
		b->SetIcon(h);
	} else {
		CFont * fnt=GetDlgItem(IDC_BUTTON_TNEXT)->GetFont();
		b->Create(ininame,WS_VISIBLE | WS_CHILD | WS_TABSTOP,r,this,b->buttonid);
		b->SetFont(fnt);
	}

	if (*subname!='\0')
		*(ininame+b->name.len)='\n';
	tooltip.AddTool((CWnd *)b,ininame);

	bcount++;
	cols++;
	if (cols==(*bcols)) {
		cols=0;
		lines++;
	}

}

void CMiniFilxDlg::DeleteButtons()
{
	CToolButton * b=buttons;
	while (b!=NULL) {
		CToolButton * bnext=b->next;
		tooltip.DelTool((CWnd *) b,b->buttonid);
		delete [] b;
		b=bnext;
	}
	bcount=0;
	buttons=NULL;
	lines=0;
	cols=0;
	
	CRect wrect;
	GetWindowRect(&wrect);
	xpos=wrect.left;
	ypos=wrect.top;
	for (int i=0;i<=propmax;i++) {
		SetIniMacrobarInt(barprops[i],props[i]);
	}
	xpossave=xpos;
	ypossave=ypos;
}

BOOL CMiniFilxDlg::OnCommand(WPARAM wParam, LPARAM lParam)
{
	int bnum=LOWORD(wParam);
	CToolButton * b=buttons;
	while (b!=NULL) {
		if (b->buttonid==bnum) break;
		b=b->next;
	}
		if (b!=NULL) {
			char * mname=b->name.buf;
			macro * m=FindMacroByName(mname);
			if (m!=NULL){
				if (m->flags==3 || m->flags==5) {
					RunMacroWithArgs(mname,b->args.buf);					
				} else {
					PlayMacro(mname);
				}
			}
		}
	return CDialog::OnCommand(wParam, lParam);
}


void CMiniFilxDlg::DoSplash(char * arg1,char * arg2/*=NULL*/)
{
	if (*arg1=='\0') {
		//use DoSplash("") to close splash window
		if (m_splash!=NULL) {
			m_splash->DestroyWindow();
			delete m_splash;
			m_splash=NULL;
		}
	} else {
		if (m_splash==NULL) {
			m_splash=new CSplashDlg();
			m_splash->Create(IDD_SPLASH);
		}
		m_splash->SetMessage(arg1,arg2);
	}

}