// MiniFilxDlg.h: interface for the CMiniFilxDlg class.

#if !defined(AFX_MINIFILXDLG_H__INCLUDED_)
#define AFX_MINIFILXDLG_H__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CSplashDlg dialog

class CSplashDlg : public CDialog
{
// Construction
public:
	CSplashDlg(CWnd* pParent = NULL);   // standard constructor
	void SetMessage(const char * message1,const char * message2="");
	bool withname;
// Dialog Data
	//{{AFX_DATA(CSplashDlg)
	enum { IDD = IDD_SPLASH };
	//}}AFX_DATA
};




/////////////////////////////////////////////////////////////////////////////
// CToolDlg dialog

class CMiniFilxDlg;

class CToolButton : public CButton
{
public:
	CToolButton * next;
	CToolButton * prev;
	int buttonid;
	Cstr name;
	Cstr subname;
	Cstr iconpath;
	Cstr args;
};

/////////////////////////////////////////////////////////////////////////////
// CMiniFilxDlg dialog

#define MAX_TITLE 200

struct MItemData {
	int		iItemID;
	HICON   hItemIcon;
    char   strItemText[200];
	char *  macroname;
};

class IconMenu :public CMenu
{
public:
	IconMenu();	
	~IconMenu();
    void DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct);
	void MeasureItem(LPMEASUREITEMSTRUCT lpMeasureItemStruct);  
};					



static char*  barprops[] = {"_x_","_y_","_ontop_","_have_icons_","_buttoncolumns_","_buttonw_","_buttonh_",
						"_textbuttoncolumns_","_textbuttonw_","_textbuttonh_"};
static int bardefaults[] = {100,100,0,0,16,23,23,6,110,30};


#define propmax 9
#define prop_x_ barprops[0]
#define prop_y_ barprops[1]
#define prop_ontop_ barprops[2]
#define prop_have_icons_ barprops[3]
#define prop_buttoncolumns_ barprops[4]
#define prop_buttonw_ barprops[5]
#define prop_buttonh_ barprops[6]
#define prop_textbuttoncolumns_ barprops[7]
#define prop_textbuttonw_ barprops[8]
#define prop_textbuttonh_ barprops[9]

#define default_x_ bardefaults[0]
#define default_y_ bardefaults[1]
#define default_ontop_ bardefaults[2]
#define default_have_icons_ bardefaults[3]
#define default_buttoncolumns_ bardefaults[4]
#define default_buttonw_ bardefaults[5]
#define default_buttonh_ bardefaults[6]
#define default_textbuttoncolumns_ bardefaults[7]
#define default_textbuttonw_ bardefaults[8]
#define default_textbuttonh_ bardefaults[9]

#define xpos props[0]
#define ypos props[1]
#define ontop props[2]
#define havicons props[3]
#define ibcols props[4]
#define ibuttonw props[5]
#define ibuttonh props[6]
#define tbcols props[7]
#define tbuttonw props[8]
#define tbuttonh props[9]





class CMiniFilxDlg : public CDialog, public CMacroCommunicator
{
public:
	CMiniFilxDlg();		//Construction
	~CMiniFilxDlg();
	void ToSendMessage(int typ,const char * arg=NULL,const char * arg2=NULL);	//Send Message to caller
	void ToSendMacroCommand(int cmd,int p1,char * t,char * params);
	void SendText(const char * txt);
	void SendWithToolTip(const char * txt) {};
	int GetInfo(int code,char * params,int arg,int arg2);
	void CleanBeforeClosing();
	void SciTEOpen(const char * path,bool activate=false);		//Open file in SciTE
	void BringSciTEToForeground();

	//Menu handling
	MItemData *  mdatas[20];	// 20 items allowed in menu
	int mdatacnt;				//menu items count
	void AddToMenu(UINT id) ;
	void DoToolBarMenu(CPoint point) ;


	//Macro Playing/Recording
	bool FilerxDebug(macro * m,int debugline) { return false;};
	void LoadMacros();
	void LoadMacroFile(char * name);
	void SaveMacroFile();
	void TextToMacros(char * buf);
	void RecordCommand(char * c);
	void PlayMacro(char * m =NULL);
	void StartRecordMacro(bool forcetesting=false);
	void StopRecordMacro();
	void CheckMacroName(char * nam);
	macro * AppendMacroToList(macro * m,char * name=NULL);
	void AddRecordedMacro();
	macro * FindMacroByName(char * mname);



	//Menu customizing macros
	bool RunMacroWithArgs(const char * macname,const char * macargs);
	//Macro List
	void BuildMacroList();
	void ExecuteMacroShortcut();

	//Shortcuts
	macro * FindMacroByShortcut(int shortcut);
	void EnableShortcuts(bool enable);

	//Buttons
	void AddOneButton(char * name,char * subname);
	void AddButtons(bool firstin=false);
	void DeleteButtons();
	void DoSplash(char *arg,char * arg2=NULL);

	int FindSciTEmenu(const char * text);

	CSplashDlg * m_splash;
	CToolTipCtrl tooltip;
	CToolButton * buttons;
	int bcount;
	int lines;
	int cols;

	int xpossave;
	int ypossave;

	int props[propmax+1];
	int * buttonh;
	int * buttonw;
	int * bcols;

	bool noresize;

	int logging;
	char logpath[MAX_PATH];
	CStdioFile logfile;
	void DoLog(const char * log1,const char * log2);


	HWND wCorrespondent;
	bool gotinfo;					//true when answer to info arrives
	Cstr sci_text_info;			//received text info
	int sci_int_info;				//received int info
	bool haverecorded;
	
	bool ifaceok;					//true when iface is loaded

	CMenu * popupmenu;					//main popup menu

	int globalshortcut;
	int lastsk;
	char * lastskname;

	// Dialog Data
	//{{AFX_DATA(CMiniFilxDlg)
	enum { IDD = IDD_MINIFILX };
	//}}AFX_DATA

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMiniFilxDlg)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL
// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CMiniFilxDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnClose();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	afx_msg BOOL OnCopyData(CWnd* pWnd, COPYDATASTRUCT* pCopyDataStruct);
	afx_msg void OnNcRButtonDown( UINT nHitTest, CPoint point );
	afx_msg void OnNcLButtonDblClk( UINT nHitTest, CPoint point );
	afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};




//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MINIFILXDLG_H__INCLUDED_)
