// menu.cpp : implementation file
//

#include "stdafx.h"
#include "..\inifile.h"
#include "MiniFilxDlg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define FILTER_MENU 1000
#define CUSTOM_MENU 10000

extern char * gMacrobarpath;

/////////////////////////////////////////////////////////////////////////////////
// Popup Menu Handling


void CMiniFilxDlg::AddToMenu(UINT id) 
{
	int iconid;
	if (id!=0){
		MItemData * mdata=new MItemData;
		mdatas[mdatacnt]=mdata;
		mdatacnt++;
		mdata->iItemID=id;
		LoadString(AfxGetResourceHandle(),id,mdata->strItemText,200);
		mdata->hItemIcon=NULL;
		iconid=0;
		if (id==IDS_ONTOP)
			iconid=IDI_ICON_ONTOP;
		else if (id==IDS_NOTONTOP)
			iconid=IDI_ICON_NOTONTOP;
		else if (id==IDS_TEXTBUT)
			iconid=IDI_ICON_TEXTBUT;
		else if (id==IDS_ICONBUT)
			iconid=IDI_ICON_ICONBUT;
		if (iconid!=0)
			mdata->hItemIcon=FlxLoadIcon(iconid);
		popupmenu->AppendMenu(MF_ENABLED | MF_OWNERDRAW, id,(LPCTSTR)mdata);
	}else
		popupmenu->AppendMenu(MF_SEPARATOR, 0);
}


/////////////////////////////////////////////////////////////////////////////////
// ToolBar Menu

void CMiniFilxDlg::DoToolBarMenu(CPoint point) 
{
	//InitMenu();
	popupmenu=new IconMenu();
	popupmenu->CreatePopupMenu();
	mdatacnt=0;

	AddToMenu((props[2] ? IDS_NOTONTOP : IDS_ONTOP));
	AddToMenu((props[3] ? IDS_TEXTBUT : IDS_ICONBUT));
	//AddCustomMenus()
	bool first=true;
	CIniSection * inisec=new CIniSection(SECTION_MACROBARMENU);
	while (inisec->GetNextKey()) {
		int vlen=lstrlen(inisec->value);
		if (vlen>0){
			if (first)
				AddToMenu(0);
			MItemData * mdata=new MItemData;
			mdatas[mdatacnt]=mdata;
			mdata->iItemID=mdatacnt+CUSTOM_MENU;
			strncpy(mdata->strItemText,inisec->key,199);
			mdata->macroname=inisec->value;
			mdata->hItemIcon=FlxLoadIcon(IDI_ICON_MACROBAR);
			mdatacnt++;
			popupmenu->AppendMenu(MF_ENABLED | MF_OWNERDRAW, mdata->iItemID,(LPCTSTR)mdata);
			first=false;
		}
	}
	
	//TrackMenu();
	UINT choice=popupmenu->TrackPopupMenu(TPM_RETURNCMD , point.x - 4, point.y,this,NULL);
	delete popupmenu;

	if (choice>0) {
		DeleteButtons();
		if (choice>=CUSTOM_MENU) {
			lstrcpy(gMacrobarpath,mdatas[choice-CUSTOM_MENU]->macroname);
		} else {
			int propnum=3;
			if (choice==IDS_ONTOP || choice==IDS_NOTONTOP)
				propnum=2;
	
			SetIniMacrobarInt(barprops[propnum],(int)!props[propnum]);
		}
		AddButtons();
	}
	if (mdatacnt>0) {
		for (int i=0;i<mdatacnt;i++) {
			MItemData * md=mdatas[i];
			if (md->hItemIcon!=NULL)
				DestroyIcon(md->hItemIcon);
			delete md;
		}
	}
	delete inisec;

}


/////////////////////////////////////////////////////////////////////////////////////////
// IconMenu Class

IconMenu::IconMenu()
{
}

IconMenu::~IconMenu()
{
	DestroyMenu();
}

#define ICON_WIDTH 16
#define ICON_HEIGHT 16

void IconMenu::DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct)
{
	MItemData * mdata=(MItemData *)lpDrawItemStruct->itemData;
	CDC* pdc=CDC::FromHandle(lpDrawItemStruct->hDC);

	CRect rect(lpDrawItemStruct->rcItem);
	CRect rcIcon(rect);
	rcIcon.left+=2;
	rcIcon.right=rcIcon.left+ICON_WIDTH;
	
	if (lpDrawItemStruct->itemAction & (ODA_SELECT | ODA_DRAWENTIRE)) {
		COLORREF backcolor;
		COLORREF textcolor;
		if (lpDrawItemStruct->itemState & ODS_SELECTED){
			backcolor=::GetSysColor(COLOR_HIGHLIGHT);
			textcolor=RGB(255,255,255);
		} else {
			backcolor=::GetSysColor(COLOR_BTNFACE);
			textcolor=::GetSysColor(COLOR_BTNTEXT);
		}
 		CBrush *pBrush=new CBrush(backcolor);
		pdc->FillRect(rect,pBrush);
		delete pBrush;

		if(mdata->hItemIcon){
			pdc->DrawState(rcIcon.TopLeft(),CSize(ICON_WIDTH,ICON_HEIGHT),mdata->hItemIcon,DST_ICON|DSS_NORMAL,(CBrush*)NULL);	
		}
		pdc->SetTextColor(textcolor);
		pdc->SetBkColor(backcolor);	
		rect.left=rcIcon.right+4;
		pdc->DrawText(mdata->strItemText,&rect,DT_LEFT|DT_NOCLIP|DT_SINGLELINE|DT_VCENTER);
	}   
}


void IconMenu::MeasureItem(LPMEASUREITEMSTRUCT lpMeasureItemStruct)
{
	MItemData  * mdata=(MItemData *)lpMeasureItemStruct->itemData;
	CDC* pdc=new CDC;
	pdc->Attach(::GetDC(AfxGetMainWnd()->m_hWnd));

    CFont m_fontMenu;
    LOGFONT m_lf;
    ZeroMemory ((PVOID) &m_lf,sizeof (LOGFONT));
    NONCLIENTMETRICS nm;
    nm.cbSize = sizeof (NONCLIENTMETRICS);
    SystemParametersInfo(SPI_GETNONCLIENTMETRICS,nm.cbSize,&nm,0); 
    m_lf =  nm.lfMenuFont;
    m_fontMenu.CreateFontIndirect (&m_lf);
    CFont* oldFont= pdc->SelectObject (&m_fontMenu);
    CSize szText=pdc->GetOutputTextExtent(mdata->strItemText);  
	pdc->SelectObject (oldFont); 
	m_fontMenu.DeleteObject();
	::ReleaseDC(AfxGetMainWnd()->m_hWnd,pdc->m_hDC);
	delete pdc;
	lpMeasureItemStruct->itemWidth=szText.cx+ICON_WIDTH+4;
	lpMeasureItemStruct->itemHeight=__max(ICON_HEIGHT,szText.cy)+3;
 }
			

