// MiniFilxx.cpp : Defines the class behaviors for the MiniFilxx application.
//

#include "stdafx.h"
#include "..\inifile.h"

#include "MiniFilxdlg.h"
#include "MiniFilxx.h"



CMiniFilxxApp NEAR theApp;
char * gMyName="MiniFilx";

CMiniFilxDlg * gMaindialog=NULL;
char * gInipath=NULL;
char * gMacrobarpath=NULL;
char * gMyDirectory=NULL;
CAtom gAtom(gMyName);
bool gLaunchedfirst;
HWND gDest;

void CMyCmdLineInfo::ParseParam(const char* pszParam, BOOL bFlag, BOOL bLast)
{
	if (!strncmp(pszParam,"macro:run:",10)) {
		theApp.macrotorun=new char[lstrlen(pszParam)+1];
		lstrcpy(theApp.macrotorun,pszParam);
	} else if (!strncmp(pszParam,"id:",3)) {
		char * desth=(char *)pszParam+3;
		int dest;
		while(*desth==' ') desth++;
		if (*desth=='0' && (*(desth+1)=='x' || *(desth+1)=='X'))
			sscanf(desth+2,"%x",&dest);
		else
			sscanf(desth,"%u",&dest);
		gDest=(HWND)dest;
	}
}

/////////////////////////////////////////////////////////////////////////////
// CMiniFilxxApp

BOOL CMiniFilxxApp::InitInstance()
{
	AfxOleInit();
	AfxEnableControlContainer();
	Enable3dControls();
	macrotorun=NULL;
	gDest=0;
	mustrun=true;
	gLaunchedfirst=true;

	gInipath=new char[MAX_PATH];
	gMacrobarpath=new char[MAX_PATH];
	gMyDirectory=new char[MAX_PATH];

	CMyCmdLineInfo cmdline;
	ParseCommandLine(cmdline);

	if (gDest!=0){	// I was launched by SciTE
		if (gAtom.Find((int)gDest)){ // another instance exists : use it
			HWND wMiniFilxx=(HWND)::FindWindow((const char *)32770L,gMyName);
			mustrun=false;
			if (macrotorun!=NULL) {
				COPYDATASTRUCT cds;
				cds.dwData = 0;
				cds.lpData = macrotorun;
				cds.cbData = lstrlen(macrotorun);
				::SendMessage(wMiniFilxx ,WM_COPYDATA,(UINT)gDest,(long)&cds);
				delete [] macrotorun;
			} else {
				ShowWindow(wMiniFilxx,SW_SHOWNORMAL);
				SetForegroundWindow(wMiniFilxx);
			}
		}
		gLaunchedfirst=false;
	}

	if (mustrun){
		
		// Save my directory :
		lstrcpy(gMyDirectory,m_pszHelpFilePath);
		char * c=gMyDirectory+lstrlen(gMyDirectory);
		while (*c!='\\' ) c--;
		*(c+1)='\0';

		//GetIniFileName
		lstrcpy(gInipath,gMyDirectory);
		lstrcat(gInipath,"filerx.ini");

		// Creates dialog
		gMaindialog= new CMiniFilxDlg ();
	}
	return TRUE;
}



int CMiniFilxxApp::Run() {
	if (mustrun) {
		gMaindialog->DoModal();
		delete [] gInipath;
		delete [] gMacrobarpath;
		delete [] gMyDirectory;
		delete gMaindialog;
	} else
		::PostQuitMessage(0);
	return 0;

}

/////////////////////////////////////////////////////////////////////////////
//