#include "stdafx.h"
#include "..\inifile.h"
#include "MiniFilxDlg.h"
#include  <io.h>
#include  <errno.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



extern macro * gCurmac;
extern macro * gMacros;
extern char * gMyDirectory;


void CMiniFilxDlg::TextToMacros(char * buf)
{
	char * mbeg=buf;
	char * mend=buf;
	macro * newmacro;

	while (*mend!='\0'){
		
		newmacro=CreateMacro();
		Compile(newmacro,gMacros,mbeg,&mend);

		gCurmac=FindMacroByName(newmacro->name);
		if (gCurmac==NULL) {
			gCurmac=AppendMacroToList(newmacro);
		} else {
			DeleteMacro(newmacro);
			Compile(gCurmac,gMacros,mbeg,&mend);
		}
		mbeg=mend;
	}
}



/////////////////////////////////////////////////////////////////////////////
//  DELETE/FIND/SELECT MACROS



macro * CMiniFilxDlg::FindMacroByName(char * mname){
	macro * m=gMacros;
	const char * smname=LPCTSTR(mname);
	while (m!=NULL){
		if (!strcmp(m->name,smname)) 
			return m;
		m=m->next;
	}
	return NULL;
}

macro * CMiniFilxDlg::FindMacroByShortcut(int shortcut){
	macro * m=gMacros;
	while (m!=NULL){
		if (m->shortcut==shortcut) 
			return m;
		m=m->next;
	}
	return NULL;
}


void CMiniFilxDlg::EnableShortcuts(bool enable){

	macro * m=gMacros;
	int gscut=GetIniShortcutInt("_global_shortcut_");
	globalshortcut=gscut;
	if (gscut!=0) {
		if (enable) {
			RegisterHK(m_hWnd,gscut);
			while (m!=NULL){
				int scut=GetIniShortcutInt(m->name);
				m->shortcut=scut;
				m=m->next;
			}
		} else {
			UnregisterHotKey(m_hWnd,gscut);
		}
		return;
	}

	while (m!=NULL){
		if (enable) {
			int scut=GetIniShortcutInt(m->name);
			m->shortcut=scut;
			RegisterHK(m_hWnd,scut);
		} else {
			UnregisterHotKey(m_hWnd,m->shortcut);
		}
		m=m->next;
	}
}


void CMiniFilxDlg::CheckMacroName(char * nam){	
	char * mmm=strstr(nam,"Macro");
	if (mmm!=NULL) *mmm='m';
	int nlen=lstrlen(nam);
	int xnum=0;
	while (FindMacroByName(nam)!=NULL){
		xnum++;
		sprintf(nam+nlen,"_%u",xnum);
	}
}



macro * CMiniFilxDlg::AppendMacroToList(macro * m,char * name/*=NULL*/){
	char nbuff[100];
	char * nname;
	if (name!=NULL)
		nname=name;
	else
		nname=m->name;
	strncpy(nbuff,nname,96);
	CheckMacroName(nbuff);
	lstrcpy(m->name,nbuff);

	macro *mm=gMacros;
	if (mm!=NULL){
		while (mm->next!=NULL) mm=mm->next;
		m->prev=mm;
		mm->next=m;
	}else
		gMacros=m;

	return m;
}

void CMiniFilxDlg::AddRecordedMacro()
{
	AppendMacroToList(gCurmac,"Recorded");
	DeleteButtons();
	AddButtons();
	haverecorded=true;
}


void CMiniFilxDlg::LoadMacros()
{
	CIniSection * inisec=new CIniSection(SECTION_MACROS);
	while (inisec->GetNextKey()) {
		if (strncmp(inisec->key,"testfile",8)){
			LoadMacroFile(inisec->value);
		}
	}
	delete inisec;
}

void CMiniFilxDlg::LoadMacroFile(char * fname)
{
	FILE *fp = fopen(fname, "rb");
	if (fp) {
		fseek(fp, 0, SEEK_END);
		int len = ftell(fp);
		char *buffer =new char[len+1];
		if (buffer) {
			fseek(fp, 0, SEEK_SET);
			fread(buffer, len, 1, fp);
			*(buffer+len)='\0';
			TextToMacros(buffer);			
		}
		 delete [] buffer;
		fclose(fp);
	}
}

/////////////////////////////////////////////////////////////////////////////
// Save gMacros

void CMiniFilxDlg::SaveMacroFile()
{
	int mlen=0;
	char *words = 0;
	macro * m=NULL;
	Cstr path0=gMyDirectory;
	Cstr path;
	path0+="Recorded_";
	bool filexists=true;
	int index=0;
	while (filexists){
		index++;
		path=path0;
		path+=index;
		path+=".macros";
		if (_access( path.buf, 0 ) == -1) 
			if (errno==ENOENT)
				filexists=false;
	}
	Cstr mess="Save to : ";
	mess+=path;
	if (MessageBox(mess.buf,"Save recorded Macros",MB_YESNO | MB_ICONQUESTION)==IDYES) {
		CStdioFile p;

		p.Open(path.buf,CFile::modeCreate | CFile::modeWrite);
		macro * m=gMacros;
		while (m!=NULL){
			if (!strncmp(m->name,"Recorded",8)) {
				words=0;
				mlen=0;
				words = Decompile(m,gMacros);
				if (words) {
					p.WriteString(words);
					delete[]words;
					p.WriteString("\r\n");
				}					
			}
			m=m->next;
		}
		p.Close();
	}
}

