// utils.cpp 

#include "stdafx.h"
#include "inifile.h"

extern int folderIcon;
extern int ofolderIcon;



///////////////////////////////////////////////////////////////////////////////////////
// Very limited String class ...



Cstr::Cstr(int n/*=0*/)
{
	blen=n+1;
	buf=new char[blen];
	*buf='\0';
	len=0;
}

Cstr::Cstr(const char * s)
{
	len=lstrlen(s);
	blen=len+1;
	buf=new char[blen];
	lstrcpy(buf,s);
}

Cstr::Cstr(const char * s1,const char * s2,int len1,int len2)
{
	len=len1+len2;
	blen=len+1;
	buf=new char[blen];
	lstrcpy(buf,s1);
	lstrcpy(buf+len1,s2);
}

Cstr::Cstr(const char * s1,int len1)
{
	len=len1;
	blen=len1+1;
	buf=new char[blen];
	char * ss=buf;
	int cnt=len1;
	while(cnt!=0 && *s1!='\0') {
		*ss++=*s1++;
		cnt--;
	}
	*ss='\0';
}
Cstr::Cstr(const Cstr & rS)
{
	len=rS.len;
	blen=len+1;
	buf=new char[blen];
	lstrcpy(buf,rS.buf);
}

Cstr::~Cstr()
{
	delete [] buf;
}

void Cstr::addtoend(const char * s,int xtended)
{
	int l=lstrlen(s);
	int xlen=len+xtended;
	if (l+xlen+1>blen) resize(l+xlen+1,true);
	lstrcpy(buf+xlen,s);
	len=xlen+l;
}


void Cstr::affect(const char * s)
{
	len=lstrlen(s);
	if (len+1>blen) resize(len+1,false);
	char * ss=(char *)s;
	char * dd=buf;
	while(*ss!='\0') *dd++=*ss++;
	*dd='\0';
}

void Cstr::resize(int n,bool withcopy/*=true*/)
{
	if (n<blen) return;
	char * bbuf=new char[n+1];
	if (withcopy) memcpy(bbuf,buf,blen);
	delete [] buf;
	buf=bbuf;
	blen=n+1;
}



Cstr & Cstr::operator=(const char * s)
{
	affect(s);
	return *this;
}
Cstr & Cstr::operator=(const Cstr& rS)
{
	affect(rS.buf);
	return *this;
}
Cstr & Cstr::operator=(const int num)
{	
	char numbuf[14];
	itoa(num,numbuf,10);
	affect(numbuf);
	return *this;
}

Cstr Cstr::operator+(const Cstr& rS)
{
	return Cstr(buf,rS.buf,len,rS.len);
}

Cstr Cstr::operator+(const char * s)
{
	return Cstr(buf,s,len,lstrlen(s));
}


Cstr & Cstr::operator+=(const char * s)
{	
	addtoend(s);
	return *this;
}

Cstr & Cstr::operator+=(const Cstr& rS)
{	
	addtoend(rS.buf);
	return *this;
}

Cstr & Cstr::operator+=(const int num)
{	
	char numbuf[14];
	itoa(num,numbuf,10);
	addtoend(numbuf);
	return *this;
}

Cstr Cstr::rightleft(int nn,bool isright)
{
	int n=(nn<0 ? 0 : nn);
	if (n>len) n=len;
	return Cstr((isright ? buf+(len-n) : buf) , n);
}

void Cstr::trim()
{
	if (len==0) return;
	char * c=buf+(len-1);
	while((*c==' ' || *c=='\t' || *c=='\n') && c>=buf) {c--;len--;}
	*(c+1)='\0';
	c=buf;
	if (*c=='\0') return;
	char * cc=buf;
	while(*c==' ' || *c=='\t' || *c=='\n') {c++;len--;}
	if (c!=buf) {
		while(*c!='\0') *cc++=*c++;
		*cc='\0';
	}
}

void Cstr::SlashAppend(const char * s)
{
	int toadd=CalcSlashLen(s);
	if (len+toadd+1>blen) resize(len+toadd);
	SlashCopy(buf+len,s);
	len=len+toadd;
}


/////////////////////////////////////////////////////////////////////////////////
// Keyboard shortcuts ...


void RegisterHK(HWND h,int scut)
{
	int i=HIWORD(scut);
	int j=0;
	if ((i & 1)==1) j+=4;
	if ((i & 2)==2) j+=2;
	if ((i & 4)==4) j+=1;
	if ((i & 8)==8) j+=8;

	RegisterHotKey(h,scut,j,LOWORD(scut));	
}


int GetScanCode(WORD wVirtualKey, WORD modifier)
{
	return (MapVirtualKey(wVirtualKey, 0) << 16) + ((modifier & 8) << 21);
}

char * GetKName(WORD wVirtualKey,WORD modifier)
{
	static Cstr sKname(256);
	int lk=GetKeyNameText(GetScanCode(wVirtualKey,modifier), sKname.buf, 255);
	sKname.len=lk;
	return sKname.buf;
}


char * GetMName(WORD modifier)
{
	static Cstr sModif(20);
	sModif="";
	if (modifier==0) {
		sModif="no modifier ...";
	} else {
		if ((modifier & 2)==2)
			sModif="Ctrl";
		if ((modifier & 1)==1)
			sModif+=" + Shift";
		if ((modifier & 4)==4)
			sModif+=" + Alt";
	}
	char * rets=sModif.buf;
	if (*rets==' ') rets+=3;
	return rets;
}


/////////////////////////////////////////////////////////////////////////
// Slashing / Unslashing

/**
 * Is the character an octal digit.
 */
static bool IsOctalDigit(char ch) {
	return ch >= '0' && ch <= '7';
}


static char slashed[]="abfnrtv\\";
static char unslashed[]="\a\b\f\n\r\t\v\\";
 
/**
 * Convert C style \nnn, \r, \n, \t into their indicated characters
 */
void UnSlash(char *s) {
    char *o = s;
    while (*s) {
        if (*s == '\\') {
            s++;
			char * slashedpos=strchr(slashed,(int)*s);
			if (*slashedpos!=NULL) {
				*o=unslashed[slashedpos-slashed];
            } else if (IsOctalDigit(*s)) {
                int val = *s - '0';
                if (IsOctalDigit(*(s+1))) {
                    s++;
                    val *= 8;
                    val += *s - '0';
                    if (IsOctalDigit(*(s+1))) {
                        s++;
                        val *= 8;
                        val += *s - '0';
                    }
				}
                *o = val;
			} else {
              *o = *s;
            }
        } else {
              *o = *s;
        }
        o++;
        if (*s)
             s++;
    }
    *o = '\0';
}


int CalcSlashLen(const char * src){
	char * s=(char *)src;
	int slashedlen=0;
	while(*s){
		if (strchr(unslashed,*s))
			slashedlen++;
		slashedlen++;
		s++;
	}
	return slashedlen;
}


void SlashCopy(char * dest,const char * src){
	char * s=(char *)src;
	char * d=dest;
	while(*s){
		char * unslashedpos=strchr(unslashed,(int)*s);
		if (unslashedpos!=NULL) {
			*d++='\\';
			*d++=slashed[unslashedpos-unslashed];
		} else
			*d++=*s;
		s++;
	}
	*d='\0';
}

HICON FlxLoadIcon(int id)
{
	return (HICON)LoadImage(GetModuleHandle(NULL), MAKEINTRESOURCE(id),IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR | LR_SHARED);
}


//////////////////////////////////////////////////////////////////////////////////////
//								UNUSED IN MINIFILX
//////////////////////////////////////////////////////////////////////////////////////

#ifndef _MINI

bool IsSuffix(const char * fname,const char * suffix)
{
	int ll=lstrlen(suffix);
	int fl=lstrlen(fname);
	if (fl>ll) {
		if (!lstrcmpi(fname+(fl-ll),suffix)) 
			return true;
	}
		return false;
}


bool IsMacros(const char * fname)
{
	return IsSuffix(fname,".macros");
}
bool IsLua(const char * fname)
{
	return IsSuffix(fname,".lua");
}

bool IsIcon(const char * fname)
{
	return IsSuffix(fname,".ico");
}

bool IsProject(const char * fname)
{
	return IsSuffix(fname,".project");
}

bool IsDSP(const char * fname)
{
	return IsSuffix(fname,".dsp");
}

static char * tlbsuffixes= ".ocx .oca .tlb .olb .dll .exe";

bool IsTypeLib(const char * fname) {
	int fl=lstrlen(fname);
	if (fl>4){
		char * buf4=new char[5];
		lstrcpy((char *) buf4,fname+(fl-4));
		CharLower(buf4);
		if (strstr(tlbsuffixes,buf4)!=NULL) 
			return true;
	}
	return false;
}

char * GetKeyName(WORD wVirtualKey,WORD modifier)
{
	static Cstr sKname(256);
	sKname="";
	if (GetScanCode(wVirtualKey,modifier) != 0) {
		if ((modifier & 7)!=0) {
			sKname=GetMName(modifier & 7);
			sKname+=" + ";
		}
		sKname+=GetKName(wVirtualKey,modifier);
	}
	return sKname.buf;
}


void ReadTextFile(const char * name,Cstr * text)
{
	HANDLE hFile = CreateFile(name,         
				GENERIC_READ,              // open for reading 
				FILE_SHARE_READ,           // share for reading 
				NULL,                      // no security 
				OPEN_EXISTING,             // existing file only 
				FILE_ATTRIBUTE_NORMAL,     // normal file 
				NULL);                     // no attr. template 
	if (hFile != INVALID_HANDLE_VALUE) {
		ULONG tlen=GetFileSize(hFile,NULL);
		text->resize(tlen);
		ULONG rlen;
		ReadFile(hFile,text->buf,tlen,&rlen,NULL);
		if (rlen<tlen && rlen>=0)
			tlen=rlen;
		*(text->buf+tlen)='\0'; 
		text->len=tlen;
		CloseHandle(hFile);
	}
}


/////////////////////////////////////////////////////////////////////////////
// To handle system Image List


CImgList::CImgList()
{
	SHFILEINFO info;
	ZeroMemory(&info,sizeof(info));
	LPITEMIDLIST itemlist = 0;
	SHGetSpecialFolderLocation(0, CSIDL_DESKTOP , &itemlist);
	m_hImageList = (HIMAGELIST)SHGetFileInfo((LPCTSTR)itemlist, 0, &info, sizeof(info), SHGFI_PIDL | SHGFI_SYSICONINDEX | SHGFI_SMALLICON);
	// Get Folder icons used here and there ...
	if (SHGetFileInfo("x",FILE_ATTRIBUTE_DIRECTORY,&info,sizeof(info),SHGFI_USEFILEATTRIBUTES | SHGFI_ICON |SHGFI_SMALLICON | SHGFI_SYSICONINDEX))
		folderIcon=info.iIcon;
	if (SHGetFileInfo("x",FILE_ATTRIBUTE_DIRECTORY,&info,sizeof(info),SHGFI_USEFILEATTRIBUTES | SHGFI_ICON |SHGFI_SMALLICON | SHGFI_OPENICON | SHGFI_SYSICONINDEX))
		ofolderIcon=info.iIcon;
}

void CImgList::RemoveImages()
{
	for (int i=1;i<=3;i++)
		Remove(addedicons[i]);

}

int CImgList::AddImage(HICON h,int num)
{
	addedicons[num]=Add(h);
	return addedicons[num];
}

/////////////////////////////////////////////////////////////////////////

int wctmb(BSTR bstr,char * buf,int size)
{
	return WideCharToMultiByte (CP_OEMCP, NULL, bstr, -1,buf, size, NULL, NULL);
}

Cstr  * BSTRtoCStr(BSTR bstr,bool free/*=true*/)
{
	static Cstr sStr("");
	if (bstr) {
		int size = wctmb(bstr,NULL,0);
		sStr.resize(size);
		wctmb(bstr,sStr.buf,size);
		sStr.len=size-1;
		if (free) ::SysFreeString(bstr);
	}
	return &sStr;
}

char *  BSTRtoChar(BSTR bstr,bool free/*=true*/)
{
	return BSTRtoCStr(bstr,free)->buf;
}


///////////////////////////////////////////////////////////////////////////////////////
// Prompt user for delete/save ...

bool UserAccepts(int todo,char * name)
{
	char  title[100];
	char  message[100];
	char  completemessage[100+MAX_PATH];
	char wantto[]="Do you want to ";
	int lwant=lstrlen(wantto);
	int title_id=IDS_SAVE;
	int condition=GetIniWorkInt("askbeforedelete",0);
	
	lstrcpy(message,wantto);
	LoadString(AfxGetResourceHandle(),todo,message+lwant,99-lwant);

	if (todo==IDS_SAVE_PROJECT || todo==IDS_SAVE_MACROS){
		if (*name=='\0'){
			MessageBox(NULL,"Give a name for this file, please.","No name ...",MB_OK);
			return false;
		}
	}

	if (*name!='\0') CharLower(name);
	switch (todo) {
		case IDS_SAVE_PROJECT :
			if (!IsProject(name)) lstrcat(name,".project");
			condition=GetIniWorkInt("askifsaveproject",0);
			break;
		case IDS_SAVE_MACROS :
			if (!IsMacros(name)) lstrcat(name,".macros");
			condition=GetIniWorkInt("askifsavemacros",0);
			break;
		case IDS_IFERASE_FOLDER :
			title_id=IDS_DELFOLDER;
			break;
		case IDS_IFCLOSE_PROJECT :
			title_id=IDS_DELPROJ;
			break;
		case IDS_IFERASE_MACRO :
			title_id=IDS_DELFOLDER;
			break;
		case IDS_IFCLOSE_MACROFILE :
			title_id=IDS_DELMACROFILE;
			break;
	}

	sprintf(completemessage,message,name);
	LoadString(AfxGetResourceHandle(),title_id,title,99);
	return ((condition==0) || MessageBox(NULL,completemessage,title,MB_YESNO | MB_ICONQUESTION)==IDYES);
}



#endif //ndef _MINI


