// filerx.h : Declares the class interfaces for the polsee application.
//
#if !defined(AFX_UTILS_H__INCLUDED_)
#define AFX_UTILS_H__INCLUDED_




class Cstr
{
public:
	Cstr(int n=0);
	Cstr(const Cstr & s);
	Cstr(const char * s);
	Cstr(const char * s1,const char * s2,int len1,int len2);
	Cstr(const char * s1,int len1);
	~Cstr();
	void resize(int n,bool withcopy=true);
	void addtoend(const char * s,int xtended=0);
	Cstr left(int n) {return rightleft(n,0);};
	Cstr right(int n){return rightleft(n,1);};
	Cstr mid(int n){return rightleft(len-n,1);};
	void trim();
	void SlashAppend(const char * s);
	char operator[](int n) { if(n>=0 && n<len) return buf[n];else return 0;}
	Cstr & operator=(const char * s);
	Cstr & operator=(const Cstr& s);
	Cstr & operator=(const int num);
	Cstr operator+(const Cstr& s);
	Cstr operator+(const char * s);
	Cstr & operator+=(const Cstr& s);
	Cstr & operator+=(const char * s);
	Cstr & operator+=(const int num);
	bool operator==(const char * s) {return(!lstrcmp(buf,s));};
	bool operator!=(const char * s) {return(0==lstrcmp(buf,s));};
	bool operator==(const Cstr& s) {return(!lstrcmp(buf,s.buf));};
	bool operator!=(const Cstr& s) {return(0==lstrcmp(buf,s.buf));};

	char * buf;
	int len;
private:
	void affect(const char * s);
	Cstr rightleft(int nn,bool isright);
	int blen;
};


#ifndef _MINI
class CImgList : public CImageList
{
public:
	CImgList();
	int addedicons[4];
	void RemoveImages();
	int AddImage(HICON h,int num);
};

	bool IsProject(const char * fname);		//is selected file .project ?
	bool IsDSP(const char * fname);			//is selected file .dsp project ?
	bool IsMacros(const char * fname);
	bool IsLua(const char * fname);
	bool IsIcon(const char * fname);
	bool IsTypeLib(const char * fname);
	char * GetKeyName(WORD wVirtualKey,WORD modifier);
	void ReadTextFile(const char * name,Cstr * text);

	Cstr  * BSTRtoCStr(BSTR bstr,bool free=true);
	char *  BSTRtoChar(BSTR bstr,bool free=true);

	bool UserAccepts(int todo,char * name);

#endif

	void RegisterHK(HWND h,int scut);
	char * GetKName(WORD wVirtualKey,WORD modifier);
	char * GetMName(WORD modifier);
	
	void UnSlash(char *s);
	void SlashCopy(char * dest,const char * src);
	int CalcSlashLen(const char * src);
	HICON FlxLoadIcon(int id);

class CAtom
{
public:
	CAtom(char * name) 
	{ 
		haveatom=false;
		appname=name;
	};
	~CAtom(){};

	bool haveatom;
	char mbuff[40];
	ATOM myatom;
	char * appname;
	
	void buildstring(unsigned int d) 
	{
		sprintf(mbuff,"%u%s",d,appname);
	};
	void Add(unsigned int dest) 
	{
		if (!haveatom) {
			buildstring((unsigned int) dest);
			myatom=GlobalAddAtom(mbuff);
			haveatom=true;
		}
	};
	void Delete()
	{
		if (haveatom) GlobalDeleteAtom(myatom);
		haveatom=false;
	};
	bool Find(unsigned int dest)
	{
		buildstring((unsigned int) dest);
		return (GlobalFindAtom(mbuff)!=0);
	};
};
#endif // !defined(AFX_UTILS_H__INCLUDED_)
